// problémy:
// - nefunguje UTF8 (kvůli SplitScreen.htm, kde je Windows-1250)
// - to znamená, že je zmršená všechna diakritika a taky třeba znak ° atd.
// - fixed: mapycz_coords.js nefunguje znak σ (nahrazen 'sigma')
// - fixed: je třeba nahradit vars.js z command line
// - fixed: v tomto souboru je třeba mít "saved from url" nastaveno na localhost, ne na internet
// - provedené opravy názvů map fungují jen ve Windows-1250 (které je platné jen pro středoevropské jazyky)
// - znak ° byl v různých .js souborech nahrazen \u00B0
// - nenačte se v 2 column verzi, pokud je smap.js neminimalizovaný

window.basePath = "../Macros/HTML_Keskomapa/";
window.varsSet = true;  // říká, že vars.js nastavujeme zde a netřeba loadovat vars.js

// defaultní hodnoty z vars.js
var isGSAK = true;
var gsakOnlyOneCache = true;
var language = 'English';
var wp = {};

// dekódování kešek z URL
var params = (location.search + "").split("&");
var cachename = "";
var last_stage_code = 0;

var windows_1250 = 
[
  /*00-0F*/ "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
  /*10-1F*/ "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
  /*20-2F*/ " ", "!", '"', "#", "$", "% ", "&", "'", "(", ")", "*", "+", ",", "-", ".", "/",  // % could break decoding, so put space after it
  /*30-3F*/ "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ":", ";", "<", "=", ">", "?",
  /*40-4F*/ "@", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O",
  /*50-5F*/ "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "[", "\\", "]", "^", "_",
  /*60-6F*/ "`", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o",
  /*70-7F*/ "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "{", "|", "}", "~", "␡",
  /*80-8F*/ "€", "�", "‚", "�", "„", "…", "†", "‡", "�", "‰", "Š", "‹", "Ś", "Ť", "Ž", "Ź",
  /*90-9F*/ "�", "‘", "’", "“", "”", "•", "–", "—", "�", "™", "š", "›", "ś", "ť", "ž", "ź",
  /*A0-AF*/ "•", "ˇ", "˘", "Ł", "¤", "Ą", "¦", "§", "¨", "©", "Ş", "«", "¬", "–", "®", "Ż",
  /*B0-BF*/ "°", "±", "˛", "ł", "´", "µ", "¶", "·", "¸", "ą", "ş", "»", "Ľ", "˝", "ľ", "ż",
  /*C0-CF*/ "Ŕ", "Á", "Â", "Ă", "Ä", "Ĺ", "Ć", "Ç", "Č", "É", "Ę", "Ë", "Ě", "Í", "Î", "Ď",
  /*D0-DF*/ "Đ", "Ń", "Ň", "Ó", "Ô", "Ő", "Ö", "×", "Ř", "Ů", "Ú", "Ű", "Ü", "Ý", "Ţ", "ß",
  /*E0-EF*/ "ŕ", "á", "â", "ă", "ä", "ĺ", "ć", "ç", "č", "é", "ę", "ë", "ě", "í", "î", "ď",
  /*F0-FF*/ "đ", "ń", "ň", "ó", "ô", "ő", "ö", "÷", "ř", "ů", "ú", "ű", "ü", "ý", "ţ", "˙"
];

var decode_windows_1250 = function(str)
{
  var regexp = /\%[0-9A-F]{2}/g;    // %E1 apod.
  var matches;
  
  while ((matches = str.match(regexp)))
  {
    var num = parseInt(matches[0].replace("%", ""), 16);  // převedení např. %20 na 32 (což je 0x20)
    str = str.replace(matches[0], windows_1250[num]);     // nahrazení řetězce (např. %20) odpovídajícím prvkem v tabulce
  }
  
  return str;
}

// parsování url parametrů (a naplnění wp[])
for (var i = 0; i < params.length; i++)
{
  var param = params[i].split("=");
  var p = param[0], val = param[1];

  // dekódujeme hodnotu (nahrazení %20 mezerou atd.)
  if (isString(val))
  {
    // převod z Windows-1250
    val = decode_windows_1250(val);
    
    // dekódování toho co zbylo
    try { val = decodeURIComponent(val); } catch(ex) {};  /* stringy s diakritikou mohou vyhodit chybu kvůli nekompatibilitě s UTF-8 :( */
  }
  
  switch(p)
  {
    case "nam":
      last_cachename = val;
      break;    

    case "cod":
      wp[val] = {};
      window.cachecode = val;
      wp[val].Name = last_cachename;
      wp[val].ShortDescription = "";
      wp[val].LongDescription = "";
      wp[val].Url = (val.match(/^(GC|WM)/)) ? ("http://coords.info/" + val) : "";
      wp[val].HasCorrected = 0;
      wp[val].UserFlag = 0;
      wp[val].Status = "A";
      wp[val].Status2 = "A";
      wp[val].Guid = "";
      wp[val].OwnerName = "";
      wp[val].PlacedDate = "";
      break;

    case "typ": 
      wp[cachecode].CacheType = val;
      break;

    case "lat": 
      wp[cachecode].Latitude = val;
      window.refLat = val;
      break;
      
    case "long":
      wp[cachecode].Longitude = val;
      window.refLon = val;
      break;

    case "dif":
      val = (val.length == 1) ? (val + ".0") : val.replace("_", "."); // 1 -> 1.0, 1_5 -> 1.5
      wp[cachecode].Difficulty = val;
      break;

    case "ter":
      val = (val.length == 1) ? (val + ".0") : val.replace("_", "."); 
      wp[cachecode].Terrain = val;
      break;

    case "con": 
      wp[cachecode].Container = val;
      break;
      
    case "namc[]":
      last_stage_code++;
      wp[last_stage_code] = {}; 
      wp[last_stage_code].Name = val;
      wp[last_stage_code].Parent = cachecode;
      wp[last_stage_code].Comment = "";
      wp[last_stage_code].Url = "";
      wp[last_stage_code].UserFlag = 0;
      break;
      
    case "latc[]":
      wp[last_stage_code].Latitude = val;
      break;
      
    case "lonc[]":
      wp[last_stage_code].Longitude = val;
      break;
      
    case "typc[]":
      wp[last_stage_code].CacheType = {Q: "VirtualStage", S: "PhysicalStage", R: "ReferencePoint", F: "FinalLocation", T: "Trailhead", P: "ParkingArea"}[val];
      break;
      
    case "ver":       // val = 008005001031
    case "mrk":       // val = 0
    case "hash":      // val = 
    case "units":     // val = k
    case "size":      // val = s (pokud máme mapu přes celé okno, tak není size poslána)
    default: break;                
  }
}
// funkce pro opravení názvů map (převod z Windows-1250 do UTF-8)
var fixUTF8Diacritics = function(str)
{
  if (!isString(str))
    return str;
    
  var conversions =  /* někdy je třeba přijít jak toto přesně souvisí s Windows1250 */
  [
    ["Ăˇ","á"], ["Ă©","é"], ["Ä›","ě"], ["Ă­","í"], ["Ĺ™","ř"], ["Ĺˇ","š"], ["Ăş","ú"], ["ĂĽ","ü"], ["Ă˝","ý"], ["Ĺľ","ž"],
    ["ÄŚ","Č"], ["Ăš","Ú"], ["Ĺ˝","Ž"], ["â€“","-"], ["Â°","°"]
  ];

  conversions.forEach(function(c)
  {
    str = str.replace(new RegExp(c[0],"g"), c[1]);
  });
  
  return str;
}

// voláno po načtení map z load.js
window.fixMapNamesDiacritics = function()
{
  // v GSAKu (IE11):
  //alert(document.inputEncoding);  // UTF-8
  //alert(document.characterSet);   // utf-8
  //alert(document.charset);        // utf-8
  //alert(document.defaultCharset); // windows-1250
 
  for (var c in SMap.CONFIG)
  {
    SMap.CONFIG[c].title = fixUTF8Diacritics(SMap.CONFIG[c].title);
    SMap.CONFIG[c].label = fixUTF8Diacritics(SMap.CONFIG[c].label);
    
    if (SMap.CONFIG[c].copyright)
    {
      var str = JSON.stringify(SMap.CONFIG[c].copyright);
      SMap.CONFIG[c].copyright = JSON.parse(fixUTF8Diacritics(str));
    }
  }
}