# 22.5.2013 byla verze 129
# 5.7.2014 byla verze 152
# 19.5.2015 je verze 172 (poslední funkční pro ČR je 146, pro celý svět 170)

use strict;
use warnings;
use utf8;
use LWP::Simple qw($ua get);
use File::Slurp qw(read_file write_file);

my $satRegexJS = qr|googleapis\.com/kh\?v=(\d+)|;
my $satRegexMy = qr|google\.com/kh/v=(\d+)|;

my $filename = "other_maps.js";

# get version from server
my $js = download('http://maps.googleapis.com/maps/api/js');
(my $satVerJS) = $js =~ $satRegexJS;

# get our version
my $myjs = read_file($filename, {binmode => ':utf8'});
my $myjs_mod = $myjs;

(my $satVerMy) = $myjs =~ $satRegexMy;

# compare and possibly replace
if ($satVerJS != $satVerMy)
{
  print "Changed satellite: $satVerMy --> $satVerJS\n";
  $myjs_mod =~ s|$satRegexMy|google.com/kh/v=$satVerJS|;
}

if ($myjs ne $myjs_mod)
{
  unlink "$filename.bak";
  rename $filename, "$filename.bak";
  write_file($filename, {binmode => ':utf8'}, $myjs_mod);
}
else
{
  print "Nothing changed!\n";
}

sleep(2); # aby dosové okno hned nezmizelo

################################################################################

# read_file (filename)
sub download
{
  my $url = shift;
  $ua->agent('Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/42.0.2311.15 Safari/537.36');
  my $data = get($url) || die "Couldn't download JS file!";
  return $data;
}