Cache = JAK.ClassMaker.makeClass(
{
	NAME: "Cache",
	VERSION: "1.0"
});

//--------------------------------------------------------
//                    Cache Types
//--------------------------------------------------------

Cache.TRADITIONAL = 1;
Cache.MULTI = 2;
Cache.MYSTERY = 3;
Cache.LETTERBOX = 4;
Cache.EARTHCACHE = 5;
Cache.WHERIGO = 6;
Cache.WAYMARK = 7;
Cache.WEBCAM = 8;
Cache.VIRTUAL = 9;
Cache.EVENT = 10;
Cache.MEGAEVENT = 11;
Cache.CITO = 12;
Cache.LOCATIONLESS = 13;
Cache.OTHER = 14;
Cache.PROJECT_APE = 15;
Cache.BENCHMARK = 16;
Cache.MAZE_EXHIBIT = 17;
Cache.LF_EVENT = 18;
Cache.GROUNDSPEAK_HQ = 19;
Cache.LF_CELEBRATION = 20;
Cache.BLOCK_PARTY = 21;
Cache.GIGA_EVENT = 22;
Cache.LAB_CACHE = 23;

// název pro tisk
Cache.format = {};
Cache.format[Cache.TRADITIONAL] =     "Traditional Cache";
Cache.format[Cache.MULTI] =           "Multi Cache";
Cache.format[Cache.MYSTERY] =         "Mystery Cache";
Cache.format[Cache.LETTERBOX] =       "Letterbox";
Cache.format[Cache.EARTHCACHE] =      "Earthcache";
Cache.format[Cache.WHERIGO] =         "Wherigo";
Cache.format[Cache.WAYMARK] =         "Waymark";
Cache.format[Cache.WEBCAM] =          "Webcam";
Cache.format[Cache.VIRTUAL] =         "Virtual Cache";
Cache.format[Cache.EVENT] =           "Event";
Cache.format[Cache.MEGAEVENT] =       "Mega Event";
Cache.format[Cache.CITO] =            "CITO";
Cache.format[Cache.LOCATIONLESS] =    "Locationless (Reverse) Cache";
Cache.format[Cache.OTHER] =           "Other";
Cache.format[Cache.PROJECT_APE] =     "Project Ape";
Cache.format[Cache.BENCHMARK] =       "BenchMark";
Cache.format[Cache.MAZE_EXHIBIT] =    "Maze Exhibit";
Cache.format[Cache.LF_EVENT] =        "L&F Event";
Cache.format[Cache.GROUNDSPEAK_HQ] =  "Groundspeak HQ";
Cache.format[Cache.LF_CELEBRATION] =  "L&F Celebration";
Cache.format[Cache.BLOCK_PARTY] =     "Block Party";
Cache.format[Cache.GIGA_EVENT] =      "Giga Event";
Cache.format[Cache.LAB_CACHE] =       "Lab Cache";

// název souboru s ikonkou
Cache.css = {};
Cache.css[Cache.TRADITIONAL] =    "T";
Cache.css[Cache.MULTI] =          "M";
Cache.css[Cache.MYSTERY] =        "U";
Cache.css[Cache.LETTERBOX] =      "B";
Cache.css[Cache.EARTHCACHE] =     "R";
Cache.css[Cache.WHERIGO] =        "I";
Cache.css[Cache.WAYMARK] =        "Y";
Cache.css[Cache.WEBCAM] =         "W";
Cache.css[Cache.VIRTUAL] =        "V";
Cache.css[Cache.EVENT] =          "E";
Cache.css[Cache.MEGAEVENT] =      "Z";
Cache.css[Cache.CITO] =           "C";
Cache.css[Cache.LOCATIONLESS] =   "L";
Cache.css[Cache.OTHER] =          "O";
Cache.css[Cache.PROJECT_APE] =    "A";
Cache.css[Cache.BENCHMARK] =      "G";
Cache.css[Cache.MAZE_EXHIBIT] =   "X";
Cache.css[Cache.LF_EVENT] =       "F";
Cache.css[Cache.GROUNDSPEAK_HQ] = "H";
Cache.css[Cache.LF_CELEBRATION] = "D";
Cache.css[Cache.BLOCK_PARTY] =    "P";
Cache.css[Cache.GIGA_EVENT] =     "J";
Cache.css[Cache.LAB_CACHE] =      "Q";

// v případě přidání typu cache je třeba upravit ještě caches.css a sidebar.js

//--------------------------------------------------------
//                  Cache Child Types
//--------------------------------------------------------

Cache.VIRTUAL_STAGE = 40;
Cache.PHYSICAL_STAGE = 41;
Cache.REFERENCE_POINT = 42;
Cache.FINAL_LOCATION = 43;
Cache.TRAILHEAD = 44;
Cache.PARKING_AREA = 45;
Cache.CORRECTED = 46;

// název pro tisk
Cache.format[Cache.VIRTUAL_STAGE] =   "Virtual Stage";
Cache.format[Cache.PHYSICAL_STAGE] =  "Physical Stage";
Cache.format[Cache.REFERENCE_POINT] = "Reference Point";
Cache.format[Cache.FINAL_LOCATION] =  "Final Location";
Cache.format[Cache.TRAILHEAD] =       "Trailhead";
Cache.format[Cache.PARKING_AREA] =    "Parking Area";
Cache.format[Cache.CORRECTED] =       "Corrected";

// název souboru s ikonkou
Cache.css[Cache.VIRTUAL_STAGE] =      "VirtualStage";
Cache.css[Cache.PHYSICAL_STAGE] =     "PhysicalStage";
Cache.css[Cache.REFERENCE_POINT] =    "ReferencePoint";
Cache.css[Cache.FINAL_LOCATION] =     "FinalLocation";
Cache.css[Cache.TRAILHEAD] =          "Trailhead";
Cache.css[Cache.PARKING_AREA] =       "ParkingArea";
Cache.css[Cache.CORRECTED] =          "Corrected";

// převod z wp[] názvu do konstanty
Cache.strToConstant = {};

for (var i in Cache.css)
  Cache.strToConstant[Cache.css[i]] = i;

// změny názvů waypointů 2014 - oprava pokud mame starsi verzi GSAKu  
Cache.strToConstant["QuestiontoAnswer"] =    Cache.VIRTUAL_STAGE;  
Cache.strToConstant["StagesofaMulticache"] = Cache.PHYSICAL_STAGE; 

//--------------------------------------------------------
//                    Containers
//--------------------------------------------------------  

Cache.MICRO = 60;
Cache.SMALL = 61;
Cache.REGULAR = 62;
Cache.LARGE = 63;
Cache.NOT_CHOSEN = 64;
Cache.OTHER_SIZE = 64;

// název pro tisk
Cache.format[Cache.MICRO] =         "Micro";
Cache.format[Cache.SMALL] =         "Small";
Cache.format[Cache.REGULAR] =       "Regular";
Cache.format[Cache.LARGE] =         "Large";
Cache.format[Cache.NOT_CHOSEN] =    "Not Chosen";
Cache.format[Cache.OTHER_SIZE] =    "Other";
Cache.format[Cache.SIZE_VIRTUAL] =  "Virtual";

// převod z wp[] názvu do konstanty
for (var i in Cache.format)
{
  if (i >= 60 && i < 70)
    Cache.strToConstant[Cache.format[i] + "_"] = i;      // _ je kvůli konfliktu s other u cachí
}

//--------------------------------------------------------
//       State (Active, Disabled, Archived, Owned)
//--------------------------------------------------------  

Cache.ACTIVE = 80;
Cache.DISABLED = 81;
Cache.ARCHIVED = 82;
Cache.FOUND = 83
Cache.OWNED = 84;

// převod z wp[] názvu do konstanty
// _ je na konci kvůli konfliktu se stejnými zkratkami cache typů
Cache.strToConstant["A_"] = Cache.ACTIVE;
Cache.strToConstant["T_"] = Cache.DISABLED;
Cache.strToConstant["X_"] = Cache.ARCHIVED;
Cache.strToConstant["F_"] = Cache.FOUND;
Cache.strToConstant["O_"] = Cache.OWNED;

// zkratka pro CSS
// Cache.format[Cache.ACTIVE] =   "A";
// Cache.format[Cache.DISABLED] = "T";
// Cache.format[Cache.ARCHIVED] = "X";
// Cache.format[Cache.FOUND] =    "F";
// Cache.format[Cache.OWNED] =    "O";

Cache.css[Cache.ACTIVE] =    "statusActive";
Cache.css[Cache.DISABLED] =  "statusDisabled";
Cache.css[Cache.ARCHIVED] =  "statusArchived";
Cache.css[Cache.FOUND] =     "isFound";
Cache.css[Cache.OWNED] =     "isOwned";

//--------------------------------------------------------
//                      speciální
//--------------------------------------------------------  

Cache.NOT_FOUND = 90;
Cache.SPECIAL_PRIVATE = 91;
Cache.SPECIAL_NON_FINALS = 92;

Cache.css[Cache.NOT_FOUND]              = "isNotFound";
Cache.css[Cache.SPECIAL_PRIVATE]        = "isSpecialPrivatToHide";
Cache.css[Cache.SPECIAL_NON_FINALS]     = "isSpecialNonFinal";

//--------------------------------------------------------
//-------------------------------------------------------- 


Cache.defaultCoords = new SMap.Coords.fromWGS(50, 15);

Cache.idGenerator = function()
{
	this._idCnt = (this._idCnt || 0) + 1;
	return this._idCnt;
}

Cache.prototype.$constructor = function(options)
{
	this._ec = [];
	this._sc = [];

  this.parent = null;
  this.children = [];
  
  this.hasCorrected = false;          // má corrected souřadnice (tedy rodič jsou opravené souřadnice, původní jsou v CC waypointu)
  this.hasFinalLocation = false;      // zda má keška finálku

  this.mouseoverCache = false;        // zda je myš nad současnou keškou
  this.mouseoverFamily = false;       // zda je myš nad libovolným členem rodiny
  
  this.isSelected = false;            // zda je keš aktuálně označena pomocí myši (SMap.Control.Selection)
  this.isHidden = false;              // zda je skrytá (pomocí X)
  
  this.marker = null;
  this.card = null;
  this.bubble = null;
  this.simpleBubble = null;

  this.parseOptions(options);
  
  this.coordsOriginal = this.coords; // backup pro případ tažení
  
  this._mouseoverHandler = null;
  this._markerInitialized = false;
  
  // terrain a difficulty převedeme na číslo
  this.terrain = parseFloat(this.terrain);
  this.difficulty = parseFloat(this.difficulty);
}



Cache.prototype.$destructor = function(options)
{
  JAK.Events.removeListeners(this._ec);

  // odvěšíme handler pro mouseover  
  if (this._mouseoverHandler && this.marker && this.marker.getMap())
  {
    this.marker.getMap().getSignals().removeListener(this._mouseoverHandler);
  }

  if (this.marker)
    this.marker.$destructor();
    
  //if (this.card)                  // tohle vyhodí chybu :(
  //  this.card.$destructor();
    
  if (this.bubble)
    this.bubble.$destructor();
    
  if (this.simpleBubble)
    this.simpleBubble.$destructor();

  // pokud jsme dítě, tak updatujeme pole dětí u rodiče (vymažeme sebe)
  if (this.parent)
  {
    this.getParent().children = this.getChildren().filter(function(child)
    {
      return (child !== this)
    }.bind(this));
  }
  
  // pokud jsme rodič, tak u všech dětí odstraníme referenci rodiče
  else if (this.children)
  {
    this.children.forEach(function(child)
    {
      child.setParent(null);
    });
  }
}

Cache.prototype.getParent = function()
{
  return this.parent || this;
}

Cache.prototype.setParent = function(parent)
{
  this.parent = parent;
}

Cache.prototype.isChild = function()
{
  return (!!this.parent);
}

Cache.prototype.isParent = function()
{
  return (!this.parent);
}

Cache.prototype.getFamily = function()
{
  return [this.getParent()].concat(this.getParent().children);
}

Cache.prototype.getChildren = function()
{
  return this.getParent().children || [];
}

Cache.prototype.isGeocache = function(parent)
{
  return (this.getParent().id.match(/^GC([0-9A-HJ-KM-NP-RTV-Z]+)$/)); 
}

Cache.prototype.isWaymark = function(parent)
{
  return (this.getParent().cacheType == Cache.WAYMARK);
}

// vrátí zda je daný bod tradičkou, finálkou nebo physical stage
Cache.prototype.isPhysical = function(parent)
{
  return (
    this.cacheType == Cache.TRADITIONAL                        /* tradička */
    || this.cacheType ==  Cache.FINAL_LOCATION                 /* finálka */
    || this.cacheType ==  Cache.PHYSICAL_STAGE                 /* fyzická stage */
    || (this.getParent().hasCorrected && this.isParent())      /* rodič, který má corrected coordinates (tedy rodič = finálka) */
  )
}

// spočte zda je keška viditelná (po aplikaci různých skrývajících filtrů)
// -- problém: markery mimo průhled *vždy* vrací true
// -- bude třeba kontrolovat vlastnosti jednu po druhé :(
// -- asi bude vhodné udělat 2 funkce - tato kontroluje aktuální viditelnost, druhá kontroluje zda je keška viditelná po aplikaci všech filtrů
Cache.prototype.isVisible = function(parent)
{
  if (!this.marker)
    return false;
  
  // toto bude vracet false pro vše mimo průhled   
  if (!this.marker.getDom().parentNode)
    return false;    
    
  // nefunguje pokud je layer disablovaná
  // -- problém: markery mimo průhled *vždy* vrací true
  if (window.getComputedStyle(this.marker.getDom()).getPropertyValue("display") == "none")
    return false;
  
  // todo: udělat víc testů :(  
  //if (settings.hide_children && this.isChild())
  //  return false;

  return true;    
}

// zda je keška N0 E0
Cache.prototype.isValid = function(parent)
{
  return !this.coords.equals(new SMap.Coords(0, 0));    
}

// zda byl marker odtažen někam jinam (bez updatu souřadnic v GSAKu)
Cache.prototype.wasDragged = function()
{
  return !this.coords.equals(this.coordsOriginal);
}

// převede terén/obtížnost na řetězec
Cache.formatTerDif = function(number)
{
  if (number != parseInt(number))  // 1.5 -> "1.5"
    return (number + "");
  else
    return (number + ".0");        // 1 -> "1.0"
}

Cache.prototype.getTerrain = function()
{
  return Cache.formatTerDif(this.terrain);
}

Cache.prototype.getDifficulty = function()
{
  return Cache.formatTerDif(this.difficulty);
}

Cache.prototype.setCoords = function(coords)
{
  this.coords = coords;

  if (this.marker)
    this.marker.setCoords(this.coords);
}

// normálně máme uloženy původní souřadnice, ke kterým se po tažení vracíme
// -- ty přepíšeme
// -- také znovu vygenerujeme text u karty a bubliny
Cache.prototype.setPermanentCoords = function(coords)
{
  coords = coords || this.coords;      // buď je dostaneme v parametru nebo použijeme souřadnice z posledního dragu
  this.coordsOriginal = this.coords = coords;
  this.setCoords(coords);
  
  this._updateFamilyValues();
}

// nastaví kartu, bublinu atd. pro celou rodinu (po nějaké změně)
Cache.prototype._updateFamilyValues = function()
{
  this.getFamily().forEach(function(child)
  {
    child._updateValues();
  });
}

// nastaví kartu, bublinu atd. pro tuto kešku (po nějaké změně)
Cache.prototype._updateValues = function()
{
  this.setHasFinalLocation();
  this.setHasCorrected();

  this._cardUpdate();
  this._bubbleUpdate();
  this._simpleBubbleUpdate();
  this._updateMarkerClasses();
}

Cache.prototype.setUserFlag = function(bool)
{
  this.userFlag = bool;
  this._updateFamilyValues();
}

// obrázek jako ikonka (do bubliny, filtru apod.)
Cache._getIconUrl = function(cacheType)
{
  return (basePath + "Images/Caches/" + Cache.css[cacheType] + ".png");
}

// projdeme rodinu a vrátíme ty členy, pro které callback funkce vrací true
Cache.prototype.filterFamily = function(callback)
{
  var filtered = this.getFamily().filter(function(c)
  {
    return (callback.bind(c)());
  });
  
  return filtered;
}     

//==============================================================================
//                           parsing cache data
//==============================================================================

Cache.prototype.parseOptions = function(options)
{
  // převod z původního formátu
  options =
  {
		id: options.id,
    coords: new SMap.Coords.fromWGS(options.Latitude, options.Longitude),
		name: options.Name,
		shortDescription: options.ShortDescription,
    longDescription: options.LongDescription,
    hasCorrected: !!options.HasCorrected,
    userFlag: !!options.UserFlag,
    cacheType: Cache.strToConstant[options.CacheType],
    container: Cache.strToConstant[options.Container + "_"],
    status: Cache.strToConstant[options.Status + "_"],
    found: (options.Status2 == "F"),
    owned: (options.Status2 == "O"),
    guid: options.Guid,
    ownerName: options.OwnerName,
    placedDate: options.PlacedDate,
    terrain: options.Terrain,
    difficulty: options.Difficulty,
    url: options.Url        
  };

  //-------------------
	var defaultData = 
  {
		id: Cache.idGenerator(),
    coords: Cache.defaultCoords,
		name: "",
		shortDescription: "",  
    longDescription: "",
    url: "",
    hasCorrected: false,
    userFlag: false,
    cacheType: "Traditional",
    container: "Small",
    status: "A",
    found: false,
    owned: false,
    guid: "",
    ownerName: "",
    placedDate: "",
    terrain: 1,
    difficulty: 1,
    cacheId: null
	};
  
  for (var p in defaultData)
  {
    this[p] = (p in options) ? options[p] : defaultData[p];
  }
}

Cache.prototype.setHasCorrected = function()
{
  // povolíme jen pro rodiče (abychom v updateFamilyValues nevolali toto zbytečně opakovaně)
  if (!this.isParent())
    return;

  var filtered = this.filterFamily(function() { return this.cacheType == Cache.CORRECTED });
  this.hasCorrected = !!filtered.length;
}

Cache.prototype.setHasFinalLocation = function()
{
  // povolíme jen pro rodiče (abychom v updateFamilyValues nevolali toto zbytečně opakovaně)
  if (!this.isParent())
    return;

  var filtered = this.filterFamily(function() { return this.cacheType == Cache.FINAL_LOCATION });
  this.hasFinalLocation = !!filtered.length;
}

// získáme Guid z url
Cache.prototype.getGuid = function(coords)
{
  var parent = this.getParent();
  var guid = parent.guid;

  // pokud už je vygenerováno, tak ho jen vrátíme
  if (guid)
    return guid;

  // jen u kešek a waymarků
  if (!this.isGeocache() && !this.isWaymark())
    return "";
  
  // získáme ho z url  
  if (!parent.url)
    return;

  var re = /guid=(.{36})/;
  
  if (!re.test(parent.url))
    return "";
  
  parent.guid = parent.url.match(re)[1];
  return parent.guid;
}

// převede GCxxxx na číselný kód, např 4254823
Cache.prototype.getCacheId = function(coords)
{
  var parent = this.getParent();
  var cacheId = parent.cacheId;

  // pokud už je vygenerováno, tak ho jen vrátíme
  if (cacheId)
    return cacheId;

  // cacheId je jen u kešek    
  if (!this.isGeocache())
    return null;

  var idHex = parent.id.match(/^(GC|WM)(.*)/)[2];
  
  // 0-FFFF
  if (/^[0-9A-F]{1,4}$/.test(idHex))
    cacheId = parseInt(idHex, 16);
  
  // > FFFF
  else
  {
    var WPTCHARS = "0123456789ABCDEFGHJKMNPQRTVWXYZ";
    var accum = 0;
  
    for (var i = 0; i < idHex.length; i++)
      accum = accum * 31 + WPTCHARS.indexOf(idHex[i]);
  
    cacheId = Math.abs(accum - 16 * 31 * 31 * 31 + 65536);
  }
  
  parent.cacheId = cacheId;
  return cacheId; 
}

//==============================================================================
//                   card (zobrazí se po kliku na kešku)
//==============================================================================

// horní část karty s daty keše
Cache.prototype._cardHeader = function()
{
  // parent icon
  var html = "<span class='cache_icon cacheimg_parent cacheimg_" + Cache.css[this.cacheType] 
    + "' title='" + Cache.format[this.cacheType] + "'></span>";
                              
  // parent Code                  
  var cache_code = "<span class='cache_code status_" + Cache.format[this.status] + "'>" + this.id + "</span>";
  html += cache_code;

  // parent Coordinates
  var cache_coords = "<span class=coords>(" + this.coords.format("WGS", "min") + ")</span>";
  html += cache_coords;

  // parent Name + Terrain/Difficulty + Container + OwnerName + PlacedDate
  var ter_dif = "<span class=cache_name>" + this.name + "</span>";
  ter_dif += " (<span class=wp_diff>" + this.getDifficulty() + "</span>";
  ter_dif += "/<span class=wp_terr>" + this.getTerrain() + " </span>";
  ter_dif += "<span class=wp_container>" + Cache.format[this.container] + "</span>,"
  ter_dif += "<span class=wp_owner> by " + this.ownerName + "</span>,"; 
  ter_dif += "<span class=wp_placed_date> " + this.placedDate + "</span>)";
  
  html += "<span class=cache_name_ter_dif>" + ter_dif + "</span>";
  return html;
}

// dolní část karty s tlačítky a listingem
Cache.prototype._cardFooter = function()
{
  var parent = this.getParent();
                              
  // "Open in ..." URLs           
  var html = "<div class=open_cache><a class='url_gsak button GSAK_Only' href='gsak://%FF/Search/" + parent.id + "'>" + tr("Open in GSAK") + "</a>";
  html    += "<a class='url_gc button' href='" + parent.url + "' target=_blank>" + tr("Open in Browser") + "</a></div>";
                              
  // parent ShortDescription / LongDescription (s výjimkou dětí)
  if (!this.isChild())
    html += "<div class=listing>" + (parent.shortDescription ? (parent.shortDescription + "<br>") : "") + (parent.longDescription || "") + "</div>";
    
  return html;
}
  
Cache.prototype._cardSetHtml = function(html)
{
  if (!this.card)
  {
    this.card = new SMap.Card();        
    this.card.setSize(311); /* Šířka (default: 311px) */
    this.card.getBody().style.backgroundColor = 'white';
    this.marker.decorate(SMap.Marker.Feature.Card, this.card);
  }

  this.card.getBody().innerHTML = html;
}

Cache.prototype._cardCreate = function()
{
  var html = this._cardHeader() + this._cardFooter();
         
  // put to DIV                   
  html = "<div class=wp_text>" + html + "</div>";
  this._cardSetHtml(html);
}

// znovu vygeneruje kartu, ale jen pokud už existuje
Cache.prototype._cardUpdate = function()
{
  if (!this.card)
    return;
    
  this._cardCreate();
}


//==============================================================================
//                     bubble (zobrazí se po najetí na kešku)
//==============================================================================

Cache.prototype._bubbleText = function()
{
  var parent = this.getParent();

  var dif_ter = parent.id + ", <span class='dif_ter_cont'>" 
    + parent.getDifficulty() + "/" + parent.getTerrain() + " " 
    + Cache.format[parent.container] + "</span>, by " + parent.ownerName;
    
  // special text for Waymarks  
  if (parent.wmCategory)
  {
    dif_ter = parent.id + ((parent.ownerName !== parent.wmCategory) ? (", by " + parent.ownerName) : "");    
  }    

  var status = "<span class='status'>" 
    + (parent.status == Cache.DISABLED ? " (Disabled)" : (parent.status == Cache.ARCHIVED ? " (Archived)" : "")) + "</span>";

  // child
  if (this.isChild())
    var hover_title = this.id + ": " + "<span class='name'>" + this.name + "</span>"
     + status + " (<span class='parent_name'>" + parent.name + "</span> - " + dif_ter + ")"
     + (this.comment ? "<span class='has_comment'> [" + tr("Has Comment") + "]</span>" : "");

  // parent
  else
    var hover_title = "<span class='name'>" + this.name + "</span>" + status 
    + (this.wmCategory ? ("<span class='wm_category'> " + this.wmCategory + "</span>") : "") 
    + " (" + dif_ter + ")";
    
  return hover_title;
}

Cache.prototype._bubbleCreate = function()
{
  // create bubble
  if (!this.bubble)
  {
    this.bubble = new SMap.Bubble({className: "cacheOnHoverBubble"});
    this.marker.decorate(SMap.Marker.Feature.Bubble, this.bubble);
  }
  
  this.bubble.setHTML(this._bubbleText());
}

Cache.prototype._bubbleUpdate = function()
{
  if (!this.bubble)
    return;

  this.bubble.setHTML(this._bubbleText());
}

//==============================================================================
//                            simple bubble
//==============================================================================

Cache.prototype._simpleBubbleClasses = function()
{
  // nastavíme třídu pro zbarvení
  var classes = ["cacheSimpleBubble"];
  
  if (this.status == Cache.DISABLED)
    classes.push("isDisabled");

  if (this.status == Cache.ARCHIVED)
    classes.push("isArchived");

  if (this.found)
    classes.push("isFound");

  if (this.owned)
    classes.push("isOwned");

  return classes;
}

Cache.prototype._simpleBubbleText = function()
{
  var html = this.isChild() ? this.parent.name : (this.id + ": " + this.name);
  return html;
}

// nastaví text existující bublině
Cache.prototype._simpleBubbleSetText = function()
{
  this.simpleBubble.setHTML(this._simpleBubbleText());
  this.simpleBubble.setClasses(this._simpleBubbleClasses());
}

// vytvoří bublinu a nastaví její text (pokud už je vytvořená, nedělá nic)
Cache.prototype._simpleBubbleCreate = function()
{
  if (!this.marker || this.simpleBubble) 
    return;

  this.simpleBubble = new SMap.Bubble({className: this._simpleBubbleClasses().join(" ")});
  this._simpleBubbleSetText();
  this.marker.decorate(SMap.Marker.Feature.Bubble, this.simpleBubble);
  
  // posuneme bublinu za tu hlavní, aby ji tato nepřekrývala, pokud najedeme na keš
  if (this.bubble)
    this.simpleBubble.dom.parentNode.appendChild(this.bubble.dom);
}

// updatuje text bubliny (pokud existuje)
Cache.prototype._simpleBubbleUpdate = function()
{
  if (!this.simpleBubble)
    return;
    
  this._simpleBubbleSetText();
}

// odstraní bublinu
Cache.prototype._simpleBubbleRemove = function()
{
  if (!this.simpleBubble) 
    return;

  this.marker.removeBubble(this.simpleBubble);
  this.simpleBubble = null;
}

//==============================================================================
//                          vytvoření markeru
//==============================================================================

Cache.prototype.generateMarkerClasses = function()
{
  var parent = this.getParent();

  var classNames =
  [
    "cacheMarker",
    "parentCacheType_" + Cache.css[parent.cacheType],           // parentCacheType (traditional, multi, ...)
    "cacheType_" + Cache.css[this.cacheType],                   // cacheType (typ dítětě nebo rodiče, pokud tento bod není dítě)
    Cache.css[parent.status],                                   // active, disabled, archived
    Cache.css[parent.found ? Cache.FOUND : Cache.NOT_FOUND],    // found, not found
    parent.owned ? Cache.css[Cache.OWNED] : "",                 // owned
    this.isParent() ? "isParent" : "isChild",                       // parent, child
    (this.isChild() && this.userFlag) ? "isUserFlaggedChild" : "",  // GSAK userFlag (child)
    parent.userFlag ? "isUserFlaggedParent" : "",                   // GSAK userFlag (parent)
    this.isSelected ? "isSelected" : "",                            // is selected? (using mouse)
    this.isHidden ? "isHidden" : ""                                 // is hidden? (using X)
  ];

  // private hide (u nalezených bodů skryjeme neoznačené, u nenalezených označené, parkoviště opačně, rodiče necháme 
  if (this.isChild())
  {
    if ((this.cacheType == Cache.PARKING_AREA && !this.userFlag)                  // neoznačené parking area
     || (this.cacheType != Cache.PARKING_AREA && parent.found && !this.userFlag)  // neoznačené u nalezených
     || (this.cacheType != Cache.PARKING_AREA && !parent.found && this.userFlag)) // označené u nenalezených     
    {
      classNames.push(Cache.css[Cache.SPECIAL_PRIVATE]);
    }
  }
  
  // non-finals hide (pokud má keška finálku, tak skryjeme vše krom finálky; pokud má corrected coordinates, tak vše kromě rodiče)
  if (parent.hasFinalLocation && this.cacheType != Cache.FINAL_LOCATION)
    classNames.push(Cache.css[Cache.SPECIAL_NON_FINALS]);

  if (parent.hasCorrected && !this.isParent())
    classNames.push(Cache.css[Cache.SPECIAL_NON_FINALS]);
    
  //log(classNames.join(" "));
  return classNames;
}

// obrázek pro marker
Cache.prototype._getMainMarkerDiv = function()
{
  var url = (basePath + "Images/Markers/" + Cache.css[this.cacheType] + ".png");
  
  // ikonka keše
  var html =
  //"<img src='" + this._getMarkerUrl() + "'>";   // znatelně pomalejší než použití divu s background-image
  "<div class=markerMain style='background-image: url(" + url + ")'></div>";
  
  return html;  
}

// pozadí markeru (pokud je keška disablovaná, archivovaná, nalezená, vlastněná)
Cache.prototype._getBackgroundMarkerDiv = function()
{
  var base = basePath + "Images/Markers/Background/";
  var parent = this.getParent();
  var url = "";

  if (parent.owned)
    url = base + "Green.png";
  else if (parent.found)
    url = base + "Yellow.png";
  else if (parent.status == Cache.ARCHIVED)
    url = base + "Violet.png";
  else if (parent.status == Cache.DISABLED)
    url = base + "Orange.png";
    
  if (!url)
    return "";
    
  return "<div class=markerBg style='background-image: url(" + url + ")'></div>";
}

// popředí markeru (jen pokud má hasCorrected)
Cache.prototype._getForegroundMarkerDiv = function()
{
  if (!this.hasCorrected)
    return "";

  var url = basePath + "Images/Markers/Foreground/CorrectedMark.png";
  
  return "<div class=markerFg style='background-image: url(" + url + ")'></div>";
}

// někdy je třeba SMap.Bubble předělat, aby to nebylo součástí markeru
// -- do té doby je třeba vytvořit extra div a umístit do něj všechny části
Cache.prototype.getMarkerContainer = function()
{
  return this.marker.getDom().firstChild;
}

// vytvoří marker
Cache.prototype.createMarker = function()
{
  var classes = this.generateMarkerClasses();
  var div = JAK.mel("div", {className: classes.join(" "), onmouseover: this._onmouseover.bind(this)});
    
  html  = this._getBackgroundMarkerDiv();
  html += this._getMainMarkerDiv();
  html += this._getForegroundMarkerDiv();    

  // je třeba umístit všechny části markeru do divu, protože jinak by při animaci animovala i bublina :(
  // -- vnější div má třídu "cacheMarker"
  // -- uvnitř něj je div "markerContainer" (se součástmi kešky) + až 2 divy s bublinami 
  
  //div.innerHTML = "<div class='" + classes.join(" ") + "'>" + html + "</div>";
  div.innerHTML = "<div class='markerContainer'>" + html + "</div>";

  this.marker = new SMap.Marker(this.coords, this.id, {url: div});
  return this.marker;  
}

Cache.prototype._updateMarkerClasses = function()
{
  if (!this.marker)
    return;

  var classes = this.generateMarkerClasses();
  var dom = this.marker.getDom();

  // hack - abychom nepřepsali třídu pro bublinu  
  if (contains_class(dom, "markerWithBubble"))
    classes.push("markerWithBubble");
  
  this.marker.getDom().className = classes.join(" ");
}

//==============================================================================
//                              context menu
//==============================================================================

Cache.prototype._contextMenuAdd = function()
{
  require(
  [
    basePath + "context_menu.css",
    basePath + "context_menu.js",
    function() { window.cacheContextMenuHandler = markerContextMenu(this.marker.getDom(), this); }.bind(this)
  ]);
}

// tohle není ideální
// -- lepší by bylo, pokud je menu otevřené, odebrat handler po zavření menu
// -- takhle může docházet k leakům
Cache.prototype._contextMenuRemove = function()
{
  if (window.cacheContextMenuHandler && document.getElementById('contextMenuWP').style.display != "block")
    contextMenu.removeContextMenu(window.cacheContextMenuHandler);
}

//==============================================================================
//                         cache hiding (using X)
//==============================================================================

Cache.prototype.hide = function()
{
  if (this.getParent().mouseoverFamily)
    return;

  this.isHidden = true;
  
  if (this.marker)
    add_class(this.marker.getDom(), "isHidden");
}

Cache.prototype.unhide = function()
{
  this.isHidden = false;
  
  if (this.marker)
    remove_class(this.marker.getDom(), "isHidden");
}

//==============================================================================
//                            cache selection
//==============================================================================

Cache.prototype._getSelectionMarkerDiv = function()
{
  return "<div class=markerBg style='background-image: url(" + url + ")'></div>";
}

Cache.prototype.select = function()
{
  if (this.isSelected)   // return false = neproběhla změna
    return false;

  // create div
  var container = this.getMarkerContainer();
  var div = JAK.mel("div", {className: "markerFgSelected"});
  container.appendChild(div);
  
  // nastavíme flag a třídu
  this.isSelected = true;
  add_class(this.marker.getDom(), "isSelected");
  return true;
}

Cache.prototype.deselect = function()
{
  if (!this.isSelected)  // return false = neproběhla změna
    return false;

  // odstraníme div
  var container = this.getMarkerContainer();
  var childNodes = container.childNodes;
    
  for (var i = 0; i < childNodes.length; i++)
  {
    if (contains_class(childNodes[i], "markerFgSelected"))
    { 
      container.removeChild(childNodes[i]);
      break;
    }
  }

  // nastavíme flag a třídu
  this.isSelected = false;
  remove_class(this.marker.getDom(), "isSelected");
  return true;
}

//==============================================================================
//                         dragging the marker
//==============================================================================

// pokud ukončíme tažení kešky, tak se toto spustí
Cache.prototype._markerDragStop = function(e)
{
  // pokud jsme netáhli se zaplým ALT, pak marker vrátíme zpět
  if (!e.data.event.altKey)
    this.marker.setCoords(this.coordsOriginal);
    
  this.coords = this.marker.getCoords();
  
  // nastavíme nové souřadnice
  this._updateFamilyValues();
  
  // (old fix) remove pressed alt class (onkeyup doesn't fire, when we do it while dialog is present)
  if (e.data.event.altKey && contains_class(this.marker.getMap().getContainer(), "key_down_alt"))
  {
    remove_class(this.marker.getMap().getContainer(), "key_down_alt");
  }
}

//==============================================================================
//                        mouseover and mouseout
//==============================================================================

Cache.prototype._onmouseover = function()
{
  // handler pro vykreslení spidera
  // -- také řeší problém, že onmouseout někdy neuhodí (zvlášť když je hodně kešek přes sebe)
  // -- pošleme  tedy signál, přijme ho _onmouseout minule vybrané kešky 
  // -- pokud už _onmouseout neproběhl, v tom případě by ten handler už byl zrušen a tento signál by neměl efekt
  // -- zbylý kód na konci této funkce
  this.marker.getMap().getSignals().makeEvent("cache-marker-mouseover", this, {cache: this});

  if (!this._markerInitialized)
  {
    // uděláme marker tahnutelný
    this.marker.decorate(SMap.Marker.Feature.Draggable);
  
    // vytvoříme card
    this._cardCreate();
    
    // vytvoříme bubble (která se zobrazí po najetí na kešku)
    this._bubbleCreate();

    // nastavíme handler pro opuštění kešky
    this.marker.getDom().onmouseout = this._onmouseout.bind(this); 
  
    this._markerInitialized = true;
  }
  
  // přidáme kontext menu    
  this._contextMenuAdd();  
  
  // *** mouseover stav ***
  this.mouseoverCache = true;                    // zda je myš nad současnou keškou
  this.getParent().mouseoverFamily = true;       // zda je myš nad libovolným členem rodiny
  
  // nastavíme class (pro animaci rodiny)
  this.getFamily().forEach(function(p)
  {
    add_class(p.getMarkerContainer(), "isMouseoverFamily");
  });
  
  add_class(this.getMarkerContainer(), "isMouseoverCache");

  // vytvoříme handler, při jakémkoli mouseoveru okamžitě provedeme mouseout 
  this._mouseoverHandler = this.marker.getMap().getSignals().addListener(this, "cache-marker-mouseover", "_onmouseout");
}

Cache.prototype._onmouseout = function()
{
  // odebereme handler nastavený v mouseover
  if (this._mouseoverHandler)
  {
    if (this.marker.getMap())
      this.marker.getMap().getSignals().removeListener(this._mouseoverHandler);

    this._mouseoverHandler = null;
  }

  // odebereme kontext menu (pokud není zrovna otevřené)    
  this._contextMenuRemove();  

  // *** mouseover stav ***
  this.mouseoverCache = false;                   // zda je myš nad současnou keškou
  this.getParent().mouseoverFamily = false;      // zda je myš nad libovolným členem rodiny
  
  // odstraníme class pro animaci rodiny
  this.getFamily().forEach(function(p)
  {
    remove_class(p.getMarkerContainer(), "isMouseoverFamily");
    remove_class(p.getMarkerContainer(), "isMouseoverCache");
  });
  
  // odebereme spidera
  if (this.marker.getMap())
    this.marker.getMap().getSignals().makeEvent("cache-marker-mouseout", this, {cache: this});
}

//##############################################################################
//==============================================================================
//                              Cache.Child
//==============================================================================

Cache.Child = JAK.ClassMaker.makeClass(
{
	NAME: "Cache",
	VERSION: "1.0",
  EXTEND: Cache
});

Cache.Child.prototype.$constructor = function(options)
{
  this.$super(options);
  this.children = null;
}

Cache.Child.prototype._cardHeader = function()
{
  // child icon                 
  var html = "<span class='cache_icon cacheimg_child cacheimg_" + Cache.css[this.cacheType] + "' title='" + Cache.format[this.cacheType] + "'></span>";
                                
  // child Code                 
  html += "<span class=cache_code>" + this.id + "</span>";
  
  // child Coordinates
  html += "<span class=coords>(" + this.coords.format("WGS", "min") + ")</span>";
                                
  // child Name                 
  html += "<span class=cache_name_ter_dif><span class=cache_name>" + this.name  + "</span></span>";
                                
  // child Comment              
  html += "<div class=child_comment>" + this.comment + "</div>";
                                
  // put to DIV                 
  html = "<div class=child_wp_text>" + html + "</div>";

  // přidáme hlavičku rodiče
  html += this.parent._cardHeader();
  return html;
}

Cache.Child.prototype.parseOptions = function(options)
{
  options =
  {
		id: options.id,
    coords: new SMap.Coords.fromWGS(options.Latitude, options.Longitude),
		name: options.Name,
		comment: options.Comment,
    userFlag: !!options.UserFlag,
    cacheType: Cache.strToConstant[options.CacheType],
    url: options.Url    
  }  

  //------------------
	var defaultData = 
  {
		id: Cache.idGenerator(),
    coords: Cache.defaultCoords,
		name: "",
		comment: "",  
    userFlag: false,
    cacheType: "Traditional",
    url: ""
	}
  
  for (var p in defaultData)
  {
    this[p] = (p in options) ? options[p] : defaultData[p];
  }
}

//##############################################################################
//==============================================================================
//                              Cache.Waymark
//==============================================================================

Cache.Waymark = JAK.ClassMaker.makeClass(
{
	NAME: "Cache",
	VERSION: "1.0",
  EXTEND: Cache
});

Cache.Waymark.prototype.$constructor = function(options)
{
  this.wmCategory = "";
  this.wmCategoryIcon = "";

  this.$super(options);
}

Cache.Waymark.prototype.parseOptions = function(options)
{
  this.$super(options);
  
  this.parseCategory(options);
  this.parseCategoryIconUrl();
  
  //log(this.wmCategory);
  //log(this.wmCategoryIcon);
}

Cache.Waymark.prototype.parseCategory = function(options)
{
  // custom (our) version
  var catname = this.shortDescription.match(/<!--WM_Category:(.*?)-->$/);
  
  if (catname && this.shortDescription[0] == ':')
    this.shortDescription = this.shortDescription.replace(/^: /, "");  

  // GeoGet version
  catname = catname || options.CacheTypeWM;
  
  // standard GroundSpeak version
  if (!catname)
  {
    catname = this.shortDescription.match(/^(.+?)(?=:)/);
    
    if (catname)
      this.shortDescription = this.shortDescription.replace(catname[0] + ": ", "");
  }
  
  if (catname)
  {
    catname = options.CacheTypeWM ? catname : catname[1];
    this.wmCategory = catname;
  }
}

Cache.Waymark.prototype.parseCategoryIconUrl = function()
{
  if (!this.wmCategory)
    return;

  // replace special characters
  var catname = this.wmCategory;
  catname = catname.replaceAll("<", "[less than]");
  catname = catname.replaceAll(">", "[greater than]");
  catname = catname.replaceAll(":", "[colon]");
  catname = catname.replaceAll("\"", "[double quote]");
  catname = catname.replaceAll("/", "[forward slash]");
  catname = catname.replaceAll("\\", "[backslash]");
  catname = catname.replaceAll("|", "[vertical bar]");
  catname = catname.replaceAll("?", "[question mark]");
  catname = catname.replaceAll("*", "[asterisk]");

  this.wmCategoryIcon = basePath + "Images/Waymarking/Icons2/" + catname + ".gif";
  
  // escape url
  // -- http://www.w3schools.com/TAGS/ref_urlencode.asp
  this.wmCategoryIcon = encodeURI(this.wmCategoryIcon).replaceAll("'", "%27").replaceAll('"', "%22");
}

// horní část karty s daty keše
Cache.Waymark.prototype._cardHeader = function()
{
  if (!this.wmCategory || !this.wmCategoryIcon || this.isChild())
    return this.$super();

  var html = "<img class='cache_icon cacheimg_parent' src=\"" + this.wmCategoryIcon 
    + "\" title='" + this.wmCategory.replaceAll("'", "").replaceAll("\\", "|") + "'>";
  
  // code                  
  html += "<span class='cache_code status_" + Cache.format[this.status] + "'>" + this.id + "</span>";
           
  // coordinates
  html += "<span class=coords>(" + this.coords.format("WGS", "min") + ")</span>";
  
  var html2 = "<span class=cache_name>" + this.name + "</span>";
  html2 += "<span class=wm_category> " + this.wmCategory + "</span> (";
  
  if (this.ownerName != this.wmCategory)
    html2 += "<span class=wp_owner>by " + this.ownerName + "</span>, ";
  
  html2 += "<span class=wp_placed_date>" + this.placedDate + "</span>)";
  html += "<span class=cache_name_ter_dif>" + html2 + "</span>";
  
  return html;  
}

// hlavní marker pro waymark bude prázdný červený waymark...
Cache.Waymark.prototype._getMainMarkerDiv = function()
{
  if (!this.wmCategoryIcon)
    return this.$super();

  var url = basePath + "Images/Markers/WaymarkGeneric.png";
  return "<div class=markerMain style='background-image: url(" + url + ")'></div>";
}

// ... na něj pak umístíme zmenšenou ikonku
Cache.Waymark.prototype._getForegroundMarkerDiv = function()
{
  if (!this.wmCategoryIcon)
    return this.$super();

  //html = "<img class=markerFgWaymark src='" + this.wmCategoryIcon + "'>"; + this.$super();
  html = "<div class=markerFgWaymark style=\"background-image: url('" + this.wmCategoryIcon + "');\"></div>" + this.$super();  

  return html;
}

//##############################################################################
//##############################################################################
//==============================================================================
//                              Caches
//==============================================================================

Caches = JAK.ClassMaker.makeClass(
{
	NAME: "Caches",
	VERSION: "1.0"
});

Caches.prototype.$constructor = function(wp, map)
{
  timer("caches");
  this._sc = [];
  this._ec = [];
  
  this.map = map;
  this.points = {};
  this.lastSelected = [[]]; // pole polí vybraných prvků (pomocí myši)
  
  this._circleLayer = null;
  this._spiderLayer = null;
  this._sc2 = null;
  
  this._disabled = false;   // umožní vypnout vrstvu, aby ji žádná funkce nezapínala
  
  // Corrected Coordinates (přidáme bod s původními souřadnicemi)
  for (var Code in wp)
  {
    if (wp[Code].HasCorrected)
    {
      wp["CC" + Code] = JSON.parse(JSON.stringify(wp[Code]));
      wp["CC" + Code].Latitude = wp["CC" + Code].LatOriginal;
      wp["CC" + Code].Longitude = wp["CC" + Code].LonOriginal;
      wp["CC" + Code].HasCorrected = 0;
      wp["CC" + Code].Parent = Code;
      wp["CC" + Code].CacheType = "Corrected";
      wp["CC" + Code].Comment = "";
      wp["CC" + Code].UserFlag = 0;
    }
  }  

  // parsneme kešky
	for (var p in wp)
  {
    var c = wp[p];
    c.id = p;
    
    // waymarks
    if (!c.Parent && c.CacheType === "Y")
      var cache = new Cache.Waymark(c);
      
    // zbylé typy rodičů
    else if (!c.Parent)
      var cache = new Cache(c);

    // děti
    else
      var cache = new Cache.Child(c);   
    
    this.points[cache.id] = cache;
  }
  
  // nastavíme rodiče a děti
  this._setChildrenAndParents(wp);
  
  // u každého bodu nastavíme, zda má finálku (pro filtr, který skryje body, pokud u kešky není finálka)
  for (var p in this.points)
  {
    if (!this.points[p].parent)
      this.points[p].hasFinalLocation = false;
  }
    
  for (var p in this.points)
  {
    if (this.points[p].cacheType == Cache.FINAL_LOCATION)
      this.points[p].parent.hasFinalLocation = true;  
  }  
  
  this._buildLayer();
  
  // nastavíme handler pro tažení markerů
  this.map.getSignals().addListener(window, "marker-drag-stop", function(e,b,c)
  {
    var id = e.target.getId();

    if (!(id in this.points) || e.target !== this.points[id].marker)
      return;

    this.points[id]._markerDragStop(e);
  }.bind(this));
  
  timer("caches");
}

Caches.prototype.$destructor = function(wp, map)
{
  this.spiderExit();  // někdy je třeba tuto funkci pořádně dodělat  
}

// při inicializaci nastaví u jednotlivých kešek linky k rodičům a dětem
Caches.prototype._setChildrenAndParents = function(wp)
{
  for (var p in wp)
  {
    if (wp[p].Parent)
    {
      this.points[p].setParent(this.points[wp[p].Parent]);      // nastavíme link dítě -> rodič
      this.points[wp[p].Parent].children.push(this.points[p]);  // nastavíme link rodič -> dítě
    }
  }
}

Caches.prototype._buildLayer = function()
{
  this.layer = new SMap.Layer.Marker();

  for (var i in this.points)
  {
    var marker = this.points[i].createMarker();
    this.layer.addMarker(marker);
  }
  
  this.map.addLayer(this.layer).enable();
}

// vyfiltruje body
// -- filter je funkce, která pokud vrátí true, tak se bod přidá do pole, které na konci vrátíme
Caches.prototype.filter = function(callback)
{
  var caches = [];

  for (var p in this.points)
  {
    if (callback.bind(this.points[p])())
      caches.push(this.points[p]);
  }
  
  return caches;
}

// spustíme danou funkci pro všechny body
// -- v callbacku je možno vracet true a tak získat počet změn
Caches.prototype.forEach = function(callback)
{
  // vypneme překreslování, zatímco probíhá operace (jinak může být pomalé selectování, mazání wp apod.)
  this.layer.disable();

  var changed = 0;
  
  for (var p in this.points)
  {
    changed += callback.bind(this.points[p])() || 0;
  }
  
  if (!this._disabled)
    this.layer.enable();
    
  return changed;
}

// vypnutí vrstvy markerů
Caches.prototype.disable = function()
{
  this.layer.disable();
  this._disabled = true;
}

Caches.prototype.enable = function()
{
  this._disabled = false;
  this.layer.enable();
}

// vytvoříme simple bublinu u všech kešek
// -- vytvoříme ji vždy jednou a pak už neodstraňujeme
Caches.prototype._createSimpleBubbles = function()
{

  for (var p in this.points)
  {
    this.points[p]._simpleBubbleCreate();
  }
}

Caches.prototype.getAll = function()
{
  return this.filter(function() { return true; });
}

Caches.prototype.getParents = function()
{
  return this.filter(function() { return this.isParent(); });
}

Caches.prototype.getAllCoords = function()
{
  var caches = this.getAll();
  return caches.map(function(c) { return c.coords }); 
}

Caches.prototype.getAllParentCoords = function()
{
  var caches = this.getParents();
  return caches.map(function(c) { return c.coords }); 
}

Caches.prototype.getAllValidCoords = function() // vrátí pole všech souřadnic krom N0 E0
{
  var caches = this.filter(function() { return this.isValid(); });
  return caches.map(function(c) { return c.coords }); 
}

Caches.prototype.deleteCaches = function(caches)
{
  caches = Array.isArray(caches) ? caches : [caches];   // umožníme volat i s jedním parametrem

  // vyfiltrujeme všechny body, u kterých mažeme celou rodinu
  // -- pokud máme rodič nebo corrected coordinates, tak mažeme celou rodinu
  var familiesToDelete = caches.filter(function(c)
  {
    return (c.isParent() || c.cacheType == Cache.CORRECTED);
  });
  
  // přidáme je k původnímu poli (mohou zde být duplicity)
  familiesToDelete.forEach(function(c)
  {
    caches = caches.concat(c.getFamily())
  });

  // získáme rodiče (abychom pak u všech kešek provedli update)
  var parents = {};
  
  for (var i = 0; i < caches.length; i++)
  {
    parents[caches[i].getParent().id] = caches[i].getParent();  
  }

  // smažeme všechny body
  caches.forEach(function(c)
  {
    // pokud už keš byla smazána tak ji přeskočíme
    if (!(c.id in this.points))
      return;

    c.$destructor();

    // odebery z vrstvy markerů  
    if (c.marker)
      this.layer.removeMarker(c.marker,  true /* noRedraw */);  

    delete this.points[c.id];

  }.bind(this));
  
  // překreslíme vrstvu markerů
  this.layer.redraw(true);


  // updatujeme hodnoty
  for (p in parents)
  {
    if (p in this.points)
      parents[p]._updateFamilyValues();
  }

  // pošleme signál (pro update ikonek ve filtru)
  this.map.getSignals().makeEvent("caches-removed", this, {});
}

//==============================================================================
//                                  Selections
//==============================================================================

// vrátí všechny vybrané (pomocí myši) kešky
Caches.prototype.getSelected = function()
{
  return this.filter(function() { return this.isSelected; });
}

Caches.prototype.getDeselected = function()
{
  return this.filter(function() { return !this.isSelected; });
}

// uloží historii (před změnou!!)
Caches.prototype.selectedSaveHistory = function()
{
  // projdeme všechny kešky a dáme do pole ty vybrané
  var state = [];

  this.forEach(function()
  {
    if (this.isSelected)
      state.push(this.id);
  });
  
  // restore funkce
  var callback = function(state)
  {
    this.forEach(function()
    {
      // pokud je prvek v poli vybraných, tak ho vybereme a naopak
      (state.indexOf(this.id) == -1) ? this.deselect() : this.select();
    });
    
    if (this.map) this.map.getSignals().makeEvent("cache-selection", this, {});
  };

  _history_.save(
  {
    state: state,
    callback: callback.bind(this)
  });
}

// points: pole bodů
// mode: Selection.CREATE, Selection.ADD, Selection.REMOVE, Selection.XOR
Caches.prototype.selectedProcess = function(params)
{
  var points = params.points;
  var mode = params.options.mode;
  var map = this.map;
  
  // získáme pole aktuálně vybraných, nevybraných a těch vybraných v posledním tažení myší  
  var arrOn = _caches_.getSelected();
  var arrOff = _caches_.getDeselected();

  var arrChange = _caches_.filter(function()
  {
    return this.coords.inMap(map) && this.coords.inPolygon(map, points) && this.isVisible();
  });
  
  var result = Selection.filter(arrChange, arrOn, arrOff, mode);

  // pokud došlo ke změnám, tak uložíme historii
  if (result.on.length || result.off.length)
    this.selectedSaveHistory();
  else
    return;

  // projdeme kešky a změníme jejich isSelected parametr
  this.layer.disable();
  result.on.forEach(function(c) { c.select() });
  result.off.forEach(function(c) { c.deselect() });
  if (!this._disabled) this.layer.enable();
  
  if (this.map) this.map.getSignals().makeEvent("cache-selection", this, {});
}

Caches.prototype.deleteSelected = function()
{
  if (!this.getSelected().length)
    return;

  this.selectedSaveHistory();
  this.deleteCaches(this.getSelected());
}

Caches.prototype.invertSelected = function()
{
  if (this.getAll().length)
    this.selectedSaveHistory();
  else
    return;  

  this.forEach(function()
  {
    this.isSelected ? this.deselect() : this.select();
  });
  
  if (this.map) this.map.getSignals().makeEvent("cache-selection", this, {});  
}

Caches.prototype.selectAll = function()
{
  if (this.getDeselected().length)
    this.selectedSaveHistory();
  else
    return;

  this.forEach(function() { this.select() });
  
  if (this.map) this.map.getSignals().makeEvent("cache-selection", this, {});  
} 

Caches.prototype.deselectAll = function()
{
  if (this.getSelected().length)
    this.selectedSaveHistory();
  else
    return;   

  this.forEach(function() { this.deselect() });
  
  if (this.map) this.map.getSignals().makeEvent("cache-selection", this, {});
}

//==============================================================================
//                                  circles
//==============================================================================

Caches.prototype.circlesInit = function()
{
  if (this._circleLayer)
    this.circlesExit();

  this._circleLayer = new SMap.Layer.Geometry("circleLayer");   /* název kvůli CSS */
  this.map.addLayer(this._circleLayer);
  //this.circlesUpdate();   /* je voláno automaticky handlerem níže po toggle-settings eventu */

  // handler - vygenerujeme znovu vrstvu po každé změně
  // -- je třeba překreslovat až po map-redraw, aby getComputedStyle dával správnou informaci o viditelnosti
  var events = "map-redraw caches-added caches-removed toggle-settings cache-selection marker-drag-stop";
  this.circleHandler = this.map.getSignals().addListener(this, events, "_circlesUpdate");
}

Caches.prototype._circlesUpdate = function(e)
{
  //log([new Date().getTime(), e.type]);
  
  // pro malé měřítko (odpovídající asi zoomu 11 a méně) nevykreslujeme
  if (this.map.getScale() > 200000)
    return;

  this._circleLayer.disable();
  this._circleLayer.removeAll();
  
  var options =  /* settings for IE8 only */
  {
    color: "#00f", 
    opacity: 0.3, 
    outlineWidth: 0
  }

  // vyfiltrujeme keše, které jsou viditelné a mají fyzickou schránku
  var caches = this.filter(function()
  {
    return this.isPhysical() && this.isVisible()
  });
  
  // vytvoříme kolem nich kruhy
  var that = this;

  caches.forEach(function(c)
  {
    var pointOnCircle = c.coords.projectPoint(0, 160.9344 /* 0.1 míle */);
    var circle = new SMap.Geometry(SMap.GEOMETRY_CIRCLE, null, [c.coords, pointOnCircle], options);
    that._circleLayer.addGeometry(circle);
  });
  
  this._circleLayer.enable();
}

Caches.prototype.circlesExit = function()
{
  if (!this._circleLayer)
    return;
    
  if (this.map)
    this.map.getSignals().removeListener(this.circleHandler);

  this._circleLayer.disable();
  this.map.removeLayer(this._circleLayer);
  this._circleLayer = null;
}

//==============================================================================
//                                   spider
//==============================================================================

Caches.prototype.spiderInit = function()
{
  if (this._spiderLayer)
    this.spiderExit();

  this._spiderLayer = new SMap.Layer.Geometry("spiderLayer");   /* název kvůli CSS */
  this.map.addLayer(this._spiderLayer).enable();

  this._sc2 = [];
  this._sc2.push(this.map.getSignals().addListener(this, "cache-marker-mouseover", "_spiderCreate"));
  this._sc2.push(this.map.getSignals().addListener(this, "cache-marker-mouseout", "_spiderClear"));
}

// vyčistí vrstvu od pavouka (reakce na mouseout)
Caches.prototype._spiderClear = function(e)
{
  this._spiderLayer.removeAll();
}

// vykreslí pavouka (reakce na mouseover)
Caches.prototype._spiderCreate = function(e)
{
  this._spiderClear();

  // parametry čar
  var options =
  {
    color: "red",
    width: 2,
    outlineWidth: 0,
    opacity: 1
  }
  
  // projdeme děti a za každé přidáme do vrstvy spojnici k rodiči
  var cache = e.data.cache;
  
  cache.getChildren().forEach(function(c)
  {
    if (!c.isValid())   /* ignorujeme kešky v N0,E0 */
      return;
      
    //if (!c.isVisible())    /* zatím zrušeno, není ta funkce moc vhodná */
    //  return;

    var points = [c.coords, c.getParent().coords];
    var line = new SMap.Geometry(SMap.GEOMETRY_POLYLINE, null, points, options);
    this._spiderLayer.addGeometry(line);

  }.bind(this));
}

Caches.prototype.spiderExit = function()
{
  if (!this._spiderLayer)
    return;

  this._spiderLayer.$destructor();

  if (this.map)
  {
    this.map.removeLayer(this._spiderLayer);
    this.map.getSignals().removeListeners(this._sc2);
  }

  this._spiderLayer = null;
  this._sc2 = null;
}

//==============================================================================
//                                  # end #
//==============================================================================





var _caches_ = new Caches(wp, m);

settings.hide_all = false;    /* nikdy nezačneme se skrytými kešemi */

[
  "hide_children",
  "hide_parents",
  "bubble",
  "hide_all",
  "hide_status_active",
  "hide_status_disabled",
  "hide_status_archived",
  "hide_status_found",
  "hide_status_not_found",
  "hide_status_owned",
  "hide_flagged_parents",
  "hide_flagged_children",
  "hide_selected",
  "private_hide",
  "hide_finals_family",
  "animation",
  "mark_userflagged_parents",
  "mark_userflagged_children",
  "spider",
  "circles"                     // circles je třeba mít dole, aby se vrstva nepřekreslovala x-krát (překresluje se po každém toggleSetting)
].forEach(function(str)
{
  if (settings[str])
    toggleSetting(str, "add");  
});

var setCenterZoomFromCaches = function()
{
  var allCoords = _caches_.getAllValidCoords();
  
  // pokud nemáme žádné kešky, taktéž souřadnice nepřenastavujeme
  if (allCoords.length)
  {
    // based on number of points, either zoom to reference point (large number of points) or show all (small number of points) 
    if (allCoords.length > 350 && window.refLat && window.refLon)
    {
      // get current reference point
      var referencePoint = SMap.Coords.fromWGS(parseFloat(refLat), parseFloat(refLon));
  
      // get nearest zoom of this map to mapy.cz ophoto map, zoom level 11
      var nearestZoom = m.getNearestZoom({layerFrom: SMap.DEF_OPHOTO, zoomFrom: 11, layerTo: settings.map});
      m.setCenterZoom.apply(m, [referencePoint, nearestZoom]);
    }
    else
      m.setCenterZoom.apply(m, m.computeCenterZoom(allCoords));
  }

  load_map();
}
