SMap.Control.CenterImage = JAK.ClassMaker.makeClass(
{
	NAME: "SMap.Control.CenterImage",
	VERSION: "1.0",
	EXTEND: SMap.Control.Visible
});

SMap.Control.CenterImage.prototype.$constructor = function(options)
{
	this.$super();
  
	this._options = 
  {
		src: "",
		width: 16,
    height: 16,
    startVisible: false
	}
  
	for (var p in options) { this._options[p] = options[p]; }

  this._build();
}

SMap.Control.CenterImage.prototype._build = function()
{
  var options = {width: this._options.width, height: this._options.height, src: this._options.src, alt: ""};
  var css = {pointerEvents: "none", display: "none", zIndex: 0}; 
	this._dom.container = JAK.mel("img", options, css);
  disableDragging(this._dom.container);
    
  if (this._options.startVisible)
    this.activate();
}

SMap.Control.CenterImage.prototype.setOwner = function(owner)
{
	this.$super(owner);
	if (!owner) { return; }

  this._sc.push(this.getMap().getSignals().addListener(this, "map-resize", "_setToCenter"));
  this._setToCenter();
}

SMap.Control.CenterImage.prototype._setToCenter = function()
{
  var sizeHalf = this.getMap().getSize().clone().scale(1/2);
  var iconHalf = (new SMap.Pixel(this._options.width, this._options.height)).scale(1/2);    
	this._dom.container.style.left = Math.round(sizeHalf.x - iconHalf.x) + "px";    
  this._dom.container.style.top = Math.round(sizeHalf.y - iconHalf.y) + "px"; 
}

SMap.Control.CenterImage.prototype.activate = function()
{
	this._dom.container.style.display = "";
}

SMap.Control.CenterImage.prototype.deactivate = function()
{
	this._dom.container.style.display = "none";
}