mapHistory = JAK.ClassMaker.makeClass(
{
	NAME: "mapHistory",
	VERSION: "3.0"
});

mapHistory.prototype.$constructor = function(map)
{
	this._ec = [];
	this._sc = [];
  this.map = map;
  this.stack = [];
  
  // vchoz stav (vi ktermu pak budeme pi aktivaci handler porovnvat)
  this.last =
  {
    zoom: this.map.getZoom(),
    mapId: this.map.CurrentMapId || settings.map,//this.map.CurrentMapId je ped enablovnm vrstvy s mapou undefined
    orientation: this.map.getOrientation(),
    center: this.map.getCenter()
  }

  this._createHandlers();
}

mapHistory.prototype.$destructor = function()
{
  this._removeHandlers();
}

mapHistory.prototype._createHandlers = function()
{
  this._sc.push(this.map.getSignals().addListener(this, "map-redraw-before", "_save"));        /* zoom change, map move */
  this._sc.push(this.map.getSignals().addListener(this, "layer-switch-click-after", "_save")); /* layer switch */
  this._sc.push(this.map.getSignals().addListener(this, "map-switch", "_save"));               /* map switch */
}  

mapHistory.prototype._removeHandlers = function()
{
  JAK.Events.removeListeners(this._ec);
  this.map.getSignals().removeListeners(this._sc);
}

// intern funkce pro uloen stavu mapy (zoom, typ mapy, orientace, sted)
mapHistory.prototype._save = function()
{
  // fix: prohlee (krom IE) hod jedno map-redraw-before jet ped nastavenm CurrentMapId
  if (typeof this.map.CurrentMapId === 'undefined')
    return;

  var now =
  {
    zoom: m.getZoom(),
    mapId: m.CurrentMapId,
    orientation: m.getOrientation(),
    center: m.getCenter()
  };

  // nic se nezmnilo? --> neulome
  if (now.zoom == this.last.zoom 
   && now.mapId == this.last.mapId 
   && now.orientation == this.last.orientation 
   && now.center.equals(this.last.center))
    return;
    
  this.stack.push({state: this.last, callback: this._restore.bind(this)});
  //log(["save", this.last.zoom, this.last.mapId, this.last.orientation, this.last.center.format()]);
  this.last = now;
}

// intern funkce pro navrcen stavu mapy
mapHistory.prototype._restore = function(state)
{
  this._removeHandlers();         // po dobu obnovovn stavu vypneme ukldn historie

  // change map type?
  if (state.mapId != this.map.CurrentMapId)
     this.map.switchMap(state.mapId);
     
  if (state.zoom != this.map.getZoom())
    this.map.setZoom(state.zoom, null, false /* vypnut animace */);

  // orientace (problm: se zaplou animac tam probhne timeout, kter m za nsledek nechtn save)  
  if (state.orientation != this.map.getOrientation())
    this.map.setOrientation(state.orientation, false /* vypnut animace */);

  if (!state.center.equals(this.map.getCenter()))
    this.map.setCenter(state.center);
  
  this.last = state;
  //log(["restore", this.last.zoom, this.last.mapId, this.last.orientation, this.last.center.format()]);    
  this._createHandlers();
}  

// veejn funkce, kter umouje uivateli poslat vlastn data k uloen v historii
// -- entry m tvar: {state: stav ped zmnou, callback: funkce provdjc restore}
mapHistory.prototype.save = function(entry)
{
  this.stack.push(entry);
}

// funkce provdjc restore (volan z vnjku, typicky po zmaknut CTRL+Z)
mapHistory.prototype.restore = function()
{
  var entry = this.stack.pop();
  
  if (entry)
    entry.callback(entry.state);
}

// funkce, kter z vrchu historie odstran posledn stav
mapHistory.prototype.pop = function()
{
  this.stack.pop();
}