var processKeys = function(key, e)
{
  // Y - display marker bubble and hide it on next Y press
  if (key == "Y" && !e.ctrlKey)
    toggleSetting("bubble", "toggle");
        
  // X - hide all markers (and show them on next X press)
  // if any WP is selected, then don't hide it and its family
  else if (key == "X" && !e.ctrlKey)
    toggleSetting("hide_all", "toggle");
  
  // C - hide all children (and show them on next C press)
  else if (key == "C" && !e.ctrlKey)
    toggleSetting("hide_children", "toggle");

  // P - hide all parents (and show them on next P press)
  else if (key == "P" && !e.ctrlKey)
    toggleSetting("hide_parents", "toggle");
    
  // SHIFT+CTRL+ALT + P - hide checked children for not found + unchecked children for found + unchecked parking areas 
  else if (key == "P" && e.ctrlKey && e.shiftKey && e.altKey)
    toggleSetting("private_hide", "toggle");

  // L - draw lines from parent to children  
  else if (key == "L" && !e.ctrlKey)
    toggleSetting("spider", "toggle");
    
  // R - draw 161m radius around physical points (Traditional Cache, FL, ST)
  else if (key == "R" && !e.ctrlKey && !e.shiftKey && !e.altKey)
    toggleSetting("circles", "toggle");
    
  // SHIFT + A - display/hide marker animation
  else if (key == "A" && e.shiftKey && !e.ctrlKey && !e.altKey)
    toggleSetting("animation", "toggle");

  // Q - copy (IE) or select text in coordinate box
  else if (key == "Q" && !e.ctrlKey && !e.shiftKey && !e.altKey)
    window.copyCoordinates && window.copyCoordinates();
    
  // SHIFT + Q - reset map settings
  else if (key == 'Q' && e.shiftKey && !e.ctrlKey && !e.altKey)
    mapCookies.resetSettings();
    
  // A - refresh map (in GSAK)
  else if (key == 'A' && !e.shiftKey && !e.ctrlKey && !e.altKey && window.isGSAK && JAK.Browser.embedded)
  {
    window.location.href = "gsak://%FF/macro:silent/HTML_Keskomapa.gsk";
  }
  
  // CTRL+A - vybereme všechny kešky
  else if (key == 'A' && !e.shiftKey && e.ctrlKey && !e.altKey && window._caches_)
  {
    if (!window.polygon || !window.polygon.polygonModeOn)
    {
      _caches_.selectAll();
      EventUtil.preventDefault(e); /* nefunguje v GSAKu :( */
      //EventUtil.stopPropagation(e);
      EventUtil.deselect();          // aby IE vše nevybral
    }
  }    
  
  // W - display/hide coordinate box
  else if (key == "W" && !e.ctrlKey)
    toggleSetting("coordinates_box", "toggle");
    
  // U - polygon marker bubble (created here for simplicity)
  else if (key == "U" && !e.ctrlKey)
    toggleSetting("polygon_bubble", "toggle");
    
  // I - invert selection
  else if (key == "I" && !e.ctrlKey && !e.shiftKey && !e.altKey && (!window.polygon || !window.polygon.polygonModeOn) && window._caches_)
    _caches_.invertSelected();
};

var onKeypress = function(e, target)
{
  if (contains_class(document.body, "lightbox_on"))
    return;

  var keyCode = EventUtil.getCharCode(e);
  var key = String.fromCharCode(keyCode).toUpperCase();
  
  //log("keypress: " + key + " - " + keyCode);
   
  // IE doesn't fire keydown while loading map tiles (which is problem for ZM10 and Freemap.sk)
  // - so we process some keys here, other keys still don't work
  if (JAK.Browser.client == "ie")
    processKeys(key, e);     
    
};

var onKeydown = function(e, target)
{
  if (contains_class(document.body, "lightbox_on"))
    return;

  var key = String.fromCharCode(e.keyCode).toUpperCase();
  //log("keydown: " + key + " - " + e.keyCode);
  
  // CTRL + Z (+ ALT in polygon mode)  - history back
  if (key == 'Z' && e.ctrlKey && !e.shiftKey 
  && (e.altKey || (!window.polygon || !window.polygon.polygonModeOn)))
  {
    _history_.restore();
    EventUtil.preventDefault(e);
    EventUtil.stopPropagation(e);      
  }
                                         
  // CTRL - display marker bubble
  if (e.ctrlKey && !contains_class(mapadiv, "key_down_ctrl"))
    add_class(mapadiv, "key_down_ctrl");
  
  // ALT  
  else if (e.altKey && !contains_class(mapadiv, "key_down_alt"))
    add_class(mapadiv, "key_down_alt");
    
  // SHIFT
  else if (e.shiftKey && !contains_class(mapadiv, "key_down_shift"))
  {log("adding shift");
    add_class(mapadiv, "key_down_shift");
  }

  // spacebar
  else if (e.keyCode == 32)
  {
    if ((!window.polygon || !window.polygon.polygonModeOn) && !window.spacebar_keydown)
    {
      toggleSetting("bubble", "toggle");
      EventUtil.preventDefault(e);
      window.spacebar_keydown = true;
    }
  }    
    
  // ESCAPE - close card, restore orientation to north, remove all selected
  else if (e.keyCode == 27)
  {
    if (document.querySelector(".card"))
    {
      m.removeCard();
      return;
    }

    else if (m.getOrientation() != SMap.NORTH/* && (!window.polygon || !window.polygon.polygonModeOn)*/)
    {
      m.setOrientation(SMap.NORTH);
      return;
    }

    else if (window._caches_ && _caches_.getSelected().length && (!window.polygon || !window.polygon.polygonModeOn))
    {
      _caches_.deselectAll();
      return;
    }
  }
  
  // TAB - iterate over points
  // CTRL or SHIFT + TAB iterates over parents only (CTRL doesn't work in Chrome)
  else if (e.keyCode == 9 && (!window.polygon || !window.polygon.polygonModeOn) && window._caches_)
  {
    // získáme pole souřadnic
    var coords = (e.shiftKey || e.ctrlKey) ? _caches_.getAllParentCoords() : _caches_.getAllCoords();
    var coords2 = coords.clone();
    var center = m.getCenter();
    
    if (!coords.length)
      return;
    
    // seřadíme dle vzdálenosti od aktuálního středu (abychom tak odhadli minulé souřadnice, kde skončil TAB)
    coords2.sort(function(c1, c2)
    {
      var dist1 = center.distance(c1, {quick: true});
      var dist2 = center.distance(c2, {quick: true});
      return dist1 - dist2;
    });
    
    // najdeme jejich polohu v neseřazeném poli souřadnic a přejdeme o index výš
    var index = coords.indexOf(coords2[0]) + 1;     
    index %= coords.length;                         /* pokud jsme na konci, tak přejdeme na začátek */
    
    m.setCenter(coords[index]);

    EventUtil.preventDefault(e);
    EventUtil.stopPropagation(e);
  }

  // ; - opens map in a browser  
  else if ((e.keyCode == 192 || e.keyCode == 59 /* Firefox */) && (!window.isGeoSetter || e.shiftKey /* v GeoSetteru SHIFT+; */))
  {
    window.open(location.href);
  }
  
  // ENTER - switch between all-screen map and small map  
  else if (e.keyCode == 13 && !e.ctrlKey && !e.shiftKey && !e.altKey)
    toggleSetting("allscreen", "toggle");
    
  // SHIFT + DELETE - delete selected points (upon asking)  
  else if (e.keyCode == 46 && !e.ctrlKey && e.shiftKey && !e.altKey && (!window.polygon || !window.polygon.polygonModeOn) && window._caches_)
  {
    _caches_.deleteSelected();      
  }

  else if (JAK.Browser.client != "ie")
    processKeys(key, e);         
};

var onKeyup = function(e, target)
{
  if (contains_class(document.body, "lightbox_on"))
    return;  
 
  var key = String.fromCharCode(e.keyCode).toUpperCase();
  //log("keyup: " + key + " - " + e.keyCode);  
  
  // CTRL - hide marker bubble
  if (e.keyCode == 17)
    resetCtrlAltShift("ctrl");    
    
  // ALT
  else if (e.keyCode == 18)
    resetCtrlAltShift("alt"); 
    
  // SHIFT
  else if (e.keyCode == 16)
    resetCtrlAltShift("shift");

  // spacebar
  else if (e.keyCode == 32)
  {
    if ((!window.polygon || !window.polygon.polygonModeOn))
    {
      toggleSetting("bubble", "toggle");
      delete window.spacebar_keydown;
    }
  }    
};

var resetCtrlAltShift = function(type)
{
  if (!type || type == "ctrl")
    remove_class(mapadiv, "key_down_ctrl");
  if (!type || type == "alt")
    remove_class(mapadiv, "key_down_alt");
  if (!type || type == "shift")
    remove_class(mapadiv, "key_down_shift");
}