  //"use strict";
  
  document.title = "Keškomapa";
  
  // on first launch, after changing SplitScreen format in GSAK using dropdown menu, window object is messy and fails, so relaunch
  try
  {
    window.launchTest = window.launchTest || [];
  } catch(ex)
  {
    window.location.href = "gsak://%FF/macro/HTML_Keskomapa.gsk";
  }

  var mapadiv = document.getElementById("mapadiv");

//   if (mapadiv.clientHeight < 20)
//     alert([mapadiv.clientWidth, mapadiv.clientHeight]);

  // IE7-8 -- disable dragging of images
  if (JAK.Browser.client == "ie" && JAK.Browser.version <= 8)
    mapadiv.ondragstart = function() {return false;}  
  
  // alert("Verze IE: " + JAK.Browser.version);

  // fix some initial stuff
  var cachecode = window.cachecode || "";
  
  try
  {
    cachecode = decodeURIComponent(cachecode);
  }
  catch(ex)  /* GSAK incorrectly exports to URI some characters, let's fix it if the above fails */
  {        
    cachecode = cachecode.replace(/%91/g, '%E2%80%98'); // fixing character ‘
    cachecode = cachecode.replace(/%92/g, '%E2%80%99'); // fixing character ’
    cachecode = decodeURIComponent(cachecode);
  };  

  // check whether we can animate markers
  var doc = document.documentElement;
  
//   var supportsAnimation = (!!cssProperty("animation") && JAK.Browser.client != "opera");
//   add_class(doc, (supportsAnimation ? "" : "no_") + "css_animation");  
  
  // supports transform?
  var supportsTransform = !!cssProperty("transform");
  add_class(doc, (supportsTransform ? "" : "no_") + "css_transform");

  // supports transition?
  var supportsTransition = !!cssProperty("transition");
  add_class(doc, (supportsTransition ? "" : "no_") + "css_transition");

  // detekce GSAKu
  window.isGSAK = !!window.isGSAK;

  if (!window.isGSAK)
    add_class(doc, "notGSAK");
    
  window.gsakTwoColumnsMode = contains_class(document.body, "gsakTwoColumnsMode");  
  
  // detekce GeoSetteru
  window.isGeoSetter = !!window.isGeoSetter;

  if (window.isGeoSetter)
    add_class(doc, "isGeoSetter");
  
  // detekce embedded verze  
  if (window.isGSAK || window.isGeoSetter)
    JAK.Browser.embedded = true;  
  
  if (JAK.Browser.client == "ie" /*&& JAK.Browser.version <= 11*/)   /* detekce dle různých parametrů, nefunguje v IE8 */
  {
    if (window.doNotTrack || window.msDoNotTrack || window.msPointerEnabled || window.pointerEnabled)
      JAK.Browser.embedded = false;
  }  
  else if (JAK.Browser.client != "ie")                               /* pokud není prohlížeč IE, tak není nikdy embedded */
  {
    JAK.Browser.embedded = false;
  }

  // show logger when testing
  if (window.testing)
    add_class(document.documentElement, "testingMode");    

  // set ie version (for animations)
  if (JAK.Browser.client == "ie")
  {
    if(JAK.Browser.version <= 8)
      add_class(doc, "ie_lte8");
      
    add_class(doc, "ie" + JAK.Browser.version);
  }
  
  add_class(doc, JAK.Browser.client);

  //*******************************************************************************************************************
    
  var translations = 
  {
    /* mapy.cz control names */
    "Change Map" : {"Czech": "Změnit mapu"},    
    "World" : {"Czech": "Svět"}, 
    "Country" : {"Czech": "Státy"},
    "State" : {"Czech": "Kraje"},
    "County" : {"Czech": "Města"},
    "Town" : {"Czech": "Obce"},
    "Street" : {"Czech": "Ulice"},
    "House" : {"Czech": "Domy"},
    "Zoom In" : {"Czech": "Přiblížit"},
    "Zoom Out" : {"Czech": "Oddálit"},
    
    /* bubble */
    "Open in GSAK" : {"Czech": "Otevřít v GSAKu"},
    "Open in Browser" : {"Czech": "Otevřít v prohlížeči"},
    
    "Has Comment" : {"Czech": "Obsahuje komentář"},    
      
    // sidebar
    "Filter" : {"Czech": "&nbsp;Filtr&nbsp;"},
    
    // copy button
    "Copy": {"Czech": "Zkopírovat"},
    "Select": {"Czech": "Označit text"},
    
    // coordinates box
    "Degrees" : {"Czech": "Stupně"},
    "Minutes" : {"Czech": "Minuty"},
    "Seconds" : {"Czech": "Vteřiny"},
    "Elevation" : {"Czech": "Nadmořská výška"},
    _coords_box_help :  {"English": "Press Q to open copy window.", "Czech": "Pro otevření kopírovacího okénka zmačkni Q."},    
    
    // ui
    "Close" : {"Czech": "Zavřít"},
      
    translate: function(str)
    {
      // 1 - try current GSAK language, 2 - try English, 3 - don't translate (return original argument)
      if (this[str])
      {
        if (typeof this[str][language] !== 'undefined')          // předklad do aktuálního jazyka
          return this[str][language];
        else if (typeof this[str]["English"] !== 'undefined')    // pokud není překlad dostupný, tak zkusíme angličtinu
          return this[str]["English"];
      }

      return str;                                        // pokud není překlad dostupný, tak vrátíme původní řetězec
    }
  };

  function tr(str)
  {
    return(translations.translate(str));
  }
   
  //*******************************************************************************************************************
  
  var transparentLayers =
  {
    hybrid: SMap.DEF_HYBRID, trail: SMap.DEF_TRAIL, bike: SMap.DEF_BIKE, relief: SMap.DEF_RELIEF, ortofoto: "MapyCZ_OPHOTO_Sub",
    g_hybrid: "GHybrid_ID", g_streetview: "GStreetView_ID", pano: "pano_ID",
    relief2: "Relief2_ID", g_terrain: "LandShading_ID", g_ortofoto: "GSatelliteSub_ID",
    vrstevnice: "Vrstevnice_ID", boundaries: "Boundaries_ID", morf: "GeomorfologickeCelkySub_ID",
    katastr: "Katastr", def_body_budov: "DefinicniBodyBudov", def_body_parcel: "DefinicniBodyParcel", bodova_pole: "BodovaPole_ID",
    geocaches: "GeocachesMap_ID"
  }
  
  var layers_to_add = 
  [
    SMap.DEF_SMART_OPHOTO,
    SMap.DEF_TURIST,
    SMap.DEF_TURIST_WINTER,
    SMap.DEF_SUMMER,
    SMap.DEF_GEOGRAPHY,    
    SMap.DEF_BASE,
    //"myin",        
    "Orto_CZ_ID",
    "ZM10_ID",
    "ZM10_SJTSK_ID",
    "GSatellite_ID",
    "GMaps_ID",
    "GTerrain_ID",
    "MapBoxTerrain_ID",
    "OSM_ID",    
    "OSMCyclo_ID",
    "MTBMap_ID",
    //"OpenTopoMap_ID",
    "ZABAGED_ID",
    "IZS_ID",
    "Vojenska_ID",    
    "DigitalniModelUzemi_ID",
    "FreemapSK_ID",
    "ZBGIS_SK_ID",
    SMap.DEF_HISTORIC,
    "VojMapIII_ID",
    "Muller_ID", 
    "GeomorfologickeCelky_ID",
    "ZM10_SK_ID",
    "Ortofoto_SK_ID",
    "Poland_Topo_ID",
    "Poland_Orto_ID",
    "Orto_1998_2002_ID",
    SMap.DEF_OPHOTO0203,
    "Orto_2003_2005_ID",
    SMap.DEF_OPHOTO0406,
    "Orto_2006_2008_ID",
    "Orto_2009_2011_ID",
    "Orto_2012_2013_ID"

    //"Automapa_ID",
  ];
  
  if (window.addExtraLayers)
    window.addExtraLayers();
  
  // get settings from cookie
  function default_settings()
  { 
    var tl = this.transparent_layers = {};

    tl[SMap.DEF_BASE] =         {trail: 0, bike: 0, relief: 0, ortofoto: 0, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, vrstevnice: 0, bodova_pole: 0};
    //this.transparent_layers[SMap.DEF_SMART_BASE] =   {hybrid: 0, trail: 0, bike: 0, relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, bodova_pole: 0};
    tl[SMap.DEF_TURIST] =       {trail: 1, bike: 1, relief: 0, ortofoto: 0, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, bodova_pole: 0};
    tl[SMap.DEF_TURIST_WINTER] ={trail: 0, bike: 0, relief: 0, ortofoto: 0, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, bodova_pole: 0};
    tl[SMap.DEF_SUMMER] =       {bike: 0, relief: 0, ortofoto: 0, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, bodova_pole: 0};
    tl[SMap.DEF_GEOGRAPHY] =    {trail: 0, bike: 0, relief: 0, ortofoto: 0, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, bodova_pole: 0};
    //tl[SMap.DEF_SMART_TURIST] = {hybrid: 0, trail: 1, bike: 1, relief: 0};
    tl[SMap.DEF_OPHOTO] =       {hybrid: 1, trail: 1, bike: 1, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, relief2: 0, vrstevnice: 0, katastr: 0, def_body_budov: 0, def_body_parcel: 0, bodova_pole: 0};
    tl[SMap.DEF_SMART_OPHOTO] = {hybrid: 1, trail: 1, bike: 1, pano: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, relief2: 0, vrstevnice: 0, katastr: 0, def_body_budov: 0, def_body_parcel: 0, bodova_pole: 0};
    tl[SMap.DEF_HISTORIC] =     {hybrid: 0, trail: 0, bike: 0, relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0};

    tl["GSatellite_ID"] =       {relief2:0, trail: 0, bike: 0, pano: 0, g_terrain: 0, geocaches: 0, g_hybrid: 1, g_streetview: 0, boundaries: 0, morf: 0, vrstevnice: 0, katastr: 0, def_body_budov: 0, def_body_parcel: 0, bodova_pole: 0};
    tl["GMaps_ID"] =            {relief: 0, trail: 0, bike: 0, pano: 0, g_ortofoto: 0, g_terrain: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, vrstevnice: 0, bodova_pole: 0};
    tl["GTerrain_ID"] =         {relief: 0, trail: 0, bike: 0, pano: 0, g_ortofoto: 0, g_terrain: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, bodova_pole: 0};
    tl["MapBoxTerrain_ID"] =    {relief: 0, trail: 0, bike: 0, pano: 0, g_ortofoto: 0, g_terrain: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, bodova_pole: 0};
    tl["OSM_ID"] =              {relief: 0, trail: 0, bike: 0, pano: 0, g_ortofoto: 0, g_terrain: 0, geocaches: 0, g_hybrid: 0, g_streetview: 0, boundaries: 0, morf: 0, vrstevnice: 0, bodova_pole: 0};
    tl["OSMCyclo_ID"] =         {relief: 0, trail: 0, bike: 0, pano: 0, g_ortofoto: 0, g_terrain: 0, geocaches: 0, g_hybrid: 0, g_streetview: 0, boundaries: 0, morf: 0, bodova_pole: 0};
    tl["MTBMap_ID"] =           {relief: 0, g_ortofoto: 0, geocaches: 0, g_hybrid: 0, g_streetview: 0, boundaries: 0, morf: 0, bodova_pole: 0};
    tl["OpenTopoMap_ID"] =      {relief: 0, g_ortofoto: 0, geocaches: 0, g_hybrid: 0, g_streetview: 0, boundaries: 0, morf: 0, bodova_pole: 0};
    tl["FreemapSK_ID"] =        {relief: 0, g_ortofoto: 0, geocaches: 0, g_hybrid: 0, g_streetview: 0, boundaries: 0, bodova_pole: 0};

    tl["ZM10_ID"] =                {relief: 1, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 1, bike: 1, pano: 0, ortofoto: 0, hybrid: 0, bodova_pole: 0};
    tl["ZM10_SJTSK_ID"] =          {relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, ortofoto: 0, bodova_pole: 0};
    tl["VojMapIII_ID"] =           {relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, ortofoto: 0, hybrid: 0, bodova_pole: 0};
    tl["Orto_CZ_ID"] =             {relief2:0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, hybrid: 0, katastr: 0, def_body_budov: 0, def_body_parcel: 0, vrstevnice: 0, bodova_pole: 0};
    tl["IZS_ID"] =                 {relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, ortofoto: 0, bodova_pole: 0};
    tl["Vojenska_ID"] =            {relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, ortofoto: 0, bodova_pole: 0};
    tl["Orto_50_ID"] =             {relief2:0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, ortofoto: 0, hybrid: 0, bodova_pole: 0};
    tl["ZABAGED_ID"] =             {relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, ortofoto: 0, hybrid: 0, bodova_pole: 0};
    tl["DigitalniModelUzemi_ID"] = {relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, ortofoto: 0, bodova_pole: 0};
    tl["GeomorfologickeCelky_ID"] ={relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0,          trail: 0, bike: 0, pano: 0, ortofoto: 0, hybrid: 0, bodova_pole: 0};
    tl["Automapa_ID"] =            {relief: 0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, ortofoto: 0, bodova_pole: 0};

    tl[SMap.DEF_OPHOTO0203] = {relief2:0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, hybrid: 0, katastr: 0, def_body_budov: 0, def_body_parcel: 0, vrstevnice: 0, bodova_pole: 0};
    tl[SMap.DEF_OPHOTO0406] = {relief2:0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, hybrid: 0, katastr: 0, def_body_budov: 0, def_body_parcel: 0, vrstevnice: 0, bodova_pole: 0};
    tl["Orto_1998_2002_ID"] = {relief2:0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, hybrid: 0, katastr: 0, def_body_budov: 0, def_body_parcel: 0, vrstevnice: 0, bodova_pole: 0};
    tl["Orto_2003_2005_ID"] = {relief2:0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, hybrid: 0, katastr: 0, def_body_budov: 0, def_body_parcel: 0, vrstevnice: 0, bodova_pole: 0};
    tl["Orto_2006_2008_ID"] = {relief2:0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, hybrid: 0, katastr: 0, def_body_budov: 0, def_body_parcel: 0, vrstevnice: 0, bodova_pole: 0};
    tl["Orto_2009_2011_ID"] = {relief2:0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, hybrid: 0, katastr: 0, def_body_budov: 0, def_body_parcel: 0, vrstevnice: 0, bodova_pole: 0};
    tl["Orto_2012_2013_ID"] = {relief2:0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, hybrid: 0, katastr: 0, def_body_budov: 0, def_body_parcel: 0, vrstevnice: 0, bodova_pole: 0};

    tl["Muller_ID"] =    {boundaries: 0, morf: 0};

    tl["ZBGIS_SK_ID"] =     {trail: 0, bike: 0, geocaches: 0, g_streetview: 0, g_ortofoto: 0, g_terrain: 0, boundaries: 0};
    tl["ZM10_SK_ID"] =      {trail: 0, bike: 0, geocaches: 0, g_streetview: 0, g_ortofoto: 0, g_terrain: 0, boundaries: 0};
    tl["Ortofoto_SK_ID"] =  {trail: 0, bike: 0, geocaches: 0, g_streetview: 0, hybrid: 0, boundaries: 0};

    tl["Poland_Topo_ID"] =       {trail: 0, bike: 0, geocaches: 0, g_streetview: 0, boundaries: 0, g_ortofoto: 0, relief: 0};
    tl["Poland_Orto_ID"] =       {trail: 0, bike: 0, geocaches: 0, g_streetview: 0, boundaries: 0, relief: 0, g_hybrid: 1};

    tl["myin"] =             {relief2:0, geocaches: 0, g_streetview: 0, boundaries: 0, morf: 0, trail: 0, bike: 0, pano: 0, hybrid: 0, katastr: 0, def_body_budov: 0, def_body_parcel: 0, vrstevnice: 0, bodova_pole: 0};


    this.startCoords = SMap.Coords.fromWGS(50, 14.8).format();
    this.zoom = 9;
    
    if (isGSAK)
      this.zoom = 17;
    
    this.orientation = SMap.NORTH;
    this.map = JAK.Browser.embedded ? SMap.DEF_SMART_OPHOTO : SMap.DEF_SUMMER;
    
    this.bubble = false;
    this.animation = true;
    this.circles = false;
    this.spider = false;
    this.scale = (JAK.Browser.client == "ie" && JAK.Browser.version <= 9) ? false : true;
    this.overview_map = false;
    this.compass = false;
    this.rosette = false;    
    this.coordinates_box = false;
    this.search_field = true;
    this.coordinate_grid = false;
    this.coordinate_grid_sjtsk = false;
    this.crosshair = false;
    this.poi_base = false;
    this.poi_tourist = false;
    this.allscreen = false;    
    
    this.private_hide = false;
    this.mark_userflagged_parents = false;
    this.mark_userflagged_children = false;
    this.hide_finals_family = false;
    
    this.hide_all = false;
    this.hide_children = false;
    this.hide_parents = false;

    this.hide_status_active = false;
    this.hide_status_disabled = false;
    this.hide_status_archived = false;

    this.hide_status_found = false;
    this.hide_status_not_found = false;
    this.hide_status_owned = false;

    this.hide_flagged_parents = false;
    this.hide_flagged_children = false;

    this.hide_selected = false;    
        
    this.version = window.map_version;
    this.streetview_width = 50 /* percent */;
    this.polygon_bubble = true;
    
    this.minimap_on = false;
    this.minimap_width = 250;
    this.minimap_height = 250;
    this.minimap_map = "_same_as_map";
    this.minimap_zoom = "-5";    
    
    if (window.gsakTwoColumnsMode)
    {
      this.minimap_width = 170;
      this.minimap_height = 170;
    }
    
    this.timer = 0;
  };

  //****************************

  var mapCookies = new function mapCookies()
  {
    this.cookieName = 'keskomapa_settings';
  
    this.compressStrings =
    [
      '_ID":{"relief2":0,"geocaches":0,"g_streetview":0,"boundaries":0,"morf":0,"trail":0,"bike":0,"pano":0,"hybrid":0,"katastr":0,"def_body_budov":0,"def_body_parcel":0,"vrstevnice":0,"bodova_pole":0},"',
      ',"katastr":0,"def_body_budov":0,"def_body_parcel":0',
      '"relief":0,"trail":0,"bike":0',
      ',"pano":0',
      '":false,"',
      ',"geocaches":0,"g_streetview":0,"boundaries":0,"morf":0',
      ',"bodova_pole":0',
      '":0,"',
      '":1,"',
      '":',
      ',"',
      '"'
    ];

    // unused in settings as of 12.4.2015: ~qLNQRUW
    // frequency analyzer: http://www.characterfrequencyanalyzer.com/english/tfa_results.php    
    this.dictionary = ["~", "q", "L", "N", "Q", "R", "WA", "WB", "WC", "WD", "WE", "WF", "WG", "WH", "WI", "WJ"];
    
    // **** encrypt cookie ****
    this.encrypt = function(cookie)
    {
      if (!cookie)
        return cookie;

      for (var i = 0; i < this.compressStrings.length; i++)
        cookie = cookie.replace(new RegExp(this.compressStrings[i], 'g'), this.dictionary[i]);
 
      return cookie;
    }
    
    // **** decrypt cookie ****
    this.decrypt = function(cookie)
    {
      if (!cookie)
        return cookie;

      for (var i = this.compressStrings.length - 1; i >= 0; i--)
        cookie = cookie.replace(new RegExp(this.dictionary[i], 'g'), this.compressStrings[i]);
        
      return cookie;
    }
    
    // **** load settings ****
    this.loadSettings = function()
    {
      // try proto, že při loadnutí jiné verze může být jiná dekryptovací funkce
      // -- a může se tedy dekryptovat na nesmysl, kde JSON.parse vyhodí chybu
      try
      {
        window.settings = JSON.parse(this.decrypt(read_cookie(this.cookieName)));
        
        if (window.settings.version != window.map_version
          || window.settings.reset)
          window.settings = new default_settings();
      }
      catch(e)
      {
        //log(this.decrypt(read_cookie(this.cookieName)));
        window.settings = new default_settings();
      };

      //window.settings = new default_settings();

      if(window.addToSettings)
        window.addToSettings(window.settings);

      // při testování zkontrolujeme, zda v cookie není nějaké nepovolené písmeno
      if (window.testing)
      {
        var _settings = JSON.stringify(window.settings);
      
        this.dictionary.forEach(function(entry)
        {
          if (_settings.indexOf(entry) != -1)
            throw "Cookie encrypt/decrypt: incorrect letter '" + entry + "'";
        });
      } 
    }
    
    // **** save settings ****
    this.saveSettings = function()
    {
      if (typeof m === 'undefined')
        return;
  
      // ** save settings **    
      settings.startCoords =  m.getCenter().format();
      settings.zoom = m.getZoom();
      settings.orientation = m.getOrientation();
      
      // minimap
      if (window.minimapExitSaveSettings)
        minimapExitSaveSettings();
        
      /*** measure time - start (unloading the page) ***/
      settings.timer = new Date().getTime();        
  
      this.writeSettings();
    }
    
    // *** write settings to cookie ***
    this.writeSettings = function()
    {
      //clear_cookie('gsak_mapycz_settings_' + window.map_version);
      clear_cookie('gsak_mapycz_settings');    /* old cookie */
      clear_cookie('timer');                   /* old cookie */
      clear_cookie(this.cookieName);
      write_cookie(this.cookieName, this.encrypt(JSON.stringify(settings)));

      //alert(escape(this.encrypt(JSON.stringify(settings))).length);
      //log((this.encrypt(JSON.stringify(settings))));
    }
    
    // *** reset settings to default + restart the map ***
    this.resetSettings = function()
    {
      // window.settings = new default_settings(); /* nefunguje ve Firefoxu */
      window.settings.reset = true;
      this.writeSettings();
      window.location.reload(true);
    }
    
    // **** save settings on exit and sometimes every second (when unload doesn't hit on exit) ****
    var that = this;

    EventUtil.addHandler(window, 'unload', function() { that.saveSettings(); });

    // Opera doesn't fire unload event, so use interval instead
    if (JAK.Browser.client == "opera" || JAK.Browser.client == "safari")
    {
      window.setInterval(function() { that.saveSettings(); }, 1000);
    }    
  };  
    
  mapCookies.loadSettings();  

  var settingsData = 
  {
    // ===========================================================
    "hide_all":
    {
      requires: [],
      on: function() { _caches_.forEach(function(){this.hide()}) },
      off: function() { _caches_.forEach(function(){this.unhide()}) }
    },

    // ===========================================================
    "hide_children":
    {
      on:  function() {    add_class(mapadiv, "cachesHideChildren") },
      off: function() { remove_class(mapadiv, "cachesHideChildren") }
    },
    
    // ===========================================================
    "hide_parents":
    {
      on:  function() {    add_class(mapadiv, "cachesHideParents") },
      off: function() { remove_class(mapadiv, "cachesHideParents") }
    },
    
    // ===========================================================
    "hide_status_active":
    {
      on:  function() {    add_class(mapadiv, "cachesHideActive"); },
      off: function() { remove_class(mapadiv, "cachesHideActive"); }
    },
        
    // ===========================================================
    "hide_status_disabled":
    {
      on:  function() {    add_class(mapadiv, "cachesHideDisabled"); },
      off: function() { remove_class(mapadiv, "cachesHideDisabled"); }
    },
    
    // ===========================================================    
    "hide_status_archived":
    {
      on:  function() {    add_class(mapadiv, "cachesHideArchived"); },
      off: function() { remove_class(mapadiv, "cachesHideArchived"); }
    },
    
    // ===========================================================
    "hide_status_found":
    {
      on:  function() {    add_class(mapadiv, "cachesHideFound"); },
      off: function() { remove_class(mapadiv, "cachesHideFound"); }
    },
    
    // ===========================================================
    "hide_status_not_found":
    {
      on:  function() {    add_class(mapadiv, "cachesHideNotFound"); },
      off: function() { remove_class(mapadiv, "cachesHideNotFound"); }
    },    
    
    // ===========================================================
    "hide_status_owned":
    {
      on:  function() {    add_class(mapadiv, "cachesHideOwned"); },
      off: function() { remove_class(mapadiv, "cachesHideOwned"); }
    },

    // ===========================================================
    "hide_flagged_parents":
    {
      on:  function() {    add_class(mapadiv, "cachesHideUserFlaggedParents"); },  // marker_hide_flagged_parents
      off: function() { remove_class(mapadiv, "cachesHideUserFlaggedParents"); }
    },
    
    // ===========================================================
    "hide_flagged_children":
    {
      on:  function() {    add_class(mapadiv, "cachesHideUserFlaggedChildren"); }, // marker_hide_flagged_children
      off: function() { remove_class(mapadiv, "cachesHideUserFlaggedChildren"); }
    },
    
    // ===========================================================
    "private_hide":   // private hide markers - hide parking areas, non-found flagged, found non-flagged
    {
      on:  function() {    add_class(mapadiv, "cachesHideSpecialPrivate"); },
      off: function() { remove_class(mapadiv, "cachesHideSpecialPrivate"); }
    },   
    
    // ===========================================================
    "hide_finals_family":   // hide all non-Final and non-CC members of a family (if there is at least one Final or CC)
    {
      on:  function() {    add_class(mapadiv, "cachesHideSpecialNonFinal"); },
      off: function() { remove_class(mapadiv, "cachesHideSpecialNonFinal"); }
    },
    
    // ===========================================================
    "hide_selected":
    {
      on:  function() {    add_class(mapadiv, "cachesHideSelected"); },
      off: function() { remove_class(mapadiv, "cachesHideSelected"); }
    },    
    
    // ===========================================================
    "mark_userflagged_parents":  // circle around flagged
    {
      on:  function() {    add_class(mapadiv, "cachesCircleUserFlaggedParents") },
      off: function() { remove_class(mapadiv, "cachesCircleUserFlaggedParents") }
    },
    
    // ===========================================================
    "mark_userflagged_children":
    {
      on:  function() {    add_class(mapadiv, "cachesCircleUserFlaggedChildren") },
      off: function() { remove_class(mapadiv, "cachesCircleUserFlaggedChildren") }
    },

    // ===========================================================
    "animation":
    {
      on:  function() {    add_class(mapadiv, "cachesAnimation") },
      off: function() { remove_class(mapadiv, "cachesAnimation") }
    },
    
    // ===========================================================
    "bubble":
    {
      on:  function() {    add_class(mapadiv, "cachesSimpleBubbleOn"); _caches_._createSimpleBubbles();},
      off: function() { remove_class(mapadiv, "cachesSimpleBubbleOn")}
    },

    // ===========================================================
    "polygon_bubble":
    {
      on:  function() {    add_class(mapadiv, "marker_polygon_bubble") },
      off: function() { remove_class(mapadiv, "marker_polygon_bubble") }
    },
    
    // ===========================================================
    "circles":
    {
      requires: [],
      
      on: function()
      {
        _caches_.circlesInit();
      },
    
      off: function()
      {
        _caches_.circlesExit();
      }
    },    

    // ===========================================================
    "spider":
    {
      requires: [],

      on: function()
      {
        _caches_.spiderInit();
      },
    
      off: function()
      {
        _caches_.spiderExit();
      }      
    },
      
    // ===========================================================
    "search_field":
    {
      requires: [basePath + "search_field.css", basePath + "search_field.js"],
      
      on: function()
      {
        load_search_field();
        window.search_field.style.visibility = "visible";     // we are using display property elsewhere, so use visibility here
      },
    
      off: function()
      {
        window.search_field.style.visibility = "hidden";
      }
    },

    // ===========================================================
    "coordinates_box":
    {
      requires: [basePath + "coordinates_box.css", basePath + "coordinates_box.js"],
      
      on: function()
      {
        load_coordinates_box();
        window.coordinates_box.style.visibility = "visible";  // we are using display property elsewhere, so use visibility here
        createDefaultMapControls();                           // if overview map is visible, push it up
      },
    
      off: function()
      {
        window.coordinates_box.style.visibility = "hidden";
        createDefaultMapControls();                           // if overview map is visible, push it up
      }
    },

    // ===========================================================
    "overview_map":
    {
      requires: [],
      on: createDefaultMapControls,
      off: createDefaultMapControls,
      initialized: true       /* aby při startu mapy a hodnoty v settings zaplé je šlo vypnout (jinak toggleSettings na vypnutí nereaguje) */
    },
    
    // ===========================================================
    "compass":
    {
      requires: [],
      on: createDefaultMapControls,
      off: createDefaultMapControls,
      initialized: true
    },
    
    // ===========================================================
    "rosette":
    {
      requires: [],
      on: createDefaultMapControls,
      off: createDefaultMapControls,
      initialized: true
    },    

    // ===========================================================
    "coordinate_grid":
    {
      requires: [basePath + "coordinate_grid.css", basePath + "coordinate_grid.js"],
      on:  function() { load_coordinate_grid(false); },
      off: function() { load_coordinate_grid(true); }    
    },

    // ===========================================================
    "coordinate_grid_sjtsk":
    {
      requires: [basePath + "coordinate_grid.css", basePath + "coordinate_grid.js"],
      on:  function() { load_coordinate_grid_sjtsk(false); },
      off: function() { load_coordinate_grid_sjtsk(true); }
    },
    
    // ===========================================================
    "scale":
    {
      requires: [],
      on: createDefaultMapControls,
      off: createDefaultMapControls,
      initialized: true
    },
    
    // ===========================================================
    "crosshair":
    {
      requires: [basePath + "crosshair.js"],

      on: function()
      {
        var options = {src: basePath + "Images/Crosshair/Crosshair.png", width: 16, height: 16, startVisible: true};
        window.crosshairControl = new SMap.Control.CenterImage(options);
        m.addControl(window.crosshairControl);        
      },
    
      off: function()
      {
        m.removeControl(window.crosshairControl);
        window.crosshairControl = null;
      }
    },
    
    // ===========================================================
    "poi_base":
    {
      requires: [seznamPath + "js/api/poi.js", basePath + "poi.js"],
      init: function() { fixPoi(); poiInit(SMap.MAPSET_BASE, m); },
      on: function() { poiOn(SMap.MAPSET_BASE); },
      off: function() { poiOff(SMap.MAPSET_BASE); }
    },
    
    // ===========================================================
    "poi_tourist":
    {
      requires: [seznamPath + "js/api/poi.js", basePath + "poi.js"],
      init: function() { fixPoi(); poiInit(SMap.MAPSET_TURIST, m); },
      on: function() { poiOn(SMap.MAPSET_TURIST); },
      off: function() { poiOff(SMap.MAPSET_TURIST); }
    },
    
    // ===========================================================
    "minimap_on":
    {
      requires: 
      [
        basePath + "context_menu.css",
        basePath + "context_menu.js",
        basePath + "minimap.css",
        basePath + "minimap.js"
      ],
      
      on: function()
      {
        startMinimap();
      },
    
      off: function()
      {
        closeMinimap();  // nemá efekt, o zavření se stará javascript handler v minimap.js
      }
    },    
    
    // ===========================================================
    "allscreen":
    {
      requires: [],
      
      _check: function() { return !!window.gsakTwoColumnsMode; },
      
      _addButton: function()
      {
        if (!this._check()) return;
    
        var options = {className: "allScreen_button", handler: function()
        {
          toggleSetting("allscreen", "toggle");
        }};
        
        m.addControl(new SMap.Control.Button(options), {right: "0px", top: "0px"});      
      },

      init: function()
      {
        if (!this._check()) return;
      
        window.savedMapHeight = mapadiv.style.height;
        
        // fix some sidebar buttons on window resize
        EventUtil.addHandler(window, "resize", function()
        {
          if (!contains_class(document.documentElement, "mapFull"))
            return;
        
          mapadiv.style.height = document.documentElement.clientHeight + "px";
        });              
      },

      on: function()
      {
        if (!this._check()) return;
          
        remove_class(document.body, "gsakTwoColumnsMode");
        document.body.appendChild(mapadiv);
        
        var cMenu = document.getElementById("contextMenu");
        var cMenuWP = document.getElementById("contextMenuWP");
        
        if (cMenu) document.body.appendChild(cMenu);
        if (cMenuWP) document.body.appendChild(cMenuWP);
       
        add_class(document.documentElement, "mapFull");
        mapadiv.style.height = document.documentElement.clientHeight + "px";
      
        if (window.svObjekt)          /* Street View */
          svObjekt.syncViewPort();
        
        if (window.polygon)
          window.polygon.textArea.syncViewPort();
        
        m.syncPort();
        createDefaultMapControls();
      },
    
      off: function()
      {
        if (!this._check()) return;

        add_class(document.body, "gsakTwoColumnsMode");
             
        var rightCol = document.getElementById("main_right_col");
        rightCol.insertBefore(mapadiv, rightCol.firstChild);
        remove_class(document.documentElement, "mapFull");
        mapadiv.style.height = window.savedMapHeight;
      
        if (window.svObjekt)
          svObjekt.syncViewPort();
      
        if (window.polygon)
          window.polygon.textArea.syncViewPort();
                
        m.syncPort();
        createDefaultMapControls();              
      }
    },
    
  };
  
  // parametry:
  // object: odkaz na třídu v SMap.Control (defaultně není zadáno, bere se SMap.Control[název objektu]
  // condition: pokud je zadáno, tak vrací zda prvek vytvořit nebo ne
  // options: zadávají se jako parametr při vytváření control
  // position: označují polohu na mapě
  // init: funkce volaná po vytvoření kontrol (parametrem je prvek)
  // exit: funkce volaná před odebráním control
  // update: zda prvek vytvářet opakovaně (tedy např. při resizu mapy) nebo jen jednou při startu, defaultně true
  // _???: privání parametry (volané z různých funkcí výše)
  // control: doplněno externě po vytvoření control

  _controls_ =
  {
    "Zoom":
    {
      condition: function() { return (_controls_.Layer._itemsOnOnePage() > 2) }, 
      options: 
      [
        {2: tr("World"), 5: tr("Country"), 8: tr("State"), 11: tr("County"), 14: tr("Town"), 17: tr("Street"), 20: tr("House")}, // labels
        {titles:[tr("Zoom In"), tr("Zoom Out")]}  
      ],
      position: {right: "15px", top: "50px"},
      exit: function(c) { c.removeZoomMenu() } // před voláním $destructor() je třeba zavolat toto
    },

    "Orientation_CCW":
    {
      object: SMap.Control.Orientation,
      condition: function() { return (_controls_.Layer._itemsOnOnePage() > 2 && (JAK.Browser.client != "ie" || JAK.Browser.version >= 9)) },  // rotace nefunguje v IE8
      options: [{mode: "ccw"}],
      position: {right: "50px",top: "15px"}
    },

    "Orientation_CW":
    {
      object: SMap.Control.Orientation,
      condition: function() { return (_controls_.Layer._itemsOnOnePage() > 2 && (JAK.Browser.client != "ie" || JAK.Browser.version >= 9)) },  // rotace nefunguje v IE8      
      options: [{mode: "cw"}],
      position: {right: "20px",top: "15px"}
    },

    "Layer":    /* musí být pod zoom a orientation, jen jimi bude překryto */
    {
      _itemWidth: 65,
      _leftOffset: 10,
      _itemsOnOnePage: function()
      {
        // generate number of items (so that we fit on the screen)    
        var margin_left = this._leftOffset + 8 + 12;  /* layer switch left: our margin + margin set by app + left arrow */
        var margin_right = 8; /* layer switch: right arrow */
    
        var available_width = mapadiv.offsetWidth - margin_left - margin_right;
        return Math.min(Math.floor(available_width / this._itemWidth) || 1, layers_to_add.length);
      },
      options: function()
      {
        var items = this._itemsOnOnePage();
        return [{items: items, page: items, width: this._itemWidth}]        
      },
      position: function(){ return {left: this._leftOffset + "px", top: "10px"} },
      init: function(c)
      {
        c.addMultipleDefaultLayers(layers_to_add);
    
        //for (var i = 0; i < layers_to_add.length; i++)
        //  c.addDefaultLayer(layers_to_add[i]);        /* nepoužívat, pokud se api stahuje z netu, budou špatně linky */
        
        // translate main caption    
        if (language != "Czech")
        {
          //document.querySelector('.layer-switch > button > span').innerHTML = tr("Change Map");
          c.getContainer().firstChild.firstChild.innerHTML = tr("Change Map");
        }
      }
    },    

    "Mouse":
    {
      options: [SMap.MOUSE_PAN + SMap.MOUSE_ZOOM + SMap.MOUSE_WHEEL],
      update: false
    },
  
    "Keyboard":
    {
      options: [SMap.KB_ZOOM | SMap.KB_PAN, {panAmount: (JAK.Browser.client == "opera") ? 250 : 40}],
      update: false
    },
  
    "ZoomNotification":    /* zoom square */
    {
      options: [],
      update: false
    },
    
    "Overview":
    {
      condition: function() { return settings.overview_map },
      options: [],
      position: function()
      {
        var bottom = settings.coordinates_box ? 110 : 25; // move upward if coordinate box visible
        return {right: "0px", bottom: bottom + "px"};
      },

      // make non-draggable
      init: function(c) { disableDragging(c.getContainer()) }
    },
    
    "Compass":
    {
      condition: function() { return settings.compass },
      options: [{title: ""}],
      position: {right: "15px", top: "90px"}
    },
    
    "Rosette":
    {
      condition: function() { return settings.rosette && (JAK.Browser.client != "ie" || JAK.Browser.version >= 9)},
      options: [{title: ""}],
      position: {right: "100px", top: "15px"}
    },
    
    "Scale":
    {
      condition: function() { return settings.scale },
      options: [],
      position: {left: "200px", bottom: "5px"}
    }
  }
  
  function createDefaultMapControls()
  {
    for (var name in _controls_)
    {
      var c = _controls_[name];

      // přeskočíme vytvořené prvky, které se nemají updatovat
      var update = ("update" in c) ? c.update : true /* default */;
            
      if (c.control && !update)
        continue;
      
      // pokud prvek existuje, tak ho nejdříve odebereme  
      if (c.control && update)
      {
        c.exit && c.exit.bind(c)(c.control);    /* voláme exit funkci, pokud existuje */
        
        // kvůli chybě v SMap.Control.Mouse.prototype._driftStep při tažení mapy myší a zároveň odstranění tohoto control
        // -- je třeba volat před odstraněním control, aby bylo control.getMap() dostupné (nejen pro Control.Mouse, ale i Control.Zoom)
        c.control.$destructor();

        m.removeControl(c.control);
        delete c.control;      
      }        

      // nevytváříme prvky s podmínkovou funkcí, která vrací false        
      if (c.condition && !c.condition.bind(c)())
        continue;
        
      // vytvoříme prvek (ten je buď zadán přímo jako c.object nebo použijeme název objektu)
      var object = c.object || SMap.Control[name];
      var options = Array.isArray(c.options || []) ? c.options : c.options.bind(c)();
      c.control = new object(options[0], options[1], options[2], options[3]);
      
      // voláme init funkci, pokud existuje
      c.init && c.init.bind(c)(c.control);
      
      // přidáme prvek do mapy
      var position = isObject(c.position || {}) ? c.position : c.position.bind(c)();
      m.addControl(c.control, position);
    }
  }
  
  
  // variables for map
  var startCoords;

  if (!cachecode || !window.wp)
    startCoords = SMap.Coords.fromString(settings.startCoords);
  else
    startCoords = SMap.Coords.fromWGS(window.wp[cachecode].Latitude, window.wp[cachecode].Longitude);

  var SMap_options = 
  {
    orientation: settings.orientation,
    minZoom: 0,                                       // zoom 0 nefunguje v konstruktoru, potřebujeme ho níže nastavit manuálně
    projection: SMap.CONFIG[settings.map].projection  // pokud není nastaveno, tak se center při zoomu 2 u S-JTSK WMTS map posune někam do Afriky
  };
  
  var m = new SMap(mapadiv, startCoords, settings.zoom || 1 /* 0 by byla přepsána na 6 :( */, SMap_options);

  // zoom 0 nefunguje v konstruktoru, nastavíme ho manuálně (v konstruktoru je třeb amít minZoom: 0)
  if (settings.zoom === 0)
    m.setZoom(0);

  // create default layers
  for (var i = 0; i < layers_to_add.length; i++)
    m.addDefaultLayer(layers_to_add[i]);

  // create transparent layers (last - so that they are not below)
  for (var layer in transparentLayers)
    m.addDefaultLayer(transparentLayers[layer]);  

  // set transparent layers on layer change 
  m.getSignals().addListener(window, "layer-change-before", function(e, elm)
  {
    var id = e.target;

    // save last map name to settings
    settings.map = id;

    // turn on/off transparent layers
    for (var layer in transparentLayers)
    {
      toggleSetting(layer, settings.transparent_layers[id][layer] ? "add" : "remove");
      //toggleSetting("transparent_layer", settings.transparent_layers[id][layer] ? "add" : "remove", layer);      
    }
  });

  // turn this on before activating the layer (otherwise the layer will be rendered twice - once by addControl below)
  m.addControl(new SMap.Control.Sync());

  window.setTimeout(function()   /* odložení kvůli loadování v GSAKu, tahle funkce zabere asi 50 ms */
  {
    toggleSetting("allscreen", settings.allscreen ? "add" : "remove");
    //toggleSetting("overview_map", settings.overview_map ? "add" : "remove");  // není už nutné, je v createDefaultMapControls
    //toggleSetting("scale", settings.scale ? "add" : "remove");
    toggleSetting("crosshair", settings.crosshair ? "add" : "remove");

    // turn on default map controls (+ re-generate them on window resize)
    createDefaultMapControls();
    EventUtil.addHandler(window, "resize", createDefaultMapControls);
    
    toggleSetting("coordinates_box", settings.coordinates_box ? "add" : "remove");
    toggleSetting("search_field", settings.search_field ? "add" : "remove");  
    toggleSetting("polygon_bubble", settings.polygon_bubble ? "add" : "remove");
  
    toggleSetting("coordinate_grid", settings.coordinate_grid ? "add" : "remove");
    toggleSetting("coordinate_grid_sjtsk", settings.coordinate_grid_sjtsk ? "add" : "remove");
    
    toggleSetting("poi_base", settings.poi_base ? "add" : "remove");
    toggleSetting("poi_tourist", settings.poi_tourist ? "add" : "remove");             
    
  }, 100);

//   // turn on layer
//   m.getLayer(settings.map).enable();


  //-----------------------------------------

  //********* misc processing *********//
  // get div of map area (element encompassing only map tiles)
  var mapAreaDiv = m.getContent();

  // set mouseenter to automatically focus (otherwise zooming may stop working after prompt or alt-tab)
  // -- don't set to mapAreaDiv (would unfocus search field on mouse leaving it)
  if (window.gsakTwoColumnsMode)
  EventUtil.addMouseHandler(document.documentElement, "mouseenter", function()
  {
    window.focus();
  });

  // set focus also on mousedown (fixes focus problems in SplitScreen mode, where onmouseover focus is turned off)
  JAK.Events.addListener(mapAreaDiv, 'mousedown', function(){window.focus();});

  // load context menu on hovering over map
  var loadContextMenuHandler = EventUtil.addHandler(mapadiv, 'mouseover', function()
  {
    require(
    [
      basePath + "context_menu.css",
      basePath + "context_menu.js",
      basePath + "search_field.css",
      basePath + "search_field.js"
    ]);

    EventUtil.removeHandler(loadContextMenuHandler);
    translate_strings();  
  });



  // set cursor (sometimes it doesn't update properly)
  document.getElementById("mapadiv").style.cursor = "move";
  
  //***************************************************************************
  //           ************** Keyboard handling **************
  //***************************************************************************

  var loadKeyboard = function(fnName, e, target)
  {
    require
    (
      //basePath + "main.js",
      basePath + "caches.js",
      basePath + "keyboard.js",
      function() { window[fnName](e, target) }
    )
  };

  EventUtil.addHandler(document.documentElement, 'keypress', function(e, target) { loadKeyboard("onKeypress", e, target) });
  EventUtil.addHandler(document.documentElement, 'keydown',  function(e, target) { loadKeyboard("onKeydown",  e, target) });
  EventUtil.addHandler(document.documentElement, 'keyup',    function(e, target) { loadKeyboard("onKeyup",    e, target) });
  
  // on window blur and focus, remove any active ALT/CTRL/SHIFT
  EventUtil.addHandler(window, "blur",  function(e, target) { loadKeyboard("resetCtrlAltShift") }); /* bez parametrů, aby funkce vše zrušila! */
  EventUtil.addHandler(window, "focus", function(e, target) { loadKeyboard("resetCtrlAltShift") });
  

  //***************************************************************************
  //                ************** Minimap **************
  //***************************************************************************
  var options = {className: "map_minimap_button", handler: function()
  {
    // start on click
    // -- tlačítko funguje jen při neaktivní minimapě, jinak odchytáváno jinde!
    toggleSetting("minimap_on", "toggle");
  }};

  m.addControl(new SMap.Control.Button(options), {right: "0px", bottom: "0px"});

  // load on start
  toggleSetting("minimap_on", settings.minimap_on ? "add" : "remove");

  // save settings on minimap exit
  function minimapExitSaveSettings()
  {
    settings.minimap_on = !!window.minimap;
    
    if (!settings.minimap_on)
      return;
  
    settings.minimap_width = window.minimap._options.width;
    settings.minimap_height = window.minimap._options.height;
    settings.minimap_map = window.minimap._options.map;
    
    var zoom = window.minimap._options.zoom;

    if (window.minimap._options.relativeZoom)
      zoom = (window.minimap._options.negativeZoomDif ? "-" : "+") + Math.abs(zoom);
  
    settings.minimap_zoom = zoom;
  }
  
  m.getSignals().addListener(window, "minimap-end", minimapExitSaveSettings);

  //***************************************************************************
  //                ************** Sidebar **************
  //***************************************************************************
  
//   var options = {className: "button", label: tr("Menu"), handler: function()
//   {
//     require(
//     [
//       basePath + "sidebar.js",
//       basePath + "sidebar.js",
//       initFileLoad,
//       function() { window.sidebarLoader(); }
//     
//     ]);
//   }};  
//   
//   m.addControl(new SMap.Control.Button(options), {left: "15px", bottom: "50px"});

  var sidebars_div = document.querySelector("#sidebars");
  
  // *** create menu button ***
  var sidebar_button = JAK.mel("div", {id: "menu_sidebar_button", className: "button sidebar_button", innerHTML: tr("Menu")});  
  sidebars_div.appendChild(sidebar_button);
  
  // *** create maps layers button ***
  translations["Layers"] = {"English": "Layer", "Czech": "Vrstvy"};
  var layers_button = JAK.mel("div", {id: "layers_sidebar_button", className: "button sidebar_button", innerHTML: tr("Layers")});  
  sidebars_div.appendChild(layers_button);  

  // *** create filter button ***
  var filter_button = JAK.mel("div", {id: "filter_sidebar_button", className: "button sidebar_button", innerHTML: tr("Filter")});  
  sidebars_div.appendChild(filter_button);  

  function initSidebar(e, elm)
  {
    EventUtil.removeHandler(sidebarHandler);
    EventUtil.removeHandler(layersSidebarHandler);
    EventUtil.removeHandler(filterHandler);
    
    require(
    [
      basePath + "caches.css",
      basePath + "caches.js",
      basePath + "sidebar.css",
      basePath + "sidebar.js",
      function() { window.sidebarLoader(e, elm); }
    ]);

    initFileLoad();
  }
  
  var sidebarHandler = EventUtil.addHandler(sidebar_button, "click", initSidebar);
  var layersSidebarHandler = EventUtil.addHandler(layers_button, "click", initSidebar);
  var filterHandler = EventUtil.addHandler(filter_button, "click", initSidebar);

  function toggleSetting(setting, type, params)
  {
    function boolChange(setting) {return ((type == "toggle") ? !setting : ((type == "add") ? 1 : 0));}
    function classChange() {return ((type == "toggle") ? toggle_class : ((type == "add") ? add_class : remove_class));}
    var checkbox = document.getElementById(setting + "_checkbox");
    params = params || {};

    var newVal;

    // transparent sub-layers
    if (setting in transparentLayers)
    {
      var map_id = transparentLayers[setting];

      // turn the layer off first
      m.getLayer(map_id).disable()
      
      var val = settings.transparent_layers[settings.map][setting];
      var turnOffTranspLayer = (typeof val === 'undefined');

      // nezapínáme vrstvu, pokud ji nelze transformovat
      if (!supportsTransform && !layersAreCompatible(settings.map, map_id))
        turnOffTranspLayer = true;

      // is sidebar loaded?
      if (checkbox)
        checkbox.parentNode.style.display = turnOffTranspLayer ? "none" : "";
      
      // transparent layer not available on this map
      if (turnOffTranspLayer)
        return;      

      val = boolChange(val);
      settings.transparent_layers[settings.map][setting] = val;

      if (val)
        m.getLayer(map_id).enable();

      newVal = val;
    }

    // defaultní
    else if (setting in settingsData)
    {
      //log("-------------------- " + setting + " ------------------------");
    
      var prop = setting;
      var on = newVal = boolChange(settings[setting]);   // změna hodnoty v settings
      var off = !on;
      var obj = settingsData[setting];
      
      if (setting in settings)        // pokud hodnota existuje v settings, pak updatujeme settings
        settings[setting] = on;

      // inicializujeme všechny proměnné
      obj.requires = obj.requires || [];
      obj.init = obj.init || function() {};
      obj.on = obj.on || function() {};
      obj.off = obj.off || function() {};
      
      // každou funkci budeme volat tak, abychom z ní mohli volat ostatní funkce
      obj.init.bind(obj);
      obj.on.bind(obj);
      obj.off.bind(obj);

      // první zapnutí (+ inicializace)
      if (on && !obj.initialized)
      {
        require(
        [
          obj.requires,
          function () { obj.init(params) },
          function() { obj.initialized = true; },
          function () { obj.on(params) }
        ]);
      }
      
      // zapnutí (pokud už proběhla inicializace)
      else if (on && obj.initialized)
      {
        obj.on(params);
      }
      
      // vypnutí (jen pokud proběhla inicializace)
      else if (off && obj.initialized)
      {
        obj.off(params);
      }
    }
    
    else
      throw("Incorrect parameter - " + setting);      

    // check/uncheck sidebar checkbox
    if (checkbox)
      checkbox.checked = newVal;
      
    // pro update kruhů kolem kešek
    if (window.m) m.getSignals().makeEvent("toggle-settings", this, {});
  }
  
  //***************************************************************************
  //                ************** Polygon **************
  //***************************************************************************
  
  // *** create sidebar button ***
  var polygon_button = JAK.mel("div", {id: "polygon_sidebar_button", className: "button sidebar_button", innerHTML: tr("Track")});  
  sidebars_div.appendChild(polygon_button);

  function initPolygon(e, elm)
  {
    EventUtil.removeHandler(polygonHandler);
    
    initFileLoad(function()
    {
      require(
      [
        basePath + "selection2.js",
        basePath + "polygon.css",
        basePath + "polygon.js",
        function(){ window.polygon.init() }
      ]);
    });
  };
  
  var polygonHandler = EventUtil.addHandler(polygon_button, "click", initPolygon);

  //***************************************************************************
  //                ************** Selections **************
  //***************************************************************************

  window.selections = [];

  var selectionsInit = function()
  {
    // add zoom selection control (CTRL version is for Opera to override gestures)
    if (!window.addedZoomRect)
    {
      window.addedZoomRect = true;
      m.addControl(new Selection.Rectangle.Zoom());
      m.addControl(new Selection.Rectangle.Zoom({ctrl: true}));
    }
    
//     if (!window._caches_)
//       return;
      
     require(basePath + "caches.js", function()
     {  
      // vytvoření všech osmi selection control
      window.selections = Selection.predefined_4.map(function(options)
      {
        return new Selection.Rectangle(
        {
          predefined: options,
          exit: _caches_.selectedProcess,
          context: _caches_
        })
      });
      
      window.selections = window.selections.concat(Selection.predefined_4.map(function(options)
      {
        return new Selection.Polygon(
        {
          predefined: options,
          exit: _caches_.selectedProcess,
          context: _caches_
        })
      }));
  
      window.selections.forEach(m.addControl.bind(m));
    });
 }; 

  function selectionsExit()
  {
    if (!window.selections)
      return;
    
    window.selections.forEach(function(c)
    {
      c.$destructor();    
      m.removeControl(c);
    });  
  }

  // odložení loadnutí selection javascriptu až při nějaké aktivitě s myší
  var selListener = JAK.Events.addListener(document, 'mousemove blur mouseenter mouseleave', function()
  {
    JAK.Events.removeListener(selListener);
    require(basePath + "selection.js", selectionsInit); // bez caches.js a bez odložení vyhodí chybu v Chrome 
  });

  // turn off while polygon mode is active
  m.getSignals().addListener(window, "polygon-mode-init", function(e, elm) {selectionsExit();});  
  m.getSignals().addListener(window, "polygon-mode-exit", function(e, elm) {selectionsInit();});
  
  //***************************************************************************
  //                ************** Misc **************
  //***************************************************************************  


  //***********************************
  // *** translate all strings ***
  function translate_strings(selector)
  {
    var nodes = document.querySelectorAll(selector || "*[data-tr]");

    // IE7 adds extra space to the end of LI elements, so remove it
    if (JAK.Browser.client == "ie" && JAK.Browser.version <= 7)
    {
      for (var i = 0, len = nodes.length; i < len; i++)
      {
        if (nodes[i].tagName.toLowerCase() == "li" && nodes[i].innerHTML.charAt(nodes[i].innerHTML.length-1) == " ")
          nodes[i].innerHTML = nodes[i].innerHTML.slice(0, -1);        
      }     
    }
    
    // translate
    for (var i = 0, len = nodes.length; i < len; i++)
    {
      nodes[i].innerHTML = tr(nodes[i].innerHTML);
      nodes[i].removeAttribute("data-tr");
    }  
  }
   


  
  

//   /** Web Timing API **/
//   // http://webtimingdemo.appspot.com/
//   
//   // Retrieve the performance object in a cross browser way. It is important to check window.performance first.
//   window.performance = window.performance || window.mozPerformance || window.msPerformance || window.webkitPerformance || {};
//   var timing = performance.timing;
//   
//   if (timing)
//   {
//     //log_object(window.performance.timing);
//     var ieOld = JAK.Browser.client == "ie" && JAK.Browser.version <= 8;
//     
//     function logJSLoad()
//     {
//       log("JS: " + (new Date().getTime() - (ieOld ? timing.loadEventEnd : timing.domContentLoadedEventEnd)) / 1000 + " s");
//     }
//     
//     function logPageLoad()
//     {
//       log("Page: " + (timing.loadEventEnd - timing.navigationStart) / 1000 + " s");
//     }    
// 
//     // waint until page is loaded
//     var timingInt = window.setInterval(function()
//     {
//       if (timing.loadEventEnd)
//       {
//         logPageLoad()
//         ieOld && logJSLoad();
//         window.clearInterval(timingInt);
//       }
//     }, 100)
//     
//     !ieOld && logJSLoad();
//   }


  //**********
  
//   // this fixes GSAK error when going from cache to cache too quickly (we detect if SplitScreen exists - OK, or not - BAD)
//   window.setTimeout(function()
//   {
//     if (navigator.appName == 'Microsoft Internet Explorer' && /SplitScreen\.htm$/.test(window.location))
//     {
//       try
//       {
//         var xhr = new ActiveXObject("MSXML2.XMLHTTP");
//         
//         xhr.onreadystatechange = function(e)
//         {
//           if (xhr.readyState == 4 && xhr.status == 2)
//             window.location.href = "gsak://%FF/macro:silent/HTML_Keskomapa.gsk";
//         }
// 
//         xhr.open("get", "SplitScreen.htm", false);
//         xhr.send(null);
//       }
//       catch(ex){}    
//     }
//   }, 500);

 

  if (window.isGeoSetter)
    require("geosetter.js");

//************************************
// fix Opera issues

if (JAK.Browser.client == "opera")
  require(basePath + "JS/opera_fixes.js");
// *******************
 
settingsData.allscreen._addButton();

//**********


//--------------------------------------------------------------

  // bug, kde se při zjišťování výšky okna v konstruktoru mapy pomocí clientHeight vrátí 0
  // -- nastává v Chromu a ve Firefoxu po nějaké době nečinnosti prohlížeči, kdy se při načtení stránky asi pomalu aktualizuje DOM
  // -- mapa pak je proužek na vrchu obrazovky
  // -- po opravě níže zůstane nesprávný zoom, takže se mapa zobrazí třeba přes celou Evropu místa jen předmětného kraje
  // -- ideálně by bylo třeba nějak zajistit, aby před vytvořením new SMap byl DOM načtený 

  if (!m.getSize().y)
  {
    window.setTimeout(function()
    {
      m.syncPort();
      require(basePath + "caches.js", function() { setCenterZoomFromCaches() });
    }, 0);  
  }
  
  
  
  

//--------------------------------------------------------------
// detekce embedded
//   function parseobject(obj)
//   {
//     var ret = "";
//     
//     if (typeof obj !== 'object')
//       return (obj + "\n");
// 
//     for (var prop in obj)
//     {
//       try
//       {
//         if (typeof obj[prop] === 'function')
//           ret += prop + ": (function)\n";
//         else
//           ret += prop + ": " + obj[prop] + "\n";
//       }
//       catch(ex)
//       {
//         ret += "<span style='color: red'>" + prop + ": reading property failed!</span>" + "\n";
//       }      
//     }
// 
//     return ret;   
//   }
// 
//   ui("copybox", {text: function()
//   {
//     var ret = "";
//     ret += parseobject(window.navigator);
//     ret += parseobject(window.defaultStatus);
//     ret += parseobject(window.document);
//     ret += parseobject(window.history);
//     ret += parseobject(window.location);
//     ret += parseobject(window.name);
//     ret += parseobject(window.status);
//     ret += parseobject(window.parent);
//     ret += parseobject(window.opener);
//     ret += parseobject(window);
//     
//     return ret;
// 
//   }(), width: 600, height: 400, select: true});


//***********************************************

// if (isGSAK)
// {
//   loadJS("cache_code.js", function()
//   {
//     if (cachecode != last_cachecode)
//     {
//       alert("not equal! cachecode: " + cachecode + " - last_cachecode: " + last_cachecode);
//       window.location.href = "gsak://%FF/macro:silent/HTML_Keskomapa.gsk";
//     }
//   })
// }

// pokud máme GSAK a jednu cache, budeme loadovat kousek níže, jinak loadneme caches.js, spočteme nový center a loadneme odtamtud
function load_map()
{
  // turn on layer
  m.getLayer(settings.map).enable();
  
  window._history_ = new mapHistory(m);

  /*** measure time - end (loading the map) ***/
  log("Total: " + (new Date().getTime() - settings.timer - window._loadDelay) / 1000);
  
  //if (window.wp)
  window.setTimeout(function() { require(basePath + "caches.css", basePath + "caches.js") }, 100);
  
  timer();
}

// pokud máme jen jednu kešky v GSAKu, tak souřadnice nepřenastavujeme
if (!window.gsakOnlyOneCache && window.wp)
{
  require
  (
    basePath + "caches.css",
    basePath + "caches.js",
    function() { window["setCenterZoomFromCaches"]() }
  );
}
else
{
  load_map();
}

