translations["_polygon_info"] = {};

translations["_polygon_info"].Czech = hereDoc(function()
{/*
::: Základní principy :::
Zde můžete vytvářet a editovat linie, tracky, polygony a skupiny bodů. Tento mód můžete opustit kliknutím na tlačítko "Track" vlevo dole (které je nyní červené).

Pod pojmem track budeme dále, pokud není řečeno jinak, rozumět cokoli a vše z výše uvedeného. Polygony se graficky liší jen v tom, že jsou vyšrafované. Zapnout a vypnout tento mód lze klikem na první bod tracku. V jednu chvíli můžete mít aktivní jen jeden track (viz menu vpravo).

Track se může dělit na segmenty. To jsou linie, které nemají mezi sebou spojnici. V případě polygonu segment tvoří ostrov. Samostatné body jsou technicky považovány za segment o délce jednoho bodu.

!! Každý track má svoji vlastní historii. Téměř jakoukoli akci můžete vrátit pomocí CTRL + Z.

::: Interface :::
Vpravo nahoře máte celkovou délku tracku (mezery mezi segmenty se nepočítají). V případě polygonu pak i celkovou plochu. Vedle toho máte počet bodů a případně za lomítkem i počet segmentů (pokud jich je víc než jeden). Deaktivované segmenty (viz níže) se nepočítají do celkové délky nebo plochy. V případě přetečení textu v této oblasti (například při velkém množství bodů a segmentů) nejsou všechny údaje vidět, nicméně po najetí myší se vše dočasně zobrazí.

Na druhém řádku si můžete přepínat mezi tracky. Pár jich tam je předpřipraveno už při startu. Vedle toho si můžete zvolit exportní formát. Uložit do souboru je nutno manuálně, neb z prostředí JavaScriptu zatím ukládat soubory nejde. Pozor, generování může zabrat nějaký čas (pokud máte tisíce bodů), tak buďte trpěliví. Navíc se výstup generuje po každé změně na mapě, tak si po uložení výstupu přepněte na něco jiného (třeba "----", což negeneruje žádný výstup nebo "GSAK", což generuje jen souřadnice).

Na třetím řádku si můžete otevřít soubor (podporované formáty jsou GPX/PLT/WPT/KML/KMZ a také linie či polygony GSAKu a GeoGetu). Druhá volba vám umožňuje importovat text souboru přímo. Třetí možnost je snad jasná, dostali jste se sem kliknutím na ono tlačítko :).

Pokud si najedete myší na bod, zobrazí se vám některé informace o něm, pokud jsou dostupné: název, popis, nadmořskou výška, datum a čas. Dále se zobrazí pořadí segmentu a pořadí bodu jak v rámci segmentu, tak i v rámci tracku (v závorce). Pokud máte jen jeden segment, zobrazí se jen pořadí bodu v rámci tracku. Zobrazování této "bubliny" si můžete vypnout/zapnout trvale pomocí U (defaultně je to zaplé). Pokud je to vyplé, tak to bude fungovat dočasně i po dobu stisku SHIFT.

Pokud stisknete mezerník, skryje se vše kromě holého tracku. Občas se hodí, když vám ho zakrývají body.

Spousta bodů na tracku se ale skrývá automaticky, a to tak, aby jich při daném rozlišení nebylo na mapě příliš (v takovém případě by to bylo poznat i na výkonu prohlížeče). Toto chování lze pro aktuální track vypnout pomocí SHIFT+M, nicméně v drtivé většině situací by toto nemělo být nutné.

Na tracku se objevují šipky - ty ukazují směr (tedy který bod je dřívější a který pozdější).

Pokud začínáte od nuly (tedy ne z otevřeného souboru), tak se vám po nakreslení prvního bodu zobrazuje pomocná čára vedoucí k aktuální poloze myši. Tuto je možno vypnout či zapnout pomocí klávesy M.

::: Barvy bodů a čar :::

Body mohou mít různou barvu, podle toho co jsou zač:
- bílá: standardní bod
- transparentní bílá: pomocný přesouvatelný bod
- zelená: začátek segmentu
- zelená s bílým okrajem: začátek tracku
- oranžová: konec segmentu
- oranžová s bílým okrajem: konec tracku
- modrá s bílým kolečkem: alternativní konec (více viz sekce o přidávání nových 
bodů)
- bílá s červeným kolečkem: konec tracku (značí, že nelze přidávat nové body)
- žlutá: označený bod
- žlutá s červeným okrajem: označený speciální bod (začátek/konec segmentu/tracku nebo alternativní konec)
- červená: pomocný bod, označuje střed rotace/zmenšování/zvětšování po dobu operace

Linie také mohou mít různou barvu:
- červená: aktivní track/segment
- oranžová: neaktivní segment
- modrá: neaktivní track
- žlutá: kolem vybraných bodů

::: Přidávání nových bodů :::

Přidání nového bodu je snadné. Stačí kliknout na požadované místo v mapě. Toto přidá bod na konec tracku. Přidání bodu před začátek je téměř stejně snadné - stačí držet stisknutý ALT. Stisknutí SHIFTu pak vždy daný bod přidá jako začátek nového segmentu.

Pokud kliknete na existující bod a budete zároveň držet CTRL, tak se nový bod přidá přesně na souřadnicích toho existujícího bodu. Je zde samozřejmě možno využít i SHIFT pro start nového segmentu v tom bodě.

Nejste omezeni jen na přidávání bodů na konec nebo před začátek, můžete je přidávat i za nebo před libovolný vámi zvolený bod. Stačí na takovýto bod kliknout s přidrženým ALT. Pak se vám tento bod zobrazí jako modré kolečko s bílým okrajem. Takovýto bod se pak bere jako výchozí bod pro výše zmíněnou operaci a i pro dvě níže zmíněné metody (a navíc cut/copy/paste zmíněné mnohem níže).

Ještě jedna metoda jak přidávat body doprostřed je tažením pomocného bílého transparentního bodu (nebo kliknutím na něj levým tlačítkem).

Body se nemusí přidávat jen klikáním po jednom, ale jdou přidávat i hromadně. Pokud budete táhnout středním tlačítkem, budou se automaticky přidávat body až dokud ho nepoustíte. Tato metoda z důvodů konfliktu s metodou níže nefunguje v IE8.

Třetí metoda přidávání bodů je stisknutí středního tlačítka (stisknutí, nikoli tažení jako u metody výše). Pak se budou přidávat body automaticky dokud někam nekliknete. Výhody této metody jsou dvě - nemusíte držet stisknuté tlačítko a můžete (narozdíl od předchozí metody) i pohybovat s mapou a dokonce i zoomovat. Další způsob jak aktivovat tuto metodu je pomocí klávesy T. Vypnout tuto metodu lze levým či středním klikem, stisknutím T nebo pomocí escape. Pokud chcete během této metody dočasně vypnout přidávání bodů a posunout myš jinam, stiskněte CTRL. Pokud zároveň i stisknete SHIFT, tak na novém bodě začnete nový segment.

Kliknutí na poslední bod tracku (tedy oranžový s bílým okrajem) vypne přidávání bodů podle výše zmíněných metod (kromě metody přidávání bodu doprostřed). Tím zamezíte nechtěnému ukliknutí a hodí se to pro editaci hotového tracku, kde nechcete přidávat už nic na konec.. Pokud je tato metoda aktivována, změní se ikonka konce tracku na bílé kolečko s červeným okrajem. Deaktivace této metody probíhá stejným způsobem.

:: Přesun a smazání jednotlivých bodů ::

Přesunout jednotlivé body je možno tažením levého tlačítka myši. Zde je ale nutno zmínit, že může zároveň dojít i k přesunu mnoha dalších blízkých bodů. Ne totiž všechny body jsou vždy zobrazeny - pokud je na spojité linii více blízkých bodů, tak se zobrazí jen jeden (kromě začátků a konců segmentů - ty se zobrazí vždy). Tažením tohoto bodu tak přesouváte vše mezi vámi taženým bodem a dvěma viditelnými body okolo. Toto chování vám umožňuje snadno editovat tracky, které obsahují velké množství bodů. Co se s těmi dalšími body přesně stane? Vyrovnají se (podle původní vzdálenosti) na spojnici mezi novým umístěním a dvěma okolními body (jejichž poloha se nemění). Pokud při tažením zároveň podržíte SHIFT, tak se provede pokus o rotaci a zvětšení/zmenšení těchto bodů, aby se věrně kopíroval předchozí stav - nicméně toto chování může něky vést k nepříliš hezkému výsledku.

Smazání jednotlivého bodu probíhá pravým kliknutím na něj. Aplikuje se stejné chování jako výše, jen s tím rozdílem, že všechny body na spojnici se také smažou.

::: Práce s tracky :::

Aktivní track je vybarven červeně (krom neaktivních segmentů - vybarvené oranžově, a označených částí - vybarvené žlutě). Neaktivní tracky jsou vybarveny celé modře.

- TAB: přepíná se z tracku na track (přeskakuje ty, kde nic není)
- CTRL + klik na track (nebo ALT + pravý klik na track - nutno použít v Opeře): aktivuje track
- insert: vytvoří prázdný track a přepne se na něj
- SHIFT + delete: smaže track (nelze vrátit zpět)
- SHIFT + CTRL + ALT + delete: smaže všechny tracky (zůstane jen jeden prázdný)
- SHIFT + CTRL + ALT + J: sloučí všechny tracky do jednoho

Tracky lze přepínat i v menu napravo. V tom lze i otevírat nové soubory (nebo je importovat v textové podobě) - a ty se také přidají jako tracky.

::: Práce se segmenty :::

Začátek segmentu je označen zeleným kolečkem. Konec pak oranžovým kolečkem.

- SHIFT + CTRL + levý klik na segment (nikoli na bod, ale na čáru): aktivuje nebo deaktivuje tento segment (deaktivovaný segment je oranžový, nezobrazují se na něm body a nelze označit pomocí níže uvedených funkcí); v Opeře je z technických důvodů nutno použít jinou kombinaci - ALT + CTRL + pravý klik
- SHIFT + CTRL + ALT + levý (nebo alternativně pravý) klik na segment: aktivuje segment, deaktivuje ostatní segmenty
- SHIFT + TAB: stejné jako metoda výše, ale skáče postupně po segmentech z jednoho na druhý
- SHIFT + levý klik na bod: rozpojí track v daném bodě a vytvoří segment se začátkem v příštím bodě; pokud je bod koncem segmentu, tak se místo rozpojení v daném místě track spojí
- dvojklik na bod: to samé, ale pohodlnější
- SHIFT + J: spojí všechny segmenty
- SHIFT + CTRL + J: spojí všechny označené segmenty (přesněji: připojí všechny segmentu v k předchozímu segmentu, pokud je alespoň jeden bod segmentu označený)
- SHIFT + pravý klik na bod: smaže segment, jehož byl bod součástí

::: Výběr bodů :::

Existuje mnoho způsobů jak vybrat body nebo naopak body odebrat z výběru. Označené body jsou žluté. Spojnice mezi nimi také.

- CTRL + A: označí všechny body
- I: invertuje výběr (co bylo označené nyní není a naopak)
- Escape: zruší výběr
- pravé nebo levé tažení + SHIFT: vytvoří nový výběr (a zruší předcházející)
- pravé nebo levé tažení + ALT: odečte z výběru
- pravé nebo levé tažení + SHIFT + ALT: přidá k výběru
- pravé nebo levé tažení + SHIFT + ALT + CTRL: provede průnik s předchozím výběrem; obdélníková verze (viz níže) této kombinace nefunguje v Opeře

Tažení levým tlačítkem myší kreslí obdélník (což je rychlejší). Tažení pravým tlačítkem vám dovolí kreslit libovolný tvar (což je přesnější).

::: Posun výběru :::

- CTRL + levé tažení: přesouvá výběr tažením
- šipky: přesune výběr požadovaným směrem o 1 pixel (nefunguje v GSAKu)
- SDFE: to samé, ale funguje v GSAKu
- SHIFT + arrows/SDFE: move point by 10 pixels at a time

::: Rotace výběru :::

- CTRL + SHIFT + levé tažení: rotuje vybrané body tažením myši; centrum rotace je označeno po dobu rotace červeným puntíkem a nachází se tam, kde jste začli táhnout myší
- CTRL + levá/pravá šipka: rotace o 1% (nefunguje v GSAKu)
- CTRL + S/F: rotace o 1% (funguje v GSAKu)
- CTRL + SHIFT + levá/pravá šipka nebo S/F: rotace o 10%

::: Zvětšení/zmenšení výběru :::
- CTRL + ALT + levé tažení: zvětšuje nebo zmenšuje vybrané body (v tom smyslu, že je posunuje blíže nebo dále od bodu, kde jste začli táhnout myší - tento bod je označen červeným puntíkem); posun myší nahoru znamená zvětšení, posun dolů zmenšení; tato kombinace nefunguje v Opeře, tam použijte jednu z níže uvedených možností
- CTRL + horní/dolní šipka: zvětšení/zmenšení o 1%, středem je zde střed výběru (nefunguje v GSAKu) 
- CTRL + E/D šipka: to samé, ale funguje v GSAKu
- CTRL + SHIFT + horní/dolní šipka nebo E/D: zvětšení/zmenšení o 10%

::: Obrácení výběru (flip) :::
- CTRL + SHIFT + střední klik: první klik vám označené body převrátí horizontálně (kolem osy Y), druhý klik pak vertikálně (kolem osy X), třetí klik kolem obou os a čtvrtý vás vráti do původního stavu; střed os je zde místo kam klikáte; pokud po jednom kliku posunete myš pryč, začínáte odznovu (tedy s horizontálním převrácením) 

::: Smazání výběru :::

- delete: smaže všechny vybrané body

::: Vyjmutí, kopírování, vložení výběru (cut, copy, paste) :::

Tyto funkce jako jediné umí přesouvat body mezi jednotlivými tracky. Na stav virtuální schránky (tedy co je aktuálně zkopírováno) se nevztahuje historie a nelze tedy vrátit zpět. Navíc jsou zkopírované body společné pro všechny tracky (tedy zkopírování v jednom tracku přepíše body ve schránce, které byly zkopírovány v jiném tracku).

- CTRL + C: zkopíruje vybrané body do virtuální schránky (nespojité oblasti budou zkopírovány jako samostatné segmenty - pokud máte například vybrány body 2,3,4 a 6,7 ze spojitého tracku, tak se vám zkopírují jako dva nové segmenty; toto chování zaručuje, že vám nikde nevzniknou nové nevhodně umístěné spojnice mezi body)
- CTRL + SHIFT + C: to samé, ale bez přerušování nespojitých zkopírovaných částí
- CTRL + X: vyjmutí (tedy identické chování jako CTRL + C, ale navíc smazání původních bodů)
- CTRL + SHIFT + X: stejné jako CTRL + SHIFT + C (jen navíc se smazáním vybraných bodů)
- CTRL + V: vloží body zkopírované jednou z předchozích metod (body jsou vloženy na identické souřadnice odkud byly zkopírovány, ale v rámci tracku se vloží na konec - případně na alternativní konec, pokud je nastaven - viz výše)
- CTRL + ALT + V: to samé, ale vloží body před začátek (nebo před alternativní konec, pokud je nastaven)
- CTRL + SHIFT (+ ALT) + V: stejné jako výše, ale body jsou vloženy jako nový segment

::: Obrácení tracku (reverse) :::

Obrátí track (tedy co byl začátek bude konec a naopak).

- SHIFT + R: obrátí celý track
- SHIFT + CTRL + R: obrátí jen označené části (použijte hlavně na segmenty, jindy může vést k neočekávaným výsledkům

::: Omezení :::
- nesnažte se načíst tracky s 10k+ body a seznamy bodů s 3k+ body - nebo se připravte na pomalost
- pokud tak přesto učiníte, pomalost můžete obejít označením části tracku/bodů, následným CTRL+X a zkopírováním do jiného tracku, kde už vás nadbytek bodů nebude zatěžovat; editované body pak můžete do původního tracku zpět zkopírovat
- výsledek snažení je prezentován v podobě textu, do souboru ho JavaScript uložit neumí - takže si to do souboru musíte uložit sami a vhodně si ho pojmenovat
- některé prohlížeče mají ve zvyku si krást pro sebe klávesové zkratky - to lze buď vyřešit v nastavení prohlížeče nebo vám pomůže prostý fakt, že většinu věcí lze dělat několika způsoby
- Firefox vždy zobrazí kontextové menu po stisknutí pravého tlačítka a SHIFTu - s tím nic udělat nelze
- v Maxthonu 2 je pro správnou funkci tažení pravým tlačítkem nutno v nastavení vypnout gesta myši (Ovládání myši -> Povolit akce myši); také je nutno pro správnou funkci klávesových zkratek s CTRL a levým klikem/tažením vypnout v nastavení tuto položku: Plovoucí tlačítko -> Rychlé uložení obrázků při kliknutí a současném držení CTRL
- v Maxthonu 3 je třeba vypnout stejná dvě nastavení, jen trochu jinde: Gesta myší -> Povolit gesta myší, Nastavení stránky -> Rychlé uložení obrázků pomocí kliknutí při zmáčknuté klávese CTRL; pro Maxthon 3 se vztahuje i níže zmíněná poznámka, takže je pro funkčnost středního tlačítka nutno se přepnout do módu IE
- Safari a další prohlížeče na něm založené (třeby i výše zmíněný Maxthon 3) nepodporují jakékoli akce vyžadující střední tlačítko myši
*/});

// ===================================================================================================================

translations["_polygon_info"].English = hereDoc(function()
{/*
::: Basic principles :::
Here you can create and edit polylines, polygon, tracks and groups of points. You can turn this mode off by clicking on "Track" below on the left.

From now on, when I say track, I mean any and all of the above (unless stated otherwise). Grafically distinct from the other are only polygons which are filled. You can convert whatever to a polygon by clicking on the very first point (marked by a green circle with a white border). At any time, you can have only one track opened.

Track can be divided into segments. Segments are not connected between each other. Segments in polygon mode are islands. Points are considered segments with a length of one.

!! Each track has its own unlimited history stack. You can go back by pressing CTRL + Z.

::: Interface :::
On the right, you can see on the first line the entire track length, followed by a total area (when we are in polygon mode), and then finally the total number of points and the number of segments behing the slash (if there is more than 1). Deactivated segments (see below) are not counted toward total length and area. In case the text overflows (because of lots of points etc.), you can hover the mouse over the area and temporarily display everything.

On the next line, you can change an active track. Several empty are predefined before you start. The option next to it lets you select export format. You need to save it to a file manually, because it can't be done from within JavaScript. If you edit a large number of points (thousands), it can take long to generate output, so be patient. Also, any change and redraw of the map regenerates the output, so turn it off after using it and select either "----", which generates no output or "GSAK", which generates only coordinates.

Third line features buttons for opening a file, opening a text and help. The third option is clear. This first on is also simple. Supported formats for loading are currently GPX/PLT/WPT/KML/KMZ and also GSAK/Geoget lines/polygons (or generally any sets of coordinates, where each is on a separate line). Second button lets you read files by directly pasting their text content and also to paste GSAK polygons/polylines.

When you hover over a point, you can see some of its parameters: name, description, elevation, date and time (whichever of these are available). Number of segment is also displayed, as is index of the point withint the segment and withint the the entire track. You can disable showing these by pressing U (which is persistent across sessions). When it's turned off, you can temporarily turn it on by pressing SHIFT (and the hovering over points).

Pressing space hides temporarily all points and other elements and leaves only bare track.

Many points on the track are hidden automatically - based on current zoom and distance of points. This is to improve speed, unclutter view and make editing track easier. You can turn off this behavior for current track by pressing SHIFT+M.

There are arrows on track lines, which show track direction.

When you start a new track from scratch (ie. not by loading a file) a helper line will be shown when drawing (which connects last point in track with current mouse position). This behavior can be turned on and off by pressing key "M".

::: Adding new points :::

Left clicking on the map will add new points to the end. Pressing ALT at the same time creates them before the beginning instead. Pressing SHIFT creates new point as a new segment start.

Clicking on an existing point while holding CTRL down will add new point at the exact coordinates of that point. You can use SHIFT modifier here to start a new segment at that point.

You are not limited to adding points to the end or before the beginning. You can add them after or before (with ALT) any point you choose. Just ALT + left click that point and its icon will change to blue circle with a white border. Now points are automatically added before or after that. You can cancel this mode by ALT + left clicking that point again or by pressing escape.

These two principles (setting alternative end and using SHIFT and ALT modifiers) apply not only to manually creating new points one by one, but also to the two methods described below and to cut/copy/paste (described even more below).

Another way to insert points to the middle is by left clicking or dragging a transparent white point, which is located between two points (if they are far enough).

You can quickly add points by dragging middle mouse button. This method is not available in IE8 and older.

Another method is just clicking the middle mouse button and then moving the mouse around. One advantage of this method is that you don't need to have the mouse button pressed while you are moving the mouse. The other is that you are free to drag the map while this mode is active and even zoom in and out. Another way to activate this method is by pressing 'T'. You can deactivate this method by left or middle click and also by pressing T or escape. If you want to temporarily prevent adding points and move the mouse to a new location, press CTRL. Pressing the SHIFT at the same time will start a new segment when you release the keys.

Clicking on the end will convert its icon to a white circle with red border. This means that adding new points using the above methods is turned off. You can cancel this special mode by clicking the end again.

::: Moving and deleting individual points :::

You can move points by left dragging them. Note that this operation may affect many other points, which are not visible at current zoom level. Points invisible at current zoom level are moved on a straight line between newly moved points and the two points around it. Pressing SHIFT tries to rotate/scale them instead to match previous curves of the track - but this may lead to unexpected results at times.

Single points can be deleted by right clicking them. All not visible points around them (up until the next two visible points around, but not including) are deleted.

::: Colors of points and tracks :::

Points are colored based on what they are.

- white: standard point
- transparent white: this point can be clicked or dragged and new point will be added there (so is not really a part of the track)
- green: start of a segment
- green with a white border: start of a track
- orange: end of a segment (or a single point)
- orange with a white border: end of a track
- blue with a white border: alternative end (see section on adding points)
- white with a red border: alternative track end (marks state, where we can't add new points to the track)
- yellow: selected point
- yellow with a red border: selected point, which is also a special point (segment/track start/end, alternative end)
- smallish red: origin of a rotation/scale

Lines:
- red: active track or segment
- orange: inactive segment
- blue: inactive track
- yellow: selected points (lines around them)

::: Working with tracks :::

Active track is red (except for deactivated segments, which are orange and selected parts, which are yellow). Inactive tracks are blue (including any deactivated segments).

- TAB: iterate over tracks
- CTRL + click on a track (or ALT + right click on a track - you need to use this combination in Opera): activate the track
- insert: create a new empty track and make it active
- SHIFT + delete: delete current track (can't be reversed by CTRL + Z)
- SHIFT + CTRL + ALT + delete: delete all tracks (leaves one empty)
- SHIFT + CTRL + ALT + J: merges all tracks into one

You can also switch tracks within sidebar on the right. There you can also load files and import text - these actions will result in adding new track(s).

::: Working with segments :::

Start of a segment is marked by a green circle. End of a segment is marked by an orange circle.

- SHIFT + CTRL + left click on a segment (not a segment point): activate or deactivate that segment (deactivated segment can't be selected and has orange color); in Opera you need to use another combination - ALT + CTRL + right click
- SHIFT + CTRL + ALT + left (or alternatively right) click on a segment: activate this segment, deactivate all others
- SHIFT + TAB: like the method above, but iterates over segments
- escape: activates all segments (which is default)

- SHIFT + left click a point: disconnecting a track there and creating a new segment; if the clicked point already is an end of track, then the segments are joined instead
- double click a point: same as above, but more convenient
- SHIFT + J: join all segments
- SHIFT + CTRL + J: joins all selected segments (or more specifically, joins all segments to the previous segment, if they have at least one point selected)
- SHIFT + right click a point: delete all points within a segment, which the point is a part of

::: Selecting points :::

There are multiple ways to select and deselect points. Selected points are yellow, so are lines between them.

- CTRL + A: select all points
- I: inverse selection
- Escape: cancel selection
- left or right drag + SHIFT: create new selection (and cancel any previous one)
- left or right drag + ALT: subtract from selection
- left or right drag + SHIFT + ALT: add to selection
- left or right drag + SHIFT + ALT + CTRL: intersection of previous selection and the current one; the rectangle version of this (see below) doesn't work in Opera

Left drag always draws rectangle (which is quicker). Right drag draws any shape (which is more accurate)

::: Moving selection :::

- CTRL + left drag: moves selection anywhere by dragging
- arrows: move points by 1 pixel in desired direction (doesn't work within GSAK)
- SDFE: same as above (but working within GSAK)
- SHIFT + arrows/SDFE: move point by 10 pixels at a time

::: Rotating selection :::

- CTRL + SHIFT + left drag: rotate selected points around origin (which is the point where you started dragging); rotation origin is marked by a red circle during rotation
- CTRL + left/right arrow: rotate selected point by 1 degree (origin is the center of selection); doesn't work within GSAK
- CTRL + S/F: same as above, but works within GSAK
- CTRL + SHIFT + left/right arrow or S/F: rotation by 10 degrees at a time

::: Scaling selection :::

- CTRL + ALT + left drag: scale selected points around origin (which is the point where you started dragging); scale origin is marked by a red circle during scaling; mouse move up to increase size and down to decrease size; this doesn't work in Opera, use combinations below instead
- CTRL + top/bottom arrow: increase/decrease size by 1% (origin is the center of selection); doesn't work within GSAK
- CTRL + E/D: same as above, but works within GSAK
- CTRL + SHIFT + top/bottom arrow or E/D: scale by 10% at a time

::: Flipping selection :::

- CTRL + SHIFT + middle click: make horizontal flip, then on next click vertical, on next click both horizontal and vertical and on fourth click return to original state; center of flip is where you click the mouse; if you move the mouse away, you will reset counter and you will start with horizontal flip again

::: Deleting selection :::

- delete: deletes all selected points

::: Cut, copy, paste selection :::

These are the only functions, that allow you to move points between tracks. They are applied on selected points. Clipboard content is totally independent of history stack, so can't be restored by CTRL + Z. Also, there is only one clipboard for all tracks (ie copying something within one track will overwrite any selection made within a different track)

- CTRL + C: copy selected points (non-continous areas will be copied as separate segments; e.g. if you have selected points 2,3,4 and 5,6,7 in a track without segment breaks, your pasted selection will by separated by a segment break)
- CTRL + SHIFT + C: same as above, but overrides the described behavior and non-continuous areas will be connected
- CTRL + X: cuts selected points (copies them + deletes them from current track)
- CTRL + SHIFT + X: same as above (but with same behavior override like with CTRL + SHIFT + C)
- CTRL + V: pastes points copied previously by one of the above functions; position of points doesn't change; points are pasted after end or after alternative origin (if one is set - see above)
- CTRL + ALT + V: pastes points before beginning (or before alternative origin - if set)
- CTRL + SHIFT (+ ALT) + V: same as above, but pastes selection as a new segment  

::: Reverse a track :::

Reverses orded of points in a track (what was start will be an end and vice-versa).

- SHIFT + R: reverses a track
- SHIFT + CTRL + R: reverses only selected parts (use preferrably on segments, otherwise it may lead to unpredictable results)

::: Limitations :::

- don't use it for loading tracks with 10k+ points or waypoint files with 3k+ points - or prepare for slowdown (or worse)
- you can solve the above be either zooming in or even better - cutting out part and editing it as a separate track (and then pasting it back) - read cut, copy, paste section for this
- you need to save resulting output to a file manually (JavaScript limitation)
- some browsers may steal some key combinations, but there is usually some way to reconfigure them or there are more ways to achieve the same
- Firefox always shows context menu on SHIFT + right click, can't do anything about it
- in Maxthon 2, you need to disable two following options within settings: Mouse Control -> Enable Mouse Gestures, Float Button -> Quick Save images by clicking while holding CTRL key; disabling the former allows you to use right drag, disabling the latter allows you to use combinations with CTRL and left mouse button (there are quite a few of them)
- in Maxthon 3, you need to disable those two same options as in Maxthon 2, but located elsewhere: Mouse Gestures -> Enable Mouse Gestures, Web Content -> Quick Save images by clicking while holding the CTRL key; also, as mentioned below, middle mouse button actions don't work in default mode - but can be enabled by switching to IE mode
- Safari based browsers (including above mentioned Maxthon 3) do not support any action involving middle mouse button
*/});
