// lev klik:
// IE:        mousedown -> mousemove -> ... -> mousemove -> mouseup -> click  (vdy alespo 1 mousemove, v embedded mdu ale nemus bt mousemove!!!)
// Opera 12:  mousedown -> mouseup -> click
// FF:        mousedown -> mouseup -> click
// Chrome:    mousedown -> mouseup -> click
// Maxthon 3: mousedown -> mouseup -> click

// lev taen:
// IE:        mousedown -> mousemove -> ... -> mousemove -> mouseup -> click
// Opera 12:  mousedown -> mousemove -> ... -> mousemove -> mouseup   (se stisknutm ctrl+alt+shift dojde k mouseup i kdy je tlatko dreno)
// FF:        mousedown -> mousemove -> ... -> mousemove -> mouseup -> click
// Chrome:    mousedown -> mousemove -> ... -> mousemove -> mouseup -> click
// Maxthon 3: mousedown -> mousemove -> ... -> mousemove -> mouseup -> click

// lev dblclick:
// IE 9+:     mousedown -> mousemove -> mouseup -> click -> mousemove -> mousedown -> mousemove -> mouseup -> click -> dblclick
// IE 8:      mousedown -> mouseup -> click -> mousemove -> mouseup -> dblclick
// Opera 12:  mousedown -> mouseup -> click -> mousedown -> mouseup -> click -> dblclick
// FF:        mousedown -> mouseup -> click -> mousedown -> mouseup -> click -> dblclick
// Chrome:    mousedown -> mouseup -> click -> mousemove -> mousedown -> mouseup -> click -> dblclick
// Maxthon 3: mousedown -> mouseup -> click -> mousemove -> mousedown -> mouseup -> click -> dblclick

// stedn klik:
// IE:        mousedown (a zmna kurzoru)
// Opera 12:  mousedown (a zmna kurzoru)
// FF:        mousedown -> mouseup (FF4 po prvnm mousedown zmn kurzor, pak pi dalm kliku vyhod mouseup)
// Chrome:    mousedown -> mouseup -> click
// Maxthon 3: mousedown -> mouseup -> click

// stedn taen:
// IE:        mousedown (a zmna kurzoru)
// Opera 12:  mousedown (a zmna kurzoru)
// FF:        mousedown -> mousemove -> mouseup (FF4 stejn jako stedn klik, jen navc s mousemove)
// Chrome:    mousedown -> mousemove -> ... -> mousemove -> mouseup -> click
// Maxthon 3: mousedown -> mousemove -> ... -> mousemove -> mouseup -> click

// prav klik:
// IE:        mousedown -> mousemove -> mouseup -> contextmenu (zruen mouseup nezru contextmenu)
// Opera 12:  mousedown -> mouseup -> contextmenu
// FF:        mousedown -> mouseup -> contextmenu (jen pokud nen dren shift, ve FF4 ale i shift funguje)
// Chrome:    mousedown -> mouseup -> contextmenu
// Maxthon 3: mousedown -> mouseup -> contextmenu

// prav taen:
// IE:        mousedown -> mousemove -> ... -> mousemove -> mouseup -> contextmenu (zruen mouseup nezru contextmenu)
// Opera 12:  mousedown -> mousemove  -> ... -> mousemove -> mouseup
// Opera Chrome: mousedown -> mousemove ... (pokud je zapl ctrl, alt nebo shift, tak se contextmenu objev)
// FF:        mousedown -> mousemove -> mouseup -> contextmenu (jen pokud nen dren shift, ve FF4 ale i shift funguje)
// Chrome:    mousedown -> mousemove -> ... -> mousemove -> mouseup -> contextmenu
// Maxthon 3: mousedown -> mousemove -> ... -> mousemove -> mouseup -> contextmenu
// Maxthon 2: mousedown -> mousemove -> ... -> mousemove -> mousedown -> mouseup -> contextmenu

// - zruen mouseup nezru click nebo contextmenu v IE a Chrome
// - v Maxthonu 3 (safari) zruen mouseup nezru jen contextmenu, ale click ano

// - Chrome < 23 dajn produkuje mousemove hned po mousedown (smap.js)

// function mouse_events_logger(e)
// {
//   log([new Date().getTime(), e.type]);
// }
// 
// JAK.Events.addListener(document.documentElement, "click dblclick mouseup mousedown contextmenu", this, mouse_events_logger, true);
// JAK.Events.addListener(document.documentElement, "mousemove", this, mouse_events_logger, true);

Drag = JAK.ClassMaker.makeClass({
	NAME: "Drag",
	VERSION: "1.0",
	EXTEND: SMap.Control.Visible
});

Drag.prototype.$constructor = function(options)
{
  this.$super();

	this._options =
  {
    init: null,                         // volme pi start taen
    update: null,                       // volme pi mousemove
    exit: null,                         // volme po spnm konci (po mouseup)
    
    alt: false,                         // stav klves: true - mus bt zapnuto, false - nesm bt zapnuto
    shift: false,
    ctrl: false,
    meta: false,
    mouse: JAK.Browser.mouse.left,      // tlatko myi, kterm tahneme
    cursor: null,                       // kurzor myi bhem taen
    minimalMove: 3                      // o kolik se musme pi mousemove alespo pohnout, aby se volalo update()
	}

  mergeOptions(this._options, options);   

  this.first = null;                // first = pixel, kde jsme zaali tahnout
  this.last = null;                 // last = aktuln pixel, kde je my
  
 	this._ecTmp = [];                 // doasn pole s listenery, kter jsou aktivn bhem taen
  this._ecTmp2 = [];                // listenery pro contextmenu (e IE problm)
  this._running = false;
  this._mouseMoved = false;         // zda se my pohla (slou k rozlien kliku a taen)
}

Drag.prototype.$destructor = function()
{
  this._mouseMoved = false;
  this._stop();
  JAK.Events.removeListeners(this._ecTmp2);
  this._ecTmp2 = [];
  this.$super();
}
  
Drag.prototype.setOwner = function(owner)
{
	this.$super(owner);
	if (!owner) { return; }

	this._ec.push(JAK.Events.addListener(owner.getContainer(), "mousedown", this, "_mousedown"));
}
    
Drag.prototype._mousedown = function(e, elm)
{
  // Maxthon 2 vyhod tsn ped mouseup jet navc mousedown (prav taen bez alt/ctrl/shift v Maxthon 2)
  // -- navc je teba oetit ppad, kdy neuhod mouseup, co se me stt teba oputn strnky pomoc alt-tab
  if (this._running)
    return this._stop(e);

  // vrtme se, pokud nen sprvn kombinace klvesnice a myi
  if (this._options.shift !== !!e.shiftKey 
  || this._options.ctrl !== !!e.ctrlKey 
  || this._options.alt !== !!e.altKey 
  || this._options.meta !== !!e.metaKey
  || this._options.mouse != e.button)
    return;
    
  // k, e jsme aktivovn (ale jet se nev, zda bude taen spn nebo se jedn jen o click)
  this._running = true;
  
  // zda u se pohlo s my (co znamen, e taen je spn a ne click)
  this._mouseMoved = false;
  
  // lev horn roh tverce (zatek kreslen)
  this.last = this.first = SMap.Pixel.fromEvent(e, this.getMap());
  
  // uloen eventu pro init funkci
  this.event = e;      

  // handlers
	this._ecTmp.push(JAK.Events.addListener(document, "mouseup", this, "_mouseup"));
	this._ecTmp.push(JAK.Events.addListener(document, "mousemove", this, "_mousemove"));

  // IE a Chrome: zruen mouseup nezru click a contextmenu (oboj nsleduje po mouseup), je teba zruit separtn
  // Maxthon 3 (safari) - stejn ppad, ale jen pro contextmenu
  if (["ie", "chrome"].indexOf(JAK.Browser.client) != -1 && this._options.mouse == JAK.Browser.mouse.left)
    this._ecTmp2.push(JAK.Events.addListener(document, "click", this, "_preventClickContextmenu", true));

  if (["ie", "chrome", "safari"].indexOf(JAK.Browser.client) != -1 && this._options.mouse == JAK.Browser.mouse.right)
    this._ecTmp2.push(JAK.Events.addListener(document, "contextmenu", this, "_preventClickContextmenu", true));  

  // nastaven kurzoru
  this.getMap().setCursor(this._options.cursor);
}

// tuto funkci volme, abychom zruili click nebo contextmenu event u prohle, kde zruen mouseup tyto nezru
Drag.prototype._preventClickContextmenu = function(e, elm)
{
  // zrume click nebo contextmenu jen pokud jsme se pohli
	if (this._mouseMoved)
  {
    EventUtil.stopPropagation(e);
    EventUtil.preventDefault(e);
  }

  JAK.Events.removeListeners(this._ecTmp2);
  this._ecTmp2 = [];
}

// pohyb myi --> pidme aktuln souadnice, pekreslme
Drag.prototype._mousemove = function(e, elm)
{
	var point = SMap.Pixel.fromEvent(e, this.getMap());

  // prvn vykreslen probhne jen tehdy, pokud se nejdve pohneme o toliko
  if (this.last === this.first && point.distance(this.first) < this._options.minimalMove)
    return;

  // mezi dvma vykreslovnmi se musme pohnout alespo o toliko    
  if (point.distance(this.last) < 1)
    return;

  this.last = point;
  
  // pi prvnm pohybu myi volme inicializaci
  if (!this._mouseMoved)
  {
    this._init();
    this._mouseMoved = true;
  }

  this.event = e;  // init ve volme s eventem mousedown, zde s eventem mousemove
  this._update();
}

// mouseup --> ukonme
Drag.prototype._mouseup = function(e, elm)
{
  //log([new Date().getTime(), "_mouseup", this._running]);
  EventUtil.preventDefault(e);
  EventUtil.stopPropagation(e);
  this.event = e;
  this._stop();
}

// cleanup po ukonen taen (nebo i po jednotlivm kliku)
Drag.prototype._stop = function()
{
	this._ecTmp.forEach(JAK.Events.removeListener, JAK.Events);
	this._ecTmp = [];
  
	this._running = false;

  // obnoven kurzoru
  this.getMap().setCursor(null);
  
  // IE po nkterch kombinacch strnku ozna
  EventUtil.deselect();
  
  // voln handleru (pokud probhlo spn taen)
  if (this._mouseMoved)
  {
    this._update();   // jet jeden posledn update
    this._exit();
  }
}

// funkce volan pi startu taen, posunu myi pi taen a konci taen
Drag.prototype._init = function()        /* volno pi spnm zatku taen */
{
	if (this._options.init)
    this._options.init.call(this._options.context, this._paramsToSend());
}

Drag.prototype._update = function()       /* volno pi mousemove pi taen */
{
	if (this._options.update)
    this._options.update.call(this._options.context, this._paramsToSend());
}

Drag.prototype._exit = function()         /* volno pi spnm ukonen taen */
{
	if (this._options.exit)
    this._options.exit.call(this._options.context, this._paramsToSend());
}

Drag.prototype._paramsToSend = function() /* pole parametr kter se polou handlerm */
{
	return {event: this.event, first: this.first, last: this.last, options: this._options};
}

//==============================================================================
//                                  Drag.Coords
//==============================================================================

// rozen Drag o uchovvn pole souadnic ktermi jsme thli my

Drag.Coords = JAK.ClassMaker.makeClass({
	NAME: "Drag.Coords",
	VERSION: "1.0",
	EXTEND: Drag
});

Drag.Coords.prototype._init = function()         /* volno pi spnm zatku taen */
{
  this.$super();
  this.points = [this.first.toCoords(this.getMap())];
}

Drag.Coords.prototype._update = function()       /* volno pi mousemove pi taen */
{
  this.$super();
	this.points.push(this.last.toCoords(this.getMap()));
}

Drag.Coords.prototype._exit = function()         /* volno pi spnm ukonen taen */
{
  this.$super();    
  this.points = [];
}

Drag.Coords.prototype._paramsToSend = function()
{
  var params = this.$super();
  params.points = this.points;
  return params;
}

//==============================================================================
//                                  Selection
//==============================================================================

Selection = JAK.ClassMaker.makeClass({
	NAME: "Selection",
	VERSION: "1.0",
	EXTEND: Drag.Coords
});

// %[b,c,d], +[a,b,c], -[d,e,f,g,h,i,j,k,l]
// 
// ALL --> +[d,e,f,g,h,i,j,k,l]
// NONE -> -[a,b,c]
// ADD -> +[d]
// REMOVE -> -[b,c]
// CREATE -> -[a], +[d]
// XOR -> -[d]

Selection.ALL = 1;
Selection.NONE = 2;
Selection.INVERT = 3;
Selection.CREATE = 4;
Selection.ADD = 5;
Selection.REMOVE = 6;
Selection.XOR = 7;

// arrChange - pole zmnnch
// arrOn - pole zaplch
// arrOff - pole vyplch
// mode - md selekce
Selection.filter = function(arrChange, arrOn, arrOff, mode)
{
  var ret = {on: [], off: []};
  
  switch(mode)
  {
    case Selection.ALL:
      ret.on = arrOff;
      break;

    case Selection.NONE:
      ret.off = arrOn;
      break;

    case Selection.INVERT:
      ret.on = arrOff;
      ret.off = arrOn;
      break;     

    case Selection.CREATE:
      ret.on = arrOff.filter(function(i) { return arrChange.indexOf(i) != -1; });
      ret.off = arrOn.filter(function(i) { return arrChange.indexOf(i) == -1; });
      break;

    case Selection.ADD:
      ret.on = arrChange.filter(function(i) { return arrOn.indexOf(i) == -1; });
      break;

    case Selection.REMOVE:
      ret.off = arrOn.filter(function(i) { return arrChange.indexOf(i) != -1; });
      break;    

    case Selection.XOR:
      ret.off = arrOn.filter(function(i) { return arrChange.indexOf(i) == -1; });
      break;    
  }
  
  // nov hodnoty promnnch arrChange, arrOn, arrOff po proveden operace
  //ret.newArrChange = [];
  //ret.newArrOn = arrOn.concat(ret.on).filter(function(i){ ret.off.indexOf(i) == -1 });
  //ret.newArrOff = arrOff.concat(ret.off).filter(function(i){ ret.on.indexOf(i) == -1 });    
  
  return ret;
}

// defaultn pedvolby
// Opera 12, Opera Chrome: na prav taen (bez ctrl/alt/shift) nevyhod mouseup (lze vyeit vypnutm gestures, to ale v nov Opee nejde)
// Opera Chrome:  a prav taen s altem *obas* dl to sam
// Opera 12: lev taen + ctrl + alt + shift zpsob okamit mouseup po startu taen
// Firefox: and SHIFT+right click launches app context menu (can't be overridden)  
Selection.SELECTION_CREATE =   {mode: Selection.CREATE, shift: true,  alt: false, ctrl: false, color: "yellow",  cursor: "cell"};
Selection.SELECTION_ADD =      {mode: Selection.ADD,    shift: true,  alt: true,  ctrl: false, color: "green",   cursor: "cell"};
Selection.SELECTION_REMOVE =   {mode: Selection.REMOVE, shift: false, alt: true,  ctrl: false, color: "red",     cursor: null};
Selection.SELECTION_XOR =      {mode: Selection.XOR,    shift: true,  alt: true,  ctrl: true,  color: "#FFA500", cursor: null};

//Selection.MIDDLE_BUTTON =    {mouse: JAK.Browser.mouse.middle,  shift: false,  alt: false,  ctrl: false,  color: "#FFA500", cursor: null}; /*orange: IE7-8 fix*/

Selection.predefined_4 =
[
  Selection.SELECTION_CREATE,
  Selection.SELECTION_ADD,
  Selection.SELECTION_REMOVE,
  Selection.SELECTION_XOR
];
  
// options: parametry(viz ne)
// options2: dal parametry (dobr pokud teba pouijeme jedny z options peddefinovanch ve)
Selection.prototype.$constructor = function(options)
{
  // umonme uivateli zadat jedno z peddefinovanch options ve
  if (options.predefined)
    for (var p in options.predefined) { options[p] = options.predefined[p]; }

  this.$super(options);

	var _options =
  {
		mode: Selection.CREATE,   // md vbru bod ALL, NONE, INVERT, CREATE, ADD, REMOVE, XOR
    borderWidth: 4,            // tlouka okraje
    color: "blue",            // barva vyplnn
    opacity: 0.3              // prhlednost kreslenho objektu
	}
  
   mergeOptions(this._options, _options);
   mergeOptions(this._options, options);    
};

Selection.prototype.$destructor = function()
{
  this.$super();
  
  if (this.layer && this.getMap())
    this.getMap().removeLayer(this.layer)
}

Selection.prototype._init = function()
{
  this.layer = new SMap.Layer.Geometry();
  this.getMap().addLayer(this.layer).enable();

  this.$super();
}

Selection.prototype._update = function()
{
  this._redraw();
  this.$super();
}

Selection.prototype._redraw = function()
{
}

Selection.prototype._exit = function()
{
  this.getMap().removeLayer(this.layer);
  this.layer = null;
  this.$super();
}

//==============================================================================
//                               Selection.Polygon
//==============================================================================

Selection.Polygon = JAK.ClassMaker.makeClass({
	NAME: "Selection.Polygon",
	VERSION: "1.0",
	EXTEND: Selection
});

Selection.Polygon.prototype.$constructor = function(options)
{
	var _options =
  {
    mouse: JAK.Browser.mouse.right
	}

  mergeOptions(_options, options);

  this.$super(_options);
};

Selection.Polygon.prototype._redraw = function()
{
  this.layer.removeAll();

  var options = 
  {
    color: this._options.color,
    opacity: this._options.opacity,
    outlineColor: "blue",
    outlineWidth: this._options.borderWidth,
    outlineOpacity: this._options.opacity
  };

  var geometry = new SMap.Geometry(SMap.GEOMETRY_POLYGON, null, this.points, options);
  this.layer.addGeometry(geometry);
  
  this.$super();
}

Selection.Polygon.prototype._init = function()
{
  this.$super();
}

Selection.Polygon.prototype._update = function()
{
  this.$super();
}

Selection.Polygon.prototype._exit = function()
{
  this.$super();
}

//==============================================================================
//                              Selection.Rectangle
//==============================================================================

Selection.Rectangle = JAK.ClassMaker.makeClass({
	NAME: "Selection.Rectangle",
	VERSION: "1.0",
	EXTEND: Selection
});

Selection.Rectangle.prototype.$constructor = function(options)
{
	var _options =
  {
    mouse: JAK.Browser.mouse.left
	}

  mergeOptions(_options, options);

  this.$super(_options);
  
  this._style = 
  {
    display: "none",
    borderColor: "#00a",
    borderStyle: "solid",
    borderWidth: this._options.borderWidth + "px",
    backgroundColor: this._options.color
  }
  
  this._build();
};

Selection.Rectangle.prototype.$destructor = function()
{
  this.getContainer().style.display = "none";
  this.$super();  
};

Selection.Rectangle.prototype._build = function()
{
  this.$super();
  this._dom.container = JAK.mel("div", {}, this._style);
  setOpacity(this.getContainer(), this._options.opacity);
};

Selection.Rectangle.prototype._init = function()
{
  this.$super();
  this.getContainer().style.display = "";
}

Selection.Rectangle.prototype._update = function()
{
  this.$super();
  
  // pepeme this.points na pole roh obdlnka
  var px2 = new SMap.Pixel(this.last.x, this.first.y);   // prav horn roh tverce
  var px4 = new SMap.Pixel(this.first.x, this.last.y);   // lev doln roh tverce
  var corners = [this.first, px2, this.last, px4];
  this.points = corners.map(function(px){ return px.toCoords(this.getMap()) }.bind(this));  // pevod pole px na pole coords
}

Selection.Rectangle.prototype._redraw = function()
{
  var dom = this.getContainer();
	var w = Math.abs(this.first.x - this.last.x);
	var h = Math.abs(this.first.y - this.last.y);
	dom.style.width = w + "px";
	dom.style.height = h + "px";
	
	var left = Math.min(this.first.x, this.last.x);
	var top = Math.min(this.first.y, this.last.y);
  
	var size = this.getMap().getSize().clone().scale(1/2);
	left += size.x - this._options.borderWidth;
	top += size.y - this._options.borderWidth;

	dom.style.left = left + "px";
	dom.style.top = top + "px";
}

Selection.Rectangle.prototype._exit = function()
{
  this.$super();
  this.getContainer().style.display = "none";
}

//==============================================================================
//                         Selection.Rectangle.Zoom
//==============================================================================

// poznmka: v Opee 12 s Gestures a v Opee Chrome kombinace options ne nen zakonena spn (nedojde k mouseup)

Selection.Rectangle.Zoom = JAK.ClassMaker.makeClass({
	NAME: "Selection.Rectangle.Zoom",
	VERSION: "1.0",
	EXTEND: Selection.Rectangle
});

Selection.Rectangle.Zoom.prototype.$constructor = function(options)
{
	var _options =
  {
    mouse: JAK.Browser.mouse.right,
    shift: false,
    alt: false,
    ctrl: false,
    cursor: "pointer",
    opacity: 0.25
	}

  mergeOptions(_options, options);
  this.$super(_options);
};

Selection.Rectangle.Zoom.prototype._build = function()
{
  this._style.borderColor = "#0D11FF";
  this._style.backgroundColor = "#8C8DF5";  
  this.$super();
};

// zazoomovn na vybranou oblast
Selection.Rectangle.Zoom.prototype._exit = function()
{
  var center_zoom = this.getMap().computeCenterZoom(this.points);
  this.getMap().setCenterZoom(center_zoom[0], center_zoom[1]);
  this.$super();  
}
