// HTML --> JavaScript
// http://www.accessify.com/tools-and-wizards/developer-tools/html-javascript-convertor/

//===========================================================================
//                               Sidebar
//===========================================================================   

Sidebar = JAK.ClassMaker.makeClass(
{
	NAME: "Sidebar",
	VERSION: "1.0"
});

Sidebar.prototype.$constructor = function(button)
{
  this.button = button;
  this.map = m;

	this._ec = [];
	this._sc = [];
  
  this.init();  
}

Sidebar.prototype.$destructor = function()
{
	JAK.Events.removeListeners(this._ec);
	if (this.map) { this.map.getSignals().removeListeners(this._sc); }
}  

Sidebar.prototype.getHTML = function()
{
  return "";
};

Sidebar.prototype.createDom = function()
{
  this._dom = JAK.mel("div", {innerHTML: this.getHTML()}, {display: "none"}).firstChild;

  // turn off right border for rightmost div
  this._dom.lastChild.style.borderRight = "none";

  sidebars_div.appendChild(this._dom);
};

Sidebar.prototype.init = function()
{
  this.createDom();

  /**** handlery ****/
  this._ec.push(JAK.Events.addListener(this.button, "click", this, "show"));
//  this._ec.push(JAK.Events.addListener(this._dom, "mouseleave", this, "hide"));
  EventUtil.addMouseHandler(this._dom, "mouseleave", this.hide.bind(this));  // je třeba použít náš handler, jinak nefunguje v Maxthonu 3
  
  //this._ec.push(JAK.Events.addListener(this._dom, "click", this, "handleClicks")); // vrací jiný target :(
  EventUtil.addHandler(this._dom, "click", this.handleClicks.bind(this));
  
  if (JAK.Browser.client == "ie" && JAK.Browser.version <= 8)
    EventUtil.addHandler(this._dom, "dblclick", this.handleClicks.bind(this));   // pro IE 8 (2 rychlé kliky po sobě neprodukují druhý click, ale dblclick)
  
  // zaklikneme checkboxy v Menu
  // -- ale jen tehdy, pokud existuje pro danou položku proměnná settings.něco
  this.menu.forEach(function(entry)
  {
    var settingName = entry.id;

    if (settingName in settings)
       document.getElementById(settingName + "_checkbox").checked = settings[settingName];
  });      
};

Sidebar.prototype.show = function()
{
  this._dom.style.display = "block";
};

Sidebar.prototype.hide = function()
{
  this._dom.style.display = "none";
};

Sidebar.prototype.handleClicks = function(e, target)
{
  // prohlížeče při dblclick označí text
  EventUtil.deselect(e);

  // get LI
  if (target.parentNode.tagName.toLowerCase() == "li")
    target = target.parentNode;
  
  // filter out non-LI elements or empty LI (separator)  
  if (target.tagName.toLowerCase() != "li" || !target.firstChild)
    return;

  if (target.firstChild.tagName.toLowerCase() == "input" && target.firstChild.type == "checkbox")
  {
    toggleSetting(target.firstChild.id.match(/^(\w+)_checkbox/)[1], "toggle");

    // send signal (for minimap)
    this.map.getSignals().makeEvent("sidebar-checkbox-change");
  }
};

// tato funkce vygeneruje položky jednoho sloupce menu nebo filteru
Sidebar.addMenuEntries = function(entry)
{
  // přidání separatoru
  if (entry.id == "SEPARATOR")
    return "    <li class=\"li_separator\"><\/li>";
  
  // přidání vertikálního rozdělovače  
  if (entry.id == "VERTICAL_SEPARATOR")
    return "  <\/div>\n  <div class=\"sidebar_checkboxes\" style=\"border-left: 2px solid black; border-radius: 0px;\">";      

  // přidání checkboxu
  translations["_" + entry.id + "_title"] = entry.title;   
  var title = ' title="' + tr("_" + entry.id + "_title") + '"';

  translations["_" + entry.id] = entry.label;
  var text = tr("_" + entry.id);
  
  var className = entry.className ? (' class="' + entry.className + '"') : "";
  var style = entry.style ? (' style="' + entry.style + '"') : "";

  // přidání buttonu
  if (className.indexOf("button") != -1)
    return '    <li' + title + className + style + ' id=' + entry.id + '_button><span>' + text + '</span></li>';
  
  return '    <li' + title + className + style + '><input type=checkbox id=' + entry.id + '_checkbox><span>' + text + '</span></li>';
};  

//===========================================================================
//                               Sidebar.Menu
//===========================================================================   

Sidebar.Menu = JAK.ClassMaker.makeClass(
{
	NAME: "Sidebar.Menu",
	VERSION: "1.0",
  EXTEND: Sidebar
});

Sidebar.Menu.prototype.$constructor = function(button)
{
  // položky menu
  // -- jakákoli položka, např. "xxx" by měla obecně mít nastavené setting.xxx + asociované toggleSetting, kde se porovnává setting == "xxx"  
  this.menu =
  [
    {id: "refresh", className: "button GSAK_Only", style: ((window.isGSAK && JAK.Browser.embedded) ? "" : "display: none;"),
        label: {"Czech": "Refresh", "English": "Refresh"},
        title: {"Czech": "", "English": ""}},
    
    {id: "load_file", className: "button", 
        label: {"Czech": "Otevřít GPX/KML/..", "English": "Load GPX/KML/.."}, 
        title: {"Czech": "Otevře a zobrazí soubor. Podporované formáty: GPX, KML, WPT, PLT + linie/polygony GSAKu a Geogetu.", "English": "Opens and displays a file. Supported formats: GPX, KML, WPT, PLT + GSAK and Geoget lines/polygons."}},
        
    {id: "SEPARATOR"},

    {id: "coordinate_grid", 
        label: {"Czech": "Síť zeměpisných souřadnic", "English": "Coordinate grid"}, 
        title: {"Czech": "Zobrazí síť zeměpisných souřadnic.", "English": "Display coordinate grid."}},
    
    {id: "coordinate_grid_sjtsk", 
        label: {"Czech": "Síť S-JTSK souřadnic", "English": "S-JTSK coordinate grid"}, 
        title: {"Czech": "Zobrazí síť S-JTSK souřadnic.", "English": "Display S-JTSK coordinate grid."}},
    
    {id: "overview_map", 
        label: {"Czech": "Náhledová mapa ČR", "English": "Overview map (CZ)"}, 
        title: {"Czech": "Zobrazí neklikatelnou náhledovou mapku ČR. Při zapnutí minimapy je automaticky skrytá.", "English": "Displays unclickable overview map of the Czech Republic. Hidden while minimap is active."}},
    
    {id: "compass", 
        label: {"Czech": "Kruhový volič", "English": "Circle control"}, 
        title: {"Czech": "Zobrazí kolečko, které po kliknutí posune mapu v daném směru.", "English": "Displays circle control, that allows you to move the map."}},

    {id: "rosette", style: (JAK.Browser.client == "ie" && JAK.Browser.version <= 9) ? "display:none;" : "", // rotace nefunguje v IE8
        label: {"Czech": "Směrová růžice", "English": "Rosette"}, 
        title: {"Czech": "Ukazuje sever.", "English": "Shows north."}},

    {id: "coordinates_box", 
        label: {"Czech": "Zobrazit souřadnice", "English": "Coordinates window"}, 
        title: {"Czech": "Zobrazí okno se souřadnicemi, na kterých se právě nachází myš.", "English": "Display window with coordinates under the mouse cursor."}},
        
    {id: "crosshair", 
        label: {"Czech": "Středový kříž", "English": "Center crosshair"}, 
        title: {"Czech": "Zobrazí kříž ve středu mapy.", "English": "Displays cross in map center."}},
    
    {id: "poi_base", style: (JAK.Browser.client == "ie" && JAK.Browser.version <= 9) ? "display:none;" : "",    // turn off POI for IE <= 9
        label: {"Czech": "POI základní", "English": "POI base"},
        title: {"Czech": "Body zájmu (základní)", "English": "Points of interest (base)"}},
    
    {id: "poi_tourist", style: (JAK.Browser.client == "ie" && JAK.Browser.version <= 9) ? "display:none;" : "", // turn off POI for IE <= 9
        label: {"Czech": "POI turistické", "English": "POI tourist"},
        title: {"Czech": "Body zájmu (turistické)", "English": "Points of interest (touristic)"}},

    {id: "VERTICAL_SEPARATOR"},
    
    {id: "scale", 
        label: {"Czech": "Měřítko mapy", "English": "Map scale"}, 
        title: {"Czech": "Zobrazí měřítko mapy. Pouze Mapy.cz a ZM10.", "English": "Displays map scale. Only Mapy.cz and ZM10."}},
    
    {id: "search_field", 
        label: {"Czech": "Pole pro vyhledávání", "English": "Search field"}, 
        title: {"Czech": "Zobrazí pole pro vyhledávání.", "English": "Display search field."}},

    //{id: "reset_settings",                      /* neaktivní, nefunkční */
    //    label: {"Czech": "Reset nastavení", "English": "Reset settings"},
    //    title: {"Czech": "Resetuje nastavení při příštím startu mapy. Zkratka: SHIFT+Q", "English": "Reset map settings on next start. Shortcut: SHIFT+Q"}},

    {id: "bubble",
        label: {"Czech": "Názvy kešek", "English": "Cache labels"},
        title: {"Czech": "Zobrazí na mapě u všech kešek názvy. Lze dočasně vypnout nebo zapnout pomocí SHIFT. Zkratka: Y", "English": "Displays labels of all caches on the map. Can be temporarily (de)activated using SHIFT. Shortcut: Y"}},

    {id: "animation", //style: "display:none;", // při skrytí potřebujeme aby to existovalo, protože se toggleSettings odkazuje i na tento checkbox
        label: {"Czech": "Animace rodiny", "English": "Animate family"},
        title: {"Czech": "Po najetí myší na bod animuje všechny body patřící do rodiny. Zkratka: SHIFT + A (jako Animace)", "English": "Animates all points within a family. Shortcut: SHIFT + A (like Animation)"}},  
    
    {id: "circles", 
        label: {"Czech": "Kolizní kruhy 161m", "English": "Collision circles"}, 
        title: {"Czech": "Zobrazí kolizní kruhy 161 m u všech fyzických bodů (tradiční kešky, finální body a fyzické stage). Zkratka: R (jako Rádius)", "English": "Displays collision circles 161 m (0.1 mile) around all physical caches (Traditional Cache, Final Location, Physical Stage). Shortcut: R (like Radius)"}},
    
    {id: "spider", 
        label: {"Czech": "Spojnice od rodiče", "English": "Lines from parent"}, 
        title: {"Czech": "Po najetí na bod zobrazí spojnice od rodiče (hlavního bodu kešky) ke všem dětem (child waypointům). Zkratka: L (jako Linie)",  "English": "Displays lines from parent to children on hovering over any point in the family. Shortcut: L (like Line)"}},

    {id: "mark_userflagged_parents", className: "GSAK_Only", 
        label: {"Czech": "Zvýraznit označené (rodiče)", "English": "Highlight flagged (parents)"}, 
        title: {"Czech": "Zobrazí červený ovál kolem kešek, které jsou označené v GSAKu (včetně všech jejich dětí).", "English": "Highlights points flagged within GSAK (and all their children) with a red ellipse."}},
    
    {id: "mark_userflagged_children", className: "GSAK_Only", 
        label: {"Czech": "Zvýraznit označené (děti)", "English": "Highlight flagged (children)"}, 
        title: {"Czech": "Zobrazí žlutý ovál kolem označených Child Waypointů.", "English": "Hightlighs flagged Child Waypoints with a yellow ellipse."}},

    {id: "hide_flagged_parents", className: "GSAK_Only",
        label: {"Czech": "Skrýt označené (rodiče)", "English": "Hide flagged (parents)"},
        title: {"Czech": "Skryje všechny (v GSAKu) označené rodičovské body (včetně všech jejich dětí).", "English": "Hides all flagged parents (including all their Child Waypoints)."}},
    
    {id: "hide_flagged_children", className: "GSAK_Only",
        label: {"Czech": "Skrýt označené (děti)", "English": "Hide flagged (children)"},
        title: {"Czech": "Skryje všechny (v GSAKu) označené Child Waypointy.", "English": "Hides all flagged Child Waypoints."}}
  ];
  
  this.$super(button);
};

Sidebar.Menu.prototype.getHTML = function()
{
  var html = "";
  html += "<div class=\"sidebar\">";

  html += "  <div class=\"sidebar_checkboxes\">";  
  html += this.menu.map(Sidebar.addMenuEntries).join("");
  html += "  </div>";

  html += "</div>";
  
  return html;
}  

Sidebar.Menu.prototype.init = function()
{
  this.$super();
};

Sidebar.Menu.prototype.handleClicks = function(e, target)
{
  this.$super.apply(this, arguments);

  // get LI
  if (target.parentNode.tagName.toLowerCase() == "li")
    target = target.parentNode;
  
  // filter out non-LI elements or empty LI (separator)  
  if (target.tagName.toLowerCase() != "li" || !target.firstChild)
    return;
  
  if (target.id == "refresh_button")
  {
    window.location.href = "gsak://%FF/macro:silent/HTML_Keskomapa.gsk";
    //window.location.href = "gsak://%FF/macro:silent/HTML_Keskomapa\\GSAK\\Update_Database.gsk?refresh/" + cachecode;
    //window.location.href = "gsak://%FF/refreshbrowser";
    return;
  }
  
  if (target.id == "load_file_button")
  {
    loadFile("fileInput2", target);
    return;
  }    
};

//===========================================================================
//                               Sidebar.Layers
//===========================================================================   

Sidebar.Layers = JAK.ClassMaker.makeClass(
{
	NAME: "Sidebar.Layers",
	VERSION: "1.0",
  EXTEND: Sidebar
});

Sidebar.Layers.prototype.$constructor = function(button)
{
  // mapové vrstvy v menu
  // -- každá vrstva, např. "xxx" by měla mít položku ve window.transparentLayers + stejně pojmenované záznamy v settings.tl
  this.menu =
  [
    {id: "trail", 
        label: {"Czech": "Turistické trasy", "English": "Trail"}, 
        title: {"Czech": "", "English": ""}},

    {id: "bike", 
        label: {"Czech": "Cyklotrasy", "English": "Bike"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "hybrid", 
        label: {"Czech": "Hybrid", "English": "Hybrid"}, 
        title: {"Czech": "", "English": ""}},

    {id: "g_hybrid", 
        label: {"Czech": "Google Hybrid", "English": "Google Hybrid"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "relief", 
        label: {"Czech": "Reliéf (ČR / Evropa)", "English": "Relief (Europe)"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "relief2", 
        label: {"Czech": "Reliéf (ČR)", "English": "Relief (CZ)"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "g_terrain", 
        label: {"Czech": "Reliéf (svět)", "English": "Relief"}, 
        title: {"Czech": "", "English": ""}},

    {id: "ortofoto", 
        label: {"Czech": "Ortofoto", "English": "Ortophoto"}, 
        title: {"Czech": "", "English": ""}},

    {id: "g_ortofoto", 
        label: {"Czech": "Ortofoto", "English": "Ortophoto"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "g_streetview", 
        label: {"Czech": "Street View", "English": "Street View"}, 
        title: {"Czech": "Zobrazí vrstvu ukazující dostupnost Street View. Pro zobrazení Street View samotného použijte pravé tlačítko na požadovaném místě.", "English": "Displays Street View availability. For showing the actual Street View window, use context menu."}},

    {id: "pano", 
        label: {"Czech": "Seznam Panorama", "English": "Seznam Panorama"}, 
        title: {"Czech": "Zobrazí vrstvu ukazující dostupnost Seznam Panorama. Pro otevření Seznam Panorama samotného použijte pravé tlačítko na požadovaném místě.", "English": "Displays Seznam Panorama availability. For opening the actual Seznam Panorama window, use context menu."}},
        
    {id: "geocaches", 
        label: {"Czech": "Kešky", "English": "Geocaches"}, 
        title: {"Czech": "Kešky nejsou klikatelné!", "English": "Caches are not clickable!"}},          
        
    {id: "VERTICAL_SEPARATOR"},        

    {id: "vrstevnice", 
        label: {"Czech": "Vrstevnice", "English": "Contour Lines"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "katastr", 
        label: {"Czech": "Katastrální mapa", "English": "Cadaster map (CZ)"}, 
        title: {"Czech": "Pro zobrazení informací o objektu či parcele, klikněte na dané místo pravým tlačítkem a pak použijte volbu 'Otevřít stránku v katastru'.", "English": "Works only within the Czech Republic. For showing extended information about a place, use context menu."}},

    {id: "def_body_budov", 
        label: {"Czech": "Definiční body budov", "English": "Definition points of buildings (CZ)"}, 
        title: {"Czech": "", "English": "Czech Republic only"}},

    {id: "def_body_parcel", 
        label: {"Czech": "Definiční body parcel", "English": "Definition points of parcels (CZ)"}, 
        title: {"Czech": "", "English": "Czech Republic only"}},

    {id: "bodova_pole", 
        label: {"Czech": "Bodová pole", "English": "Geodetic points"}, 
        title: {"Czech": "", "English": "Czech Republic only"}},

    {id: "boundaries", 
        label: {"Czech": "Správní hranice", "English": "Boundaries"}, 
        title: {"Czech": "", "English": ""}},
        
    {id: "morf", 
        label: {"Czech": "Geomorfologické celky", "English": "Geomorfology"}, 
        title: {"Czech": "", "English": "CZ only"}},
  ];
  
  this.$super(button);
};

Sidebar.Layers.prototype.getHTML = function()
{
  var html = "";
  html += "<div class=\"sidebar\">";

  html += "  <div class=\"sidebar_checkboxes\">";  
  html += this.menu.map(Sidebar.addMenuEntries).join("");
  html += "  </div>";

  html += "</div>";
  
  return html;
}  

Sidebar.Layers.prototype.init = function()
{
  this.$super();
  
  // nastavíme tlačítka u transparentních vrstev
  for (transp in transparentLayers)
  {
    var val = settings.transparent_layers[settings.map][transp];
    var checkbox = document.getElementById(transp + "_checkbox");
    checkbox.parentNode.style.display = (typeof val === 'undefined') ? "none" : "";
    checkbox.checked = val;

    // pokud nemají vrstvy stejnou projekci a nelze je transformovat, tak tlačítko skryjeme
    if (!supportsTransform && !layersAreCompatible(settings.map, transparentLayers[transp]))
      checkbox.parentNode.style.display = "none";
  }
};

Sidebar.Layers.prototype.handleClicks = function(e, target)
{
  this.$super.apply(this, arguments);
};

//===========================================================================
//                               Sidebar.Filter
//===========================================================================

Sidebar.Filter = JAK.ClassMaker.makeClass(
{
	NAME: "Sidebar.Filter",
	VERSION: "1.0",
  EXTEND: Sidebar
});

Sidebar.Filter.prototype.$constructor = function(button)
{
  // mapové vrstvy v menu
  // -- každá vrstva, např. "xxx" by měla mít položku ve window.transparentLayers + stejně pojmenované záznamy v settings.tl
  this.menu =
  [
    {id: "hide_children",
        label: {"Czech": "Skrýt děti", "English": "Hide Children"},
        title: {"Czech": "Skryje všechny děti (Child Waypoints). Klávesová zkratka: C (jako Children)", "English": "Hides all Child Waypoints of all caches. Shortcut: C (like Children)"}},

    {id: "hide_parents",
        label: {"Czech": "Skrýt rodiče", "English": "Hide Parents"},
        title: {"Czech": "Skryje všechny rodiče (tedy hlavní body, děti nechá zobrazené). Klávesová zkratka: P (jako Parents)", "English": "Hides all parents (in other words - show only Child Waypoints). Shortcut: P (like Parents)"}},

    {id: "hide_all",
        label: {"Czech": "Skrýt vše", "English": "Hide All"},
        title: {"Czech": "Skryje úplně všechny keše a všechny jejich body. Pokud při skrytí máte myš na nějaké kešce, tato jediná a všechny její děti zůstanou zobrazeny. Klávesová zkratka: X (jako eXit)", "English": "Hides all caches and their children. When turning this on, if a mouse is over a cache, this one and only cache and its entire family stay displayed. Shortcut: X (like eXit)"}},

    {id: "hide_finals_family",
        label: {"Czech": "Zobrazit jen finálky", "English": "Show Finals only"},
        title: {"Czech": "U bodů, které mají Final Location nebo mají Corrected Coordinates, se zobrazí jen finálka a/nebo Corrected Coordinates.", "English": "Display only Final Location or Corrected Coordinates for each point when that point has either."}},

    {id: "private_hide", className: "GSAK_Only",
        label: {"Czech": "Speciální mód", "English": "Special mode"},
        title: {"Czech": "Speciální mód. Pokud je keška nalezena, tak to zobrazí jen ty děti, které jsou označené. Pokud keška není nalezena, tak to naopak zobrazí jen ty děti, které nejsou označené. Parkovací body to zobrazí jen pokud jsou explicitně označené (bez ohledu na stav nalezení). Klávesová zkratka: CTRL+ALT+SHIFT+P", "English": "Hides non-flagged children of found caches and flagged children of non-found caches. Parking waypoints are hidden irregardless of found status, unless explicitly flagged. Shortcut: CTRL+ALT+SHIFT+P"}},

    {id: "SEPARATOR"},

    {id: "hide_status_active",
        label: {"Czech": "Skrýt aktivní", "English": "Hide active"},
        title: {"Czech": "Skryje všechny aktivní kešky (tj. ty, které nejsou disablované nebo archivované)", "English": "Hides all active (ie. not disabled or archived) caches"}},

    {id: "hide_status_disabled",
        label: {"Czech": "Skrýt disablované", "English": "Hide disabled"},
        title: {"Czech": "Skryje všechny disablované kešky", "English": "Hides all disabled caches"}},
        
    {id: "hide_status_archived",
        label: {"Czech": "Skrýt archivované", "English": "Hide archived"},
        title: {"Czech": "Skryje všechny archivované kešky", "English": "Hides all archived caches"}},

    {id: "SEPARATOR"},        

    {id: "hide_status_found",
        label: {"Czech": "Skrýt nalezené", "English": "Hide found"},
        title: {"Czech": "Skryje všechny nalezené kešky", "English": "Hides all found caches"}},

    {id: "hide_status_not_found",
        label: {"Czech": "Skrýt nenalezené", "English": "Hide not found"},
        title: {"Czech": "Skryje všechny nenalezené kešky", "English": "Hides all caches, that are not found"}},

    {id: "hide_status_owned",
        label: {"Czech": "Skrýt vlastněné", "English": "Hide owned"},
        title: {"Czech": "Skryje všechny vlastněné kešky", "English": "Hides all owned caches"}},

    {id: "SEPARATOR"},

    {id: "hide_selected",
        label: {"Czech": "Skrýt vybrané", "English": "Hide selected"},
        title: {"Czech": "Skryje vybrané body (více o nich viz Nápověda na pravém tlačítku).", "English": "Hides all selected points (more about them in the Help)."}},
  ];
  
  this.$super(button);
};

Sidebar.Filter.prototype.getHTML = function()
{
  // =============== první část Filteru ===============

  var html = "";
  html += "<div class=\"sidebar\" id=\"filter_sidebar\" style=\"display: none\">";  
  html += "  <div class=\"sidebar_checkboxes\">";

  html += this.menu.map(Sidebar.addMenuEntries).join("");

  html += "  <\/div>";

  // =============== druhá část Filteru ===============
      
  translations["Cache Filter"] = {"Czech": "WP Filtr"},
  translations["_show_all"] = {"Czech": "Zobrazit vše", "English": "Show all"},
  translations["_hide_all"] = {"Czech": "Skrýt vše", "English": "Hide all"},

  html += "  <div class=\"sidebar_cache_filter\">";
  html += "    <div id=\"cache_filter_header\">";
  html += "      <div class=\"cache_filter_label\">" + tr("Cache Filter") + "<\/div>";
  html += "      <div id=\"cache_filter_buttons\">";
  html += "        <div class=\"button\" id=\"cache_filter_show_all\">" + tr("_show_all") + "<\/div>";
  html += "        <div class=\"button\" id=\"cache_filter_hide_all\">" + tr("_hide_all") + "<\/div>";
  html += "      <\/div>";
  html += "    <\/div>";
  html += "    <div id=\"cache_filter_parents\">";

  // přidání klikatelných ikonek kešek
  this.parentCacheTypes =
  [
    Cache.TRADITIONAL,    Cache.MULTI,          Cache.MYSTERY,     Cache.LETTERBOX,  Cache.EARTHCACHE,   Cache.WHERIGO,  "",  /* první řádek */
    Cache.WAYMARK,        Cache.WEBCAM,         Cache.VIRTUAL,     Cache.EVENT,      Cache.MEGAEVENT,    Cache.CITO,     "",  /* druhý řádek */
    Cache.LOCATIONLESS,   Cache.OTHER,          Cache.PROJECT_APE, Cache.BENCHMARK,  Cache.MAZE_EXHIBIT, Cache.LF_EVENT, "",  /* třetí řádek */
    Cache.GROUNDSPEAK_HQ, Cache.LF_CELEBRATION, Cache.BLOCK_PARTY, Cache.GIGA_EVENT, Cache.LAB_CACHE,                    ""   /* čtvrtý řádek */
  ] 

  this.parentCacheTypes.forEach(function(entry)
  {
    // nový řádek
    if (entry == "")
      html += "      <div class=\"clear_both\"><\/div>";
    // přidání kešky
    else
      html += '      <div class="cacheimg_parent cacheimg_' + Cache.css[entry] + '" data-cachetype=' + entry + '><\/div>';  
  })

  html += "    <\/div>";
  html += "    <div id=\"cache_filter_children\">";
  
  // přídání spodních ikonek child waypointů
  this.childCacheTypes =
  [
    Cache.FINAL_LOCATION,
    Cache.PARKING_AREA,
    Cache.VIRTUAL_STAGE,
    Cache.PHYSICAL_STAGE,
    Cache.TRAILHEAD,
    Cache.REFERENCE_POINT,
    Cache.CORRECTED
  ]
  
  this.childCacheTypes.forEach(function(entry)
  {
    html += '      <div class="cacheimg_child cacheimg_' + Cache.css[entry] + '" data-cachetype="' + entry + '"></div>';
  })  

  html += "    </div>";
  html += "  </div>";
  
  // =============== třetí část Filteru (Terrain) ===============
  translations["Difficulty"] = {"Czech": "Obtížnost"},
  
  html += "  <div class=sidebar_cache_filter id=stars_difficulty>";
  html += "  <div class=\"cache_filter_label\">" + tr("Difficulty") + "</div>";
  
  this.stars = ["1.0", "1.5", "2.0", "2.5", "3.0", "3.5", "4.0", "4.5", "5.0"];
  
  var generateStars = function()
  {
    var html = "    <div id=''>";

    // přidání klikatelných ikonek kešek
    this.stars.forEach(function(entry)
    {
      // nový řádek
      html += "      <div class=\"clear_both\"><\/div>";
      
     // přidání hvězd
      html += '      <div class="stars" title="' + entry + '" data-stars=' + entry + ' style=\'' + "" + '\'><\/div>';  
    })
  
    html += "    <\/div>";
    return html;

  }.bind(this);
  
  html += generateStars();

  html += "  <\/div>";
  
  // =============== čtvrtá část Filteru (Difficulty) ===============
  translations["Terrain"] = {"Czech": "Terén"},
  
  html += "  <div class=sidebar_cache_filter id=stars_terrain>";
  html += "  <div class=\"cache_filter_label\">" + tr("Terrain") + "</div>";
  html += generateStars();
  html += "  <\/div>";   

  //=============================
  
  html += "<\/div>";
  
  return html;
}  

Sidebar.Filter.prototype.init = function()
{
  this.$super();
  
  if (!window._caches_)
    return;

  /**** init cache filter with caches that are present ****/
  this.updateCacheTypesIcons();
  this._sc.push(this.map.getSignals().addListener(this, "caches-added caches-removed", "updateCacheTypesIcons"));

  this.updateDiffTerIcons("difficulty");
  this.updateDiffTerIcons("terrain");
  this._sc.push(this.map.getSignals().addListener(this, "caches-added caches-removed", function() { this.updateDiffTerIcons("difficulty") }.bind(this)));
  this._sc.push(this.map.getSignals().addListener(this, "caches-added caches-removed", function() { this.updateDiffTerIcons("terrain") }.bind(this)));
};

// iterátor přes všechny typy kešek ve filtru
// -- callback je volán s dvěma parametry - cacheType (např. Cache.WHERIGO) a node (tlačítko s cachetypem)
Sidebar.Filter.prototype.forEachCacheType = function(callback)
{
  // získání pole se všemi typy keší
  var cacheTypes = this.parentCacheTypes.concat(this.childCacheTypes); // zkombinování obou polí s typy cachí
  cacheTypes = cacheTypes.filter(function(p) { return (p != "") });    // odstranění oddělovačů řádků
  
  cacheTypes.forEach(function(cacheType)                               // projdeme všechny typy
  {
    var node = document.querySelector(".sidebar_cache_filter div[data-cachetype='" + cacheType + "']")
    callback.bind(this)(cacheType, node);

  }.bind(this));                             
}

Sidebar.Filter.prototype.disableCacheType = function(cacheType, node)
{
  // deaktivujeme tlačítko
  remove_class(node, "active");
  add_class(node, "inactive");

  // skryjeme kešky
  _caches_.forEach(function()
  {
    if (this.getParent().cacheType == cacheType)                // jsme rodič --> skryjeme celou rodinu
      add_class(this.marker.getDom(), "hiddenParentCacheType");
      
    else if (this.cacheType == cacheType)                       // jsme dítě --> skryjeme jen dítě
      add_class(this.marker.getDom(), "hiddenChildCacheType");      
  });  
}

Sidebar.Filter.prototype.enableCacheType = function(cacheType, node)
{
  // eaktivujeme tlačítko
  add_class(node, "active");
  remove_class(node, "inactive");

  // odkryjeme kešky
  _caches_.forEach(function()
  {
    if (this.getParent().cacheType == cacheType)
      remove_class(this.marker.getDom(), "hiddenParentCacheType");
      
    else if (this.cacheType == cacheType)
      remove_class(this.marker.getDom(), "hiddenChildCacheType");      
  });  
}

Sidebar.Filter.prototype.updateCacheTypesIcons = function()
{
  _caches_.disable();

  this.forEachCacheType(function(cacheType, node)
  {
    // spočteme kolik je kešek daného typu
    var total = _caches_.filter(function() { return this.cacheType == cacheType }).length;

    // přidáme titulek (typ kešky a v závorce počet); pokud je počet 0, pak počet neuvádíme 
    node.title = Cache.format[cacheType] + ((total > 0) ? " (" + total + ")" : "");

    if (total == 0)                               // pokud je kešek 0, tak tlačítko bude disablované (neklikatelné)
      var state = "disabled";
    else if (contains_class(node, "inactive"))    // pokud je typ vypnut (při updatu tak může být), tak ho necháme vyplý
    {                                             // -- navíc kešky znovu projedeme a vše deaktivujeme (to kdyby nějaké kešky v databázi přibyly
      var state = "inactive";
      this.disableCacheType(cacheType, node);
    }
    else
      var state = "active";                       // jinak tlačítko nastavíme do aktivního stavu
    
    remove_class(node, "disabled");               // radši nejdřív všechny třídy odstraníme (dobré při updatu, kdy třídy měníme)
    remove_class(node, "inactive");
    remove_class(node, "active");
    add_class(node, state);
  })
  
  _caches_.enable();
}
//********************************

// iterátor přes všechny obtížnosti, resp. terény
// -- callback je volán s dvěma parametry - cacheType (např. Cache.WHERIGO) a node (tlačítko s cachetypem)
Sidebar.Filter.prototype.forEachDiffTer = function(callback, property /* difficulty, terrain */)
{
  this.stars.forEach(function(stars)                               // projdeme všechny typy
  {
    var node = document.querySelector("#stars_" + property + " div[data-stars='" + stars + "']");
    callback.bind(this)(stars, node);

  }.bind(this));                             
}
 
Sidebar.Filter.prototype.disableDiffTer = function(stars, node, property /* difficulty, terrain */)
{
  // deaktivujeme tlačítko
  remove_class(node, "active");
  add_class(node, "inactive");

  // skryjeme kešky
  _caches_.forEach(function()
  {
    if (this.getParent()[property] == parseFloat(stars))
      add_class(this.marker.getDom(), (property == "terrain") ? "hiddenTerrain" : "hiddenDifficulty");
  });  
}
 
Sidebar.Filter.prototype.enableDiffTer = function(stars, node, property /* difficulty, terrain */)
{
  // eaktivujeme tlačítko
  add_class(node, "active");
  remove_class(node, "inactive");

  // odkryjeme kešky
  _caches_.forEach(function()
  {
    if (this.getParent()[property] == parseFloat(stars))
      remove_class(this.marker.getDom(), (property == "terrain") ? "hiddenTerrain" : "hiddenDifficulty");
  });  
}

Sidebar.Filter.prototype.updateDiffTerIcons = function(property /* difficulty, terrain */)
{
  _caches_.disable();

  this.forEachDiffTer(function(stars, node)
  {
    // spočteme kolik je kešek daného typu
    var total = _caches_.filter(function() { return this[property] == parseFloat(stars) }).length;

    // přidáme titulek (typ kešky a v závorce počet); pokud je počet 0, pak počet neuvádíme 
    node.title = stars + ((total > 0) ? " (" + total + ")" : "");

    if (total == 0)                               // pokud je kešek 0, tak tlačítko bude disablované (neklikatelné)
      var state = "disabled";
    else if (contains_class(node, "inactive"))    // pokud je typ vypnut (při updatu tak může být), tak ho necháme vyplý
    {                                             // -- navíc kešky znovu projedeme a vše deaktivujeme (to kdyby nějaké kešky v databázi přibyly
      var state = "inactive";
      this.disableDiffTer(stars, node, property);
    }
    else
      var state = "active";                       // jinak tlačítko nastavíme do aktivního stavu

    remove_class(node, "disabled");               // radši nejdřív všechny třídy odstraníme (dobré při updatu, kdy třídy měníme)
    remove_class(node, "inactive");
    remove_class(node, "active");
    add_class(node, state);
  }, property)
  
  _caches_.enable();  
}

//********************************
Sidebar.Filter.prototype.handleClicks = function(e, target)
{
  // --- handle cache filter ---

  // handle click on cache icon
  var cachetype = target.getAttribute("data-cachetype");  
 
  if (cachetype)
  {
    if (contains_class(target, "active"))           // aktivní --> deaktivujeme
      this.disableCacheType(cachetype, target);
    else if (contains_class(target, "inactive"))    // neaktivní --> aktivujeme
      this.enableCacheType(cachetype, target);   
    else                                            // přítomen
      return;
  }
  
  // handle show/hide all buttons
  if (target.id == "cache_filter_show_all")
  {
    this.forEachCacheType(this.enableCacheType);
  }
  
  if (target.id == "cache_filter_hide_all")
  {
    this.forEachCacheType(this.disableCacheType);
  }

  // --- handle difficulty and terrain --
  var stars = target.getAttribute("data-stars");

  if (stars)
  {
    var property = EventUtil.isSubnode(target, JAK.gel("stars_terrain")) ? "terrain" : "difficulty";
  
    if (contains_class(target, "active"))           // aktivní --> deaktivujeme
      this.disableDiffTer(stars, target, property);
    else if (contains_class(target, "inactive"))    // neaktivní --> aktivujeme
      this.enableDiffTer(stars, target, property);   
    else                                            // není přítomno
      return;
  }

  // --- handle left menu --  
  this.$super.apply(this, arguments);
  
  if (window.m) m.getSignals().makeEvent("toggle-settings", this, {});
};  

//===========================================================================
//                               init...
//===========================================================================

window.sidebarLoader = function(e, target)
{
  // vytvoříme všechny sidebary
  var btnToSidebar = 
  {
    "menu_sidebar_button": new Sidebar.Menu(sidebar_button),
    "layers_sidebar_button": new Sidebar.Layers(layers_button),
    "filter_sidebar_button": new Sidebar.Filter(filter_button)
  };
  
  // spustíme sidebar podle tlačítka, na které jsme klikli
  var btnId = EventUtil.getTarget(e).id;
  
  if (btnId in btnToSidebar)
    btnToSidebar[btnId].show();
}
